<?php
define('ROOT_PATH', __DIR__ . DIRECTORY_SEPARATOR);
require ROOT_PATH.'vendor/autoload.php';
$uriPath = parseUrl();
require ROOT_PATH.'package/core/function/blocks.php';
header('Content-Type: text/html; charset=utf-8');
session_start();
if(isset($_REQUEST['blockId'])) unset($_REQUEST['blockId']);
$host = explode(':',$_SERVER['HTTP_HOST']);
$_SERVER['HTTP_HOST'] = $host[0];
define('DOMAIN', $host[0]);
$domain = main::mapper('domain_core')->getDomain(DOMAIN, $uriPath);
if (!empty($domain['datas']['fontFams'])) $GLOBALS['fontFamily'] = array_merge($domain['datas']['fontFams'],$GLOBALS['fontFamily']);
login();
if (!empty($_SERVER['HTTP_REFERER']))
{
    setcookie("reftail3", $_SERVER['HTTP_REFERER'], time() + 3*24*3600, BASE_DIR.'/', DOMAIN);
}
if(isset($_GET['pr'])) {
    if (!isset($_COOKIE['prCode']) || $_COOKIE['prCode'] != $_GET['pr']) main::mapper('user_ACL')->setHistory($_GET['pr']);
    setcookie("prCode", $_GET['pr'], time() + 1095*24*3600, BASE_DIR.'/', DOMAIN);
}
if (isset($_GET['utm_source']) || isset($_GET['utm_medium']) || isset($_GET['utm_campaign']) || isset($_GET['utm_term']) || isset($_GET['utm_content'])) {
    $_COOKIE['utm'] = '';
    if (isset($_GET['utm_source'])) {
        $_COOKIE['utm'] .= 'utm_source = '.mb_convert_encoding($_GET['utm_source'], "UTF-8", detect_encoding($_GET['utm_source'])).'; ';
        unset($_GET['utm_source']);
    }
    if (isset($_GET['utm_medium'])) {
        $_COOKIE['utm'] .= 'utm_medium = '.mb_convert_encoding($_GET['utm_medium'], "UTF-8", detect_encoding($_GET['utm_medium'])).'; ';
        unset($_GET['utm_medium']);
    }
    if (isset($_GET['utm_campaign'])) {
        $_COOKIE['utm'] .= 'utm_campaign = '.mb_convert_encoding($_GET['utm_campaign'], "UTF-8", detect_encoding($_GET['utm_campaign'])).'; ';
        unset($_GET['utm_campaign']);
    }
    if (isset($_GET['utm_term'])) {
        $_COOKIE['utm'] .= 'utm_term = '.mb_convert_encoding($_GET['utm_term'], "UTF-8", detect_encoding($_GET['utm_term'])).'; ';
        unset($_GET['utm_term']);
    }
    if (isset($_GET['utm_content'])) {
        $_COOKIE['utm'] .= 'utm_content = '.mb_convert_encoding($_GET['utm_content'], "UTF-8", detect_encoding($_GET['utm_content'])).'; ';
        unset($_GET['utm_content']);
    }
    setcookie("utm", $_COOKIE['utm'], time() + 30*24*3600, BASE_DIR.'/', DOMAIN);
}
$detect = new MobileDetect;
define('isMobile', $detect->isMobile(true));
define('isTablet', $detect->isTablet());
define('isSkipVideoBG', (isMobile && ($detect->isOpera() || strpos($detect->getUserAgent(), 'MiuiBrowser'))));
define('isSafari', $detect->isSafari());
$data = null;
$pcm = main::mapper('page_core');
if ($domain) $data = $pcm->findBySimple($uriPath, 0, $domain['domainId']);
if ($data) $robots = $data['robots'];
if ($data && $data['perm'] != 1)
{
    if (main::$user['isGuest'])
    {
    	if ($data['perm'] == 2)
        {
            formLogin();
            $robots = null;
        }
    	elseif ($data['perm'] != 1 && $data['perm'] != 7)
        {
            formLogin();
            $robots = null;
        }
    }
    else if ($data['perm'] != 2 && !main::$user['isAdmin'] && !in_array($data['perm'], main::$user['groups']))
    {
        $data = false;
    }
}
$err404 = false;
if (!$data && Page404Id != 0) {
	$robots = null;
	$data = $pcm->findBySimple('',Page404Id);
	if ($domain['domainId'] != $data['domainId']) {
		$domain = main::mapper('domain_core')->findById($data['domainId']);
		if (!empty($domain['datas']['fontFams'])) $GLOBALS['fontFamily'] = array_merge($domain['datas']['fontFams'],$GLOBALS['fontFamily']);
	}
	header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found', true, 404);
    header("Status: 404 Not Found");
    $err404 = true;
}
if (!main::$user['isAdmin'] && isMobile && (!empty($data['mobileId']) || !empty($data['tabletId']))) {
    if ($data) $root = $data;
    $mob = false;
    if (isTablet) {
    	if (!empty($data['tabletId'])) {
    		$mob = $pcm->findById($data['tabletId']);
    	}
    } elseif (!empty($data['mobileId'])) {
	   $mob = $pcm->findById($data['mobileId']);
    }
    if ($mob) {
        $pcm->p[$mob['id']]['robots'] = $mob['robots'] = $data['robots'];
    	$data = $mob;
    	if ($data['parentId']) $GLOBALS['selectIds'][$data['parentId']] = 1;
	    $pcm->p[$data['id']]['parentId'] = $data['parentId'] = $root['parentId'];
        $pcm->p[$data['id']]['path'] = $data['path'] = $root['path'];
    }
}
if ($data) {
	$data = $pcm->findById($data['id']);
	if (!empty($robots)) $pcm->p[$data['id']]['robots'] = $robots;
}
if (!$data) {
	if ($uriPath !== '/') {
		header('location: '.BASE_DIR.'/');
        Common\Lib\DB::connection()->close();
        exit;
	} else {
		header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found', true, 404);
		header("Status: 404 Not Found");
        Common\Lib\DB::connection()->close();
		exit;
	}
}
if ($data['langId'] == DEFAULT_LANG_ID) {
    define('CUR_LANG_ID', DEFAULT_LANG_ID);
    define('CUR_LANG', DEFAULT_LANG);
} elseif ($lang = getLangById($data['langId'])) {
    define('CUR_LANG_ID', $data['langId']);
    define('CUR_LANG', $lang);
} else {
    define('CUR_LANG_ID', DEFAULT_LANG_ID);
    define('CUR_LANG', DEFAULT_LANG);
}
if (!main::$user['id']) main::$user['langId'] = CUR_LANG_ID;
if (file_exists(ROOT_PATH.'constants/'.CUR_LANG.'.php')) include(ROOT_PATH.'constants/'.CUR_LANG.'.php');
else include(ROOT_PATH.'constants/en.php');
$GLOBALS['selectIds'][$data['id']] = 1;
if ($data['parentId']) {
    $GLOBALS['selectIds'][$data['parentId']] = 1;
    $pnode = $pcm->findNodeById($data['parentId']);
    if (!empty($pnode['parentId'])) $GLOBALS['selectIds'][$pnode['parentId']] = 1;
}
$_REQUEST['id'] = $data['id'];
$ifmod = '';
if (!empty($_ENV['HTTP_IF_MODIFIED_SINCE'])) $ifmod = $_ENV['HTTP_IF_MODIFIED_SINCE'];
elseif (!empty($_SERVER['HTTP_IF_MODIFIED_SINCE'])) $ifmod = $_SERVER['HTTP_IF_MODIFIED_SINCE'];
$modified = substr(gmdate('r', $data['dateCustom']), 0, -6).' GMT';
header('Last-Modified: '.$modified, true);
if ($ifmod == $modified && !$err404) {
    header($_SERVER['SERVER_PROTOCOL'].' 304 Not Modified');
    Common\Lib\DB::connection()->close();
    exit;
}

include(ROOT_PATH.'skinss/template/page.php');
Common\Lib\DB::connection()->close();