<?php
use Common\Lib\DB;

class group_ACL_mapper
{
    private $con;
	public $groups = array();

    public function __construct()
    {
        $this->con = DB::connection();
    }

    public function findByParentId($id) {
        $return = array();
        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'acl_group WHERE parentId = '.(int)$id.' ORDER BY sequence DESC');
        while ($result = $r->fetch_assoc()) {
	        if (empty($result['baseName'])) {
	          if ($result['id'] == 7) $result['baseName'] = Guests;
	          elseif ($result['id'] == 3) $result['baseName'] = Clients;
	          elseif ($result['id'] == 4) $result['baseName'] = Admins;
	          elseif ($result['id'] == 5) $result['baseName'] = Potential_customers;
	          elseif ($result['id'] == 6) $result['baseName'] = Partners;
	        }
	        $return[] = $result;
        }
        return $return;

    }

    public function countItems($id) {
        $r = $this->con->query('SELECT count(*) as count FROM '.DB_PREFIX.'acl_group WHERE parentId = '.(int)$id);
        $result = $r->fetch_assoc();
        return (int)$result['count'];
    }

    public function goupMap($perm = 0) {
    	if ($perm) {
            $return['0'][] = array('id' => 1, 'baseName' => PublicOn, 'parentId' => 0);
            $return['0'][] = array('id' => 2, 'baseName' => Registred, 'parentId' => 0);
    	} else {
    		$return = array();
    	}

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'acl_group ORDER BY sequence DESC');
        while ($result = $r->fetch_assoc()) {
            if (empty($result['baseName'])) {
              if ($result['id'] == 7) $result['baseName'] = Guests;
              elseif ($result['id'] == 3) $result['baseName'] = Clients;
              elseif ($result['id'] == 4) $result['baseName'] = Admins;
              elseif ($result['id'] == 5) $result['baseName'] = Potential_customers;
              elseif ($result['id'] == 6) $result['baseName'] = Partners;
            }
        	$this->groups[$result['id']] = $return[$result['parentId']][$result['id']] = $result;
        }

        return $return;

    }

    public function findMultiById($id) {

    	if (isSubmit()) return $_REQUEST;
        if (isset($_REQUEST['create'])) return array('parentId' => $_REQUEST['id']);

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'acl_group WHERE id = '.(int)$id);
        $data = $r->fetch_assoc();
	    if ($data && empty($data['baseName'])) {
		  if ($data['id'] == 7) $data['baseName'] = Guests;
		  elseif ($data['id'] == 3) $data['baseName'] = Clients;
		  elseif ($data['id'] == 4) $data['baseName'] = Admins;
		  elseif ($data['id'] == 5) $data['baseName'] = Potential_customers;
		  elseif ($data['id'] == 6) $data['baseName'] = Partners;
	    }
        return $data;
    }

    public function findById($id) {

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'acl_group WHERE id = '.(int)$id);
        $data = $r->fetch_assoc();
        if ($data && empty($data['baseName'])) {
          if ($data['id'] == 7) $data['baseName'] = Guests;
          elseif ($data['id'] == 3) $data['baseName'] = Clients;
          elseif ($data['id'] == 4) $data['baseName'] = Admins;
          elseif ($data['id'] == 5) $data['baseName'] = Potential_customers;
          elseif ($data['id'] == 6) $data['baseName'] = Partners;
        }
        return $data;

    }

    public function update($data) {
        if (isset($data['create'])) $data['id'] = $this->insert($data['id']);
        else {
        	$isPartners = $this->isPartnerGroup(array($data['id']));
        	if (isset($data['isPartners']) && !$isPartners) {
                $this->con->query('UPDATE '.DB_PREFIX.'acl_user u, '.DB_PREFIX.'acl_ug ug SET u.isPartner = 1, u.partnerId = 0 WHERE u.isPartner = 0 AND ug.userId = u.id AND ug.groupId = '.(int)$data['id']);
        	} elseif (!isset($data['isPartners']) && $isPartners) {
        		$groupIds = $this->getPartnerGroups($data['id']);
        		if (!$groupIds) {
		           $this->con->query('UPDATE '.DB_PREFIX.'acl_user SET isPartner = 0, partnerId = 0 WHERE isPartner = 1');
        		} else {
                   $this->con->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.DB_PREFIX.'acl_user_tmp ENGINE = MEMORY AS SELECT userId FROM '.DB_PREFIX.'acl_ug WHERE groupId = '.(int)$data['id']);
                   $this->con->query('DELETE FROM '.DB_PREFIX.'acl_user_tmp USING '.DB_PREFIX.'acl_user_tmp, '.DB_PREFIX.'acl_ug WHERE '.DB_PREFIX.'acl_user_tmp.userId='.DB_PREFIX.'acl_ug.userId AND '.DB_PREFIX.'acl_ug.groupId IN ('.implode(',',$groupIds).')');
                   $this->con->query('UPDATE '.DB_PREFIX.'acl_user u, '.DB_PREFIX.'acl_user_tmp ut SET u.isPartner = 0, u.partnerId = 0 WHERE u.id = ut.userId');
        		}

        	}
        }
        $set = '';
        if (isset($data['parentId'])) $set = ', parentId = '.$data['parentId'];
        if ($data['id'] == 7 && $data['baseName'] == Guests) {
	       $data['baseName'] = '';
	    } elseif ($data['id'] == 3 && $data['baseName'] == Clients) {
    	   $data['baseName'] = '';
	    } elseif ($data['id'] == 4 && $data['baseName'] == Admins) {
    	   $data['baseName'] = '';
	    } elseif ($data['id'] == 5 && $data['baseName'] == Potential_customers) {
    	   $data['baseName'] = '';
	    } elseif ($data['id'] == 6 && $data['baseName'] == Partners) {
    	   $data['baseName'] = '';
	    }
        $this->con->query('UPDATE '.DB_PREFIX.'acl_group
                             SET baseName = "'.$this->con->real_escape_string($data['baseName']).'",
                                 isPartners = '.(isset($data['isPartners']) ? 1 : 0).'
                                 '.$set.'
                             WHERE id = '.$data['id']);
        return $data['id'];
    }

    public function insert($parentId) {
        $this->con->query('INSERT INTO '.DB_PREFIX.'acl_group (parentId, sequence) VALUES ('.$parentId.', '.$this->nextSeq($parentId).')');
        return $this->con->insert_id;
    }

    public function nextSeq($parentId) {
        $r = $this->con->query('SELECT max(sequence) as max FROM '.DB_PREFIX.'acl_group WHERE parentId = '.(int)$parentId);
        $data = $r->fetch_assoc();
        return (int)$data['max'] + 1;
    }

    public function isPartnerGroup($groups) {
        if (empty($groups)) return false;
        $r = $this->con->query('SELECT 1 FROM '.DB_PREFIX.'acl_group WHERE isPartners = 1 AND id IN ('.implode(',',$groups).') LIMIT 1');
        if ($data = $r->fetch_assoc()) return true;
        return false;
    }

    public function getPartnerGroups($groupId) {
    	$return = array();
        $r = $this->con->query('SELECT id FROM '.DB_PREFIX.'acl_group WHERE isPartners = 1 AND id <> '.(int)$groupId);
        while ($result = $r->fetch_assoc()) {
            $return[] = $result['id'];
        }
        if (!empty($return)) return $return;
        return false;
    }

    public function delete($id) {
        $id = (int) $id;
        if ($this->isPartnerGroup(array($id))) {
            $groupIds = $this->getPartnerGroups($id);
            if (!$groupIds) {
                $this->con->query('UPDATE '.DB_PREFIX.'acl_user SET isPartner = 0, partnerId = 0 WHERE isPartner = 1');
            } else {
                $this->con->query('CREATE TEMPORARY TABLE IF NOT EXISTS '.DB_PREFIX.'acl_user_tmp ENGINE = MEMORY AS SELECT userId FROM '.DB_PREFIX.'acl_ug WHERE groupId = '.$id);
                $this->con->query('DELETE FROM '.DB_PREFIX.'acl_user_tmp USING '.DB_PREFIX.'acl_user_tmp, '.DB_PREFIX.'acl_ug WHERE '.DB_PREFIX.'acl_user_tmp.userId='.DB_PREFIX.'acl_ug.userId AND '.DB_PREFIX.'acl_ug.groupId IN ('.implode(',',$groupIds).')');
                $this->con->query('UPDATE '.DB_PREFIX.'acl_user u, '.DB_PREFIX.'acl_user_tmp ut SET u.isPartner = 0, u.partnerId = 0 WHERE u.id = ut.userId');
            }
        }
        $this->con->query('UPDATE '.DB_PREFIX.'handler SET userGroupId = 0 WHERE userGroupId = '.$id);
        $this->con->query('DELETE FROM '.DB_PREFIX.'acl_group WHERE id ='.$id);
        main::mapper('user_ACL')->delete(false, $id);
    }

}