<?php
//ini_set('session.use_only_cookies', 1);
//ini_set('session.cookie_httponly', 1);
/*if (getProtocol() === 'https')
{
    ini_set('session.cookie_secure', 1);
}*/
function trans($key)
{
    $events = [
        'event.submit' => orderNew,
        'event.work' => inWork,
        'event.paid' => orderPayd,
        'event.delivery' => orderDelivery,
        'event.done' => orderDone,
        'event.cancel' => cancelled,
        'event.error' => error2,
        'event.delete' => bDel
    ];

    return isset($events[$key]) ? $events[$key] : '';
}
function includeLangConst($langId) {
    if ($langId == DEFAULT_LANG_ID) {
        define('CUR_LANG_ID', DEFAULT_LANG_ID);
        define('CUR_LANG', DEFAULT_LANG);
    } elseif ($lang = getLangById($langId)) {
        define('CUR_LANG_ID', $langId);
        define('CUR_LANG', $lang);
    } else {
        define('CUR_LANG_ID', DEFAULT_LANG_ID);
        define('CUR_LANG', DEFAULT_LANG);
    }
    if (file_exists(ROOT_PATH.'constants/'.CUR_LANG.'.php')) include(ROOT_PATH.'constants/'.CUR_LANG.'.php');
    else include(ROOT_PATH.'constants/en.php');
}
function xmlParse($string){
    return  str_replace("\n","",
            str_replace('"','&quot;',
            str_replace("'", '&apos;',
            str_replace('>','&gt;',
            str_replace("<", '&lt;',
            str_replace("&", '&amp;',
            str_replace("\r", "",
             $string)))))));
}
function xmlParse2($string){
    return  str_replace('"','&quot;',
            str_replace("'", '&apos;',
            str_replace('>','&gt;',
            str_replace("<", '&lt;',
            str_replace("&", '&amp;',
             $string)))));
}
function escape($str) {
	return htmlentities($str, ENT_QUOTES, 'UTF-8');
}
function isAni($filename) {
    if(!($fh = @fopen($filename, 'rb')))
        return false;
    $count = 0;
    while(!feof($fh) && $count < 2) {
        $chunk = fread($fh, 1024 * 100);
        $count += preg_match_all('#\x00\x21\xF9\x04.{4}\x00(\x2C|\x21)#s', $chunk, $matches);
   }
    fclose($fh);
    return $count > 1;
}
function escapeMeta($str) {
    return  str_replace('"','&quot;',
            str_replace('>','&gt;',
            str_replace("<", '&lt;',
            str_replace("&", '&amp;',
             $str))));
}

function getProtocol()
{
    if(!empty($_SERVER['HTTP_X_FORWARDED_PROTOCOL']))
    {
        return $_SERVER['HTTP_X_FORWARDED_PROTOCOL'];
    }
    else if(!empty($_SERVER['HTTP_X_FORWARDED_PROTO']))
    {
        return $_SERVER['HTTP_X_FORWARDED_PROTO'];
    }
    else if(!empty($_SERVER['HTTP_SCHEME']))
    {
        return $_SERVER['HTTP_SCHEME'];
    }
    else if ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || 443 == $_SERVER['SERVER_PORT'])
    {
        return 'https';
    }
	else if (isset($_SERVER['HTTP_X_HTTPS']) && ($_SERVER['HTTP_X_HTTPS'] === 'on' || $_SERVER['HTTP_X_HTTPS'] == '1'))
    {
        return 'https';
    }
	else if (isset($_SERVER['REDIRECT_HTTPS']) && $_SERVER['REDIRECT_HTTPS'] == 'on')
    {
        return 'https';
    }

    return 'http';
}

function parseUrl()
{
    $redirect = '';
    $uri = parse_url($_SERVER['REQUEST_URI']);

    if (!isset($uri['path']))
    {
        $uri['path'] = '/';
    }

    if (BASE_DIR !== '')
    {
        $uri['path'] = substr($uri['path'], strlen(BASE_DIR));
    }

    if ($uri['path'] == '/favicon.ico')
    {
        exit;
    }
    else if ($uri['path'] == '/robots.txt' || $uri['path'] == '/sitemap.xml')
    {
        include('.'.$uri['path'].'.php');
        exit;
    }
    else if (isset($uri['query']) && $uri['query'] === '')
    {
        $redirect = BASE_DIR . $uri['path'];
    }
    else if ($uri['path'] == '/index.php')
    {
        $redirect = BASE_DIR . '/';
    }

    if ($uri['path'] !== '/' && $uri['path'] !== rtrim($uri['path'], '/'))
    {
        $uri['path'] = rtrim($uri['path'], '/');
        if ($uri['path'] === '')
        {
            $uri['path'] = '/';
        }
        $redirect = BASE_DIR . $uri['path'] . (!empty($uri['query']) ? '?'.$uri['query'] : '');
    }

    $fixHost = false;
    if (substr($_SERVER['HTTP_HOST'], 0, 4) === 'www.')
    {
        $fixHost = true;
        $_SERVER['HTTP_HOST'] = substr($_SERVER['HTTP_HOST'], 4);
    }

    if ($fixHost || (siteProtocol === 'https' && getProtocol() != 'https'))
    {
        $redirect = siteProtocol.'://'.$_SERVER['HTTP_HOST'] . BASE_DIR . $uri['path'] . (!empty($uri['query']) ? '?'.$uri['query'] : '');
    }

    if ($redirect)
    {
        header("HTTP/1.1 301 Moved Permanently");
        header('location: ' . $redirect);
        exit;
    }

    return $uri['path'];
}

function getimagesizenew($file)
{
    $return = getimagesize($file);
    if (!$return)
    {
        $return = [0, 0, 0];
        $ext = substr(strrchr($file, '.'), 1);
        if ($ext == 'svg')
        {
            $xml = simplexml_load_file($file);
            if ($xml)
            {
                $xmlattr = $xml->attributes();
                if ($xmlattr)
                {
                    if (isset($xmlattr->width) && isset($xmlattr->height))
                    {
                        $return[0] = (int) $xmlattr->width;
                        $return[1] = (int) $xmlattr->height;
                        $return[2] = 99;
                    }
                    else if (isset($xmlattr->viewBox))
                    {
                        $viewBox = explode(" ", $xmlattr->viewBox);
                        if (isset($viewBox[2]))
                        {
                            $return[0] = (int) $viewBox[2];
                        }
                        if (isset($viewBox[3]))
                        {
                            $return[1] = (int) $viewBox[3];
                        }
                        $return[2] = 99;
                    }
                }
            }
        }
    }

    return $return;
}

function escapeHtml($str) {
	return htmlentities(strip_tags($str), ENT_QUOTES, 'UTF-8');
}

function escapeJS($str) {
	return str_replace(array('\\', "\n", "\r", "\t", "'", '"'), array('\\\\', '\\n','\\r','\\t',"\\'", '\\"'), $str);
}

function preg_escape_back($str, $escs = '', $escr = '') {
	$sea = array('\\', '$');
	$rep = array('\\\\\\\\', '\\$');
	if (!empty($escs)) {
		$sea[] = $escs;
		$rep[] = $escr;
	}
    return str_replace($sea, $rep, $str);
}

function dateTimeConvert($date = '') {
    if (!intval($date)) return '';
    return date('j F Y H:i:s', $date);
}

function fileSizeH($size) {
    $i=0;
    $iec = array("B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB");
    while (($size/1024)>1) {
        $size=$size/1024;
        $i++;
    }
    return ($size ? substr($size, 0, strpos($size,'.')+3) : '0' ) . $iec[$i];
}

function isSubmit() {
    return isset($_REQUEST['submitted']);
}

function redirect($path = './') {
    header('location: '.$path);exit;
}

function createSelectMap($list, $countDomain, $curent, $padd, $selectedId = 1, $ignoreId = 0, $width = '920', $ifSelectedId = 1) {
    $return = [];
    if (!$curent && $countDomain > 1)
    {
        $return[] = '<optgroup label="'.$list['name'].'">';
    }

    if (empty($list['pages'][$curent])) return [];

    foreach($list['pages'][$curent] AS $item)
    {
    	if ($ifSelectedId && empty($selectedId))
        {
            $selectedId = $item['id'];
        }

        if ($ignoreId == $item['id'])
        {
            continue;
        }

        $return[] = '<option value="'.$item['id'].'"'.($selectedId == $item['id'] ? ' SELECTED' : '').' style="width:'.$width.'px">'.$padd.$item['baseName'].'&nbsp;&nbsp;</option>';

        if (isset($list['pages'][$item['id']]))
        {
            $return = array_merge($return, createSelectMap($list, $countDomain, $item['id'], $padd.'&nbsp;&nbsp;&nbsp;&nbsp;', $selectedId, $ignoreId, $width, $ifSelectedId));
        }
    }

    if (!$curent && $countDomain > 1)
    {
        $return[] = '</optgroup>';
    }

    return $return;
}

function createSelectACLMap($list, $curent, $padd, $selectedId = 0) {
    $return = [];
    if (empty($list[$curent])) return [];
    foreach($list[$curent] AS $item) {
        $return[] = '<option value="'.$item['id'].'"'.($selectedId == $item['id'] ? ' SELECTED' : '').'>'.$padd.$item['baseName'].'&nbsp;&nbsp;</option>';
        if (isset($list[$item['id']])) $return = array_merge($return, createSelectACLMap($list, $item['id'], $padd.'&nbsp;&nbsp;&nbsp;&nbsp;', $selectedId));
    }
    return $return;
}

function view($tpl, $addData = []) {
    extract($addData);
    include(ROOT_PATH.'skinss/template/'.$tpl);
}

function renderTpl($tpl, $addData = []) {
	ob_start();
    extract($addData);
	include(ROOT_PATH.'skinss/template/'.$tpl);
    $content = ob_get_contents();
    ob_get_clean();
    return $content;
}

function getHeaders() {
    if(!empty($GLOBALS['headers'])) foreach ($GLOBALS['headers'] as $key=>$value) if (!is_array($value)) print $value; else print implode('',$value);
}

function imageCrop3($path, $dst, $cropWidth, $cropHeight, $cropLeft, $cropTop, $bwidth, $bheight) {

    list ($wReal, $hReal, $tReal) = getimagesizenew($path);
    if ($tReal == 99 || ($tReal === 1 && isAni($path))) {
    	copy($path, $dst);
    	return;
    }

    switch ($tReal) {
        case 1: $img=imagecreatefromgif($path);break;
        case 2: $img=imagecreatefromjpeg($path);break;
        case 3: $img=imagecreatefrompng($path);break;
        case 18: $img=imagecreatefromwebp($path);break;
        default: return false;
    }

    $thumb=imagecreatetruecolor($bwidth, $bheight);
    if ($tReal == 3 || $tReal == 18) {
        imagealphablending($thumb, false);
        imagesavealpha($thumb, true);
    }
    if ($tReal == 1) {
        $ct = imagecolortransparent($img);
        if($ct >= 0 && $ct < imagecolorstotal($img)) {
            $color_tran = imagecolorsforindex($img, $ct);
            $ct2 = imagecolorexact($thumb, $color_tran['red'], $color_tran['green'], $color_tran['blue']);
            imagefill($thumb,0,0,$ct2);
            imagecolortransparent($thumb, $ct2);
        }
    }
    imagecopyresampled($thumb, $img, 0, 0, $cropLeft, $cropTop, $bwidth, $bheight, $cropWidth, $cropHeight);
    switch ($tReal) {
        case 1: imagegif($thumb, $dst);break;
        case 2: imagejpeg($thumb, $dst, 100);break;
        case 3: imagepng($thumb, $dst);break;
        case 18: imagewebp($thumb, $dst);break;
        default: return false;
    }
    imagedestroy($thumb);
    imagedestroy($img);
}

function login() {

    if (!empty($_SESSION['user']))
    {
        if (isset($_SESSION['user']['timeLogin']) && $_SESSION['user']['timeLogin'] > time()) {
            main::$user = $_SESSION['user'];
            return;
        }

        loginByPass($_SESSION['user']['login'], $_SESSION['user']['hPassword'], 'h', $_SESSION['user']['id']);
    }
    elseif (!empty($_COOKIE['login']) && !empty($_COOKIE['passwd']))
    {
        loginByPass($_COOKIE['login'], $_COOKIE['passwd']);
    }

}

function loginByPass($login, $password, $typePass = 'h', $id = 0) {
    if (isset($_COOKIE['login'])) {
        setcookie('login', '', time() - 3600, BASE_DIR.'/', $_SERVER['HTTP_HOST']);
        setcookie('passwd', '', time() - 3600, BASE_DIR.'/', $_SERVER['HTTP_HOST']);
    }
    if (isset($_SESSION['user'])) unset($_SESSION['user']);
    if (empty($id) && (empty($password) || empty($login))) return false;
    if ($id) {
        $data = findUserByIdAndPassword($id, $password, $typePass);
    } else {
        $data = findByLoginAndPassword($login, $password, $typePass);
    }

    if (empty($data)) return false;

    $_SESSION['user'] = main::$user = $data;
    $_SESSION['user']['login'] = $login;
    $_SESSION['user']['timeLogin'] = mktime(date('G') + 1, date('i'), 0, date('m'), date('d'), date('Y'));
    setcookie('login', $login, time() + 12*30*24*3600, BASE_DIR.'/', $_SERVER['HTTP_HOST']);
    setcookie('passwd', $data['hPassword'], time() + 12*30*24*3600, BASE_DIR.'/', $_SERVER['HTTP_HOST']);
    return $data;
}

function findByLoginAndPassword($login, $password, $typePass = 'h') {
    $login = trim($login);
    if (empty($login)) return false;
    $where = '';
    $con = Common\Lib\DB::connection();

    if (strpos($login,'@')) {
        $where = ' userEmail = "'.$con->real_escape_string($login).'"';
    } elseif ($login[0] == '+' || ctype_digit($login[0])) {
        if (ctype_digit(str_replace(array('(',')','-',' ','+'), '', $login))) {
            $where = ' userPhone = "'.$con->real_escape_string($login).'"';
        } else {
            $where = ' (userPhone = "'.$con->real_escape_string($login).'" || userEmail = "'.$con->real_escape_string($login).'")';
        }
    } else {
        $where = ' (userPhone = "'.$con->real_escape_string($login).'" || userEmail = "'.$con->real_escape_string($login).'")';
    }
    $r = $con->query('SELECT * FROM '.DB_PREFIX.'acl_user
                       WHERE '.$where.' AND
                             status = 1 AND
                             '.$typePass.'Password = "'.$con->real_escape_string($password).'"');
    $data = $r->fetch_assoc();
    if (!empty($data))
    {
        if (!empty($data['admins'])) $data['admins'] = unserialize($data['admins']);
        else $data['admins'] = [];
        $data = getGroups($data);
    }

    return $data;
}

function findUserByIdAndPassword($id, $password, $typePass = 'h')
{
    if (empty($id)) return false;

    $con = Common\Lib\DB::connection();
    $r = $con->query('SELECT * FROM '.DB_PREFIX.'acl_user
    WHERE status = 1 AND
          id = '. (int) $id .' AND
          '.$typePass.'Password = "'.$con->real_escape_string($password).'"');
    $data = $r->fetch_assoc();

    if (!empty($data))
    {
        if (!empty($data['admins'])) $data['admins'] = unserialize($data['admins']);
        else $data['admins'] = [];
        $data = getGroups($data);
    }

    return $data;
}

function getGroups($data)
{
    $data['isAdmin'] = 0;
    $isGuest = $data['isGuest'] = 0;
    $data['groups'] = [];
    $r = Common\Lib\DB::connection()->query('SELECT groupId FROM '.DB_PREFIX.'acl_ug WHERE userId = '.(int)$data['id']);
    while ($gr = $r->fetch_assoc())
    {
        $data['groups'][] = $gr['groupId'];
        if ($gr['groupId'] == 4 || isset($data['admins']['mape']) || isset($data['admins']['mapv']))
        {
            $data['isAdmin'] = 1;
        }
        if ($gr['groupId'] == 7) $isGuest = 1;
    }
    if ($isGuest && count($data['groups']) == 1) $data['isGuest'] = 1;
    return $data;
}

function formLogin()
{
    $pcm = main::mapper('page_core');
    if ($data = $pcm->findById(4)) {
		if (isMobile && (!empty($data['mobileId']) || !empty($data['tabletId']))) {
		    if ($data) $root = $data;
		    $mob = false;
		    if (isTablet) {
		       if (!empty($data['tabletId'])) {
		         $mob = $pcm->findById($data['tabletId']);
		       }
		    } elseif (!empty($data['mobileId'])) {
		       $mob = $pcm->findById($data['mobileId']);
		    }
		    if ($mob) {
		        $data = $mob;
		        if ($data['parentId']) $GLOBALS['selectIds'][$data['parentId']] = 1;
		        $pcm->p[$data['id']]['parentId'] = $data['parentId'] = $root['parentId'];
		        $pcm->p[$data['id']]['path'] = $data['path'] = $root['path'];
		    }
		}
		if ($data['langId'] == DEFAULT_LANG_ID) {
		    define('CUR_LANG_ID', DEFAULT_LANG_ID);
		    define('CUR_LANG', DEFAULT_LANG);
		} elseif ($lang = getLangById($data['langId'])) {
		    define('CUR_LANG_ID', $data['langId']);
		    define('CUR_LANG', $lang);
		} else {
		    define('CUR_LANG_ID', DEFAULT_LANG_ID);
		    define('CUR_LANG', DEFAULT_LANG);
		}
		if (!main::$user['id']) main::$user['langId'] = CUR_LANG_ID;
		if (file_exists(ROOT_PATH.'constants/'.CUR_LANG.'.php')) include(ROOT_PATH.'constants/'.CUR_LANG.'.php');
		else include(ROOT_PATH.'constants/en.php');
        $_REQUEST['id'] = $data['id'];

        $pcm->p[$data['id']]['robots'] = 0;
	    $domain = main::mapper('domain_core')->findById($data['domainId']);
	    if (!empty($domain['datas']['fontFams'])) $GLOBALS['fontFamily'] = array_merge($domain['datas']['fontFams'],$GLOBALS['fontFamily']);
        include(ROOT_PATH.'skinss/template/page.php');
    }
    Common\Lib\DB::connection()->close();
    exit;
}

function selectDirFiles($path) {
    $r = [];
    if (!file_exists($path)) return [];
    $dh  = opendir($path);
    while (false !== ($filename = readdir($dh))) if ($filename != "." && $filename != "..") $r[] = $filename;
    closedir($dh);
    return $r;
}
function unzip($zip, $dir) {
	$list = [];
	if (file_exists($zip)) {
		$arc = new PclZip($zip);
		$data = $arc->extract(PCLZIP_OPT_PATH, $dir,
				PCLZIP_OPT_REMOVE_ALL_PATH,
				PCLZIP_OPT_REPLACE_NEWER);
		if ($data) $list = $data;
	}
	return $list;
}
function detect_encoding($string, $pattern_size = 50) {
	if (isUtf8($string)) return 'utf-8';

    $list = array('cp1251', 'utf-8', 'ascii', '855', 'KOI8R', 'ISO-IR-111', 'CP866', 'KOI8U');
    $c = strlen($string);
    if ($c > $pattern_size)
    {
        $string = substr($string, floor(($c - $pattern_size) /2), $pattern_size);
        $c = $pattern_size;
    }

    $reg1 = '/(\xE0|\xE5|\xE8|\xEE|\xF3|\xFB|\xFD|\xFE|\xFF)/i';
    $reg2 = '/(\xE1|\xE2|\xE3|\xE4|\xE6|\xE7|\xE9|\xEA|\xEB|\xEC|\xED|\xEF|\xF0|\xF1|\xF2|\xF4|\xF5|\xF6|\xF7|\xF8|\xF9|\xFA|\xFC)/i';

    $mk = 10000;
    $enc = 'ascii';
    foreach ($list as $item)
    {
        $sample1 = @iconv($item, 'cp1251', $string);
        $gl = @preg_match_all($reg1, $sample1, $arr);
        $sl = @preg_match_all($reg2, $sample1, $arr);
        if (!$gl || !$sl) continue;
        $k = abs(3 - ($sl / $gl));
        $k += $c - $gl - $sl;
        if ($k < $mk)
        {
            $enc = $item;
            $mk = $k;
        }
    }
    return $enc;
}
function isUtf8($string) {
    return preg_match('%^(?:
          [\x09\x0A\x0D\x20-\x7E]            # ASCII
        | [\xC2-\xDF][\x80-\xBF]             # non-overlong 2-byte
        |  \xE0[\xA0-\xBF][\x80-\xBF]        # excluding overlongs
        | [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
        |  \xED[\x80-\x9F][\x80-\xBF]        # excluding surrogates
        |  \xF0[\x90-\xBF][\x80-\xBF]{2}     # planes 1-3
        | [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
        |  \xF4[\x80-\x8F][\x80-\xBF]{2}     # plane 16
    )*$%xs', $string);
}
if (!function_exists('mb_strtolower')) {
    function mb_strtolower($str, $encoding = '') {
        return $str;
    }
}
if (!function_exists('mb_strlen')) {
	function mb_strlen($str, $encoding = '') {
		return strlen($str);
	}
}
if (!function_exists('mb_substr')) {
    function mb_substr($str, $start, $length, $encoding = '') {
        return substr($str, $start , $length);
    }
}
function phpBlockInclude($b) {
    include(FILES_S.'block/'.$b['files']['php']['fileName']);
}
function getLangById($id) {
    $r = Common\Lib\DB::connection()->query('SELECT code from '.DB_PREFIX.'langs WHERE id = '.(int)$id);
    if ($data = $r->fetch_assoc()) return $data['code'];
    else '';
}
function cp_get_contents($url) {
    if (extension_loaded('curl') && function_exists('curl_init')) {
        return curl_contents($url);
    } else {
        return file_get_contents($url);
    }
}
function curl_contents($url) {
    $c = curl_init();
    curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($c, CURLOPT_FOLLOWLOCATION, false);
    curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($c, CURLOPT_TIMEOUT, 10);
    curl_setopt($c, CURLOPT_SSL_VERIFYPEER,0);
    curl_setopt($c, CURLOPT_SSL_VERIFYHOST,0);
    curl_setopt($c, CURLOPT_URL, $url);
    $ret = curl_exec($c);
    $error = curl_errno($c);
    curl_close($c);
    if ($error || !$ret) {
        return false;
    }
    return $ret;
}
function fontScss($d) {
    $css = $fdata = '';
    if (!empty($d['fsType']) && $d['fsType'] == 'calc') $fdata .= 'font-size:calc('.$d['fs1'].');';
    elseif (isset($d['fs1']) && $d['fs1'] !== '') $fdata .= 'font-size:'.$d['fs1'].$d['fsType'].';';
    if (!empty($d['lhType']) && $d['lhType'] == 'calc') $fdata .= 'line-height:calc('.$d['lh1'].');';
    elseif (isset($d['lh1']) && $d['lh1'] !== '') $fdata .= 'line-height:'.$d['lh1'].$d['lhType'].';';
    if (!empty($d['lsType'])) {
        if ($d['lsType'] == 'calc') {$fdata .= 'letter-spacing:calc('.$d['ls1'].');';}
        else {$fdata .= 'letter-spacing:'.$d['ls1'].$d['lsType'].';';}
    }
    if (!empty($d['fw'])) $fdata .= 'font-weight:'.$d['fw'].';';
    if (!empty($d['ff']) && isset($GLOBALS['fontFamily'][$d['ff']])) {
        $fdata .= 'font-family:'.$GLOBALS['fontFamily'][$d['ff']].';';
    }
    if ($fdata) $css .= 'html,body{'.$fdata.'}';
    for($i=1;$i<=4;$i++) {
        $fdata = '';
        if (!empty($d['h'.$i.'fsType']) && $d['h'.$i.'fsType'] == 'calc') $fdata .= 'font-size:calc('.$d['h'.$i.'fs1'].');';
        elseif (isset($d['h'.$i.'fs1']) && $d['h'.$i.'fs1'] !== '') $fdata .= 'font-size:'.$d['h'.$i.'fs1'].$d['h'.$i.'fsType'].';';
        if (!empty($d['h'.$i.'lhType']) && $d['h'.$i.'lhType'] == 'calc') $fdata .= 'line-height:calc('.$d['h'.$i.'lh1'].');';
        elseif (isset($d['h'.$i.'lh1']) && $d['h'.$i.'lh1'] !== '') $fdata .= 'line-height:'.$d['h'.$i.'lh1'].$d['h'.$i.'lhType'].';';
        if (!empty($d['h'.$i.'lsType'])) {
            if ($d['h'.$i.'lsType'] == 'calc') {$fdata .= 'letter-spacing:calc('.$d['h'.$i.'ls1'].');';}
            else {$fdata .= 'letter-spacing:'.$d['h'.$i.'ls1'].$d['h'.$i.'lsType'].';';}
        }
        if (!empty($d['h'.$i.'fw'])) $fdata .= 'font-weight:'.$d['h'.$i.'fw'].';';
        if (!empty($d['h'.$i.'ff']) && isset($GLOBALS['fontFamily'][$d['h'.$i.'ff']])) {
            $fdata .= 'font-family:'.$GLOBALS['fontFamily'][$d['h'.$i.'ff']].';';
        }
        if ($fdata) $css .= 'h'.$i.',.bh'.$i.'{'.$fdata.'}';
    }
    return $css;
}