<?php
use Common\Lib\DB;

class adaptive_core_mapper
{
    private $con;

    public function __construct()
    {
        $this->con = DB::connection();
    }

    public function getAdaptive($blockId, $swidth) {
        $return = array();
        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'block_adaptive WHERE swidth = '.$swidth.' AND id = '.(int)$blockId);
        $result = $r->fetch_assoc();
        if ($result) $result['swidth'] = (float) $result['swidth'];
        return $result;
    }

    public function getAdaptives($blockIds, $swidth) {
        $i = 0;
        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'block_adaptive WHERE swidth = '.$swidth.' AND id IN ('.$blockIds.')');
        while ($result = $r->fetch_assoc()) {
        	$i++;
            $result['swidth'] = (float) $result['swidth'];
            if (!isset($return)) $return = $result;
            else {
	            if ($return['fs1'] !== $result['fs1']) $return['fs1'] = '';
	            if ($return['fsType'] !== $result['fsType']) $return['fsType'] = '';
	            if ($return['fw'] !== $result['fw']) $return['fw'] = '';
	            if ($return['lh1'] !== $result['lh1']) $return['lh1'] = '';
	            if ($return['lhType'] !== $result['lhType']) $return['lhType'] = '';
	            if ($return['ls1'] !== $result['ls1']) $return['ls1'] = '';
	            if ($return['lsType'] !== $result['lsType']) $return['lsType'] = '';
	            if ($return['textAlign'] !== $result['textAlign']) $return['textAlign'] = '';
	            if ($return['inlineb'] !== $result['inlineb']) $return['inlineb'] = '';
	            if ($return['bhide'] !== $result['bhide']) $return['bhide'] = '';
	            if ($return['bwidth'] !== $result['bwidth']) $return['bwidth'] = '';
	            if ($return['bwidthType'] !== $result['bwidthType']) $return['bwidthType'] = '';
	            if ($return['bheight'] !== $result['bheight']) $return['bheight'] = '';
	            if ($return['bheightType'] !== $result['bheightType']) $return['bheightType'] = '';
	            if ($return['minwidth'] !== $result['minwidth']) $return['minwidth'] = '';
	            if ($return['minwidthType'] !== $result['minwidthType']) $return['minwidthType'] = '';
	            if ($return['minheight'] !== $result['minheight']) $return['minheight'] = '';
	            if ($return['minheightType'] !== $result['minheightType']) $return['minheightType'] = '';
	            if ($return['maxwidth'] !== $result['maxwidth']) $return['maxwidth'] = '';
	            if ($return['maxwidthType'] !== $result['maxwidthType']) $return['maxwidthType'] = '';
	            if ($return['maxheight'] !== $result['maxheight']) $return['maxheight'] = '';
	            if ($return['maxheightType'] !== $result['maxheightType']) $return['maxheightType'] = '';
	            if ($return['btop'] !== $result['btop']) $return['btop'] = '';
	            if ($return['btopPos'] !== $result['btopPos']) $return['btopPos'] = '';
	            if ($return['btopType'] !== $result['btopType']) $return['btopType'] = '';
	            if ($return['bleft'] !== $result['bleft']) $return['bleft'] = '';
	            if ($return['bleftPos'] !== $result['bleftPos']) $return['bleftPos'] = '';
	            if ($return['bleftType'] !== $result['bleftType']) $return['bleftType'] = '';
            }
        }
        return (isset($return) && count(explode(',', $blockIds)) == $i) ? $return : array();
    }

    public function update($data) {
        $cpoint = $ids = $swidths = array();
        $pageId = $pageId2 = 0;
        $swins = main::mapper('config_settings')->getAdaptivePoints();
        unset($swins[key($swins)]);
        if (!empty($data['ids'])) $ids = explode(',', $data['ids']);
        else $ids[] = $data['blockId'];
        if (!empty($data['siwidths'])) $swidths = explode(',', $data['siwidths']);
    	else $swidths[] = $data['swidth'];
        if (!empty($data['btop'])) $data['btop'] = strval(floatval(str_replace(',','.', $data['btop'])));
        if (!empty($data['bleft'])) $data['bleft'] = strval(floatval(str_replace(',','.', $data['bleft'])));
        if (!empty($data['bwidth'])) $data['bwidth'] = strval(floatval(str_replace(',','.', $data['bwidth'])));
        if (!empty($data['bheight'])) $data['bheight'] = strval(floatval(str_replace(',','.', $data['bheight'])));
        if (!empty($data['minwidth'])) $data['minwidth'] = strval(floatval(str_replace(',','.', $data['minwidth'])));
        if (!empty($data['minheight'])) $data['minheight'] = strval(floatval(str_replace(',','.', $data['minheight'])));
        if (!empty($data['maxwidth'])) $data['maxwidth'] = strval(floatval(str_replace(',','.', $data['maxwidth'])));
        if (!empty($data['maxheight'])) $data['maxheight'] = strval(floatval(str_replace(',','.', $data['maxheight'])));
        if (!empty($data['fs1']) && $data['fsType'] != 'calc') $data['fs1'] = strval(floatval(str_replace(',','.', $data['fs1'])));
        if (!empty($data['lh1']) && $data['lhType'] != 'calc') $data['lh1'] = strval(floatval(str_replace(',','.', $data['lh1'])));
        if (!empty($data['ls1']) && $data['lsType'] != 'calc') $data['ls1'] = strval(floatval(str_replace(',','.', $data['ls1'])));

        if ($data['btop'] === '') $data['btopType'] = '';
        if ($data['bleft'] === '') $data['bleftType'] = '';
        if ($data['bwidth'] === '' && $data['bwidthType'] !== 'a') $data['bwidthType'] = '';
        if ($data['bheight'] === '' && $data['bheightType'] !== 'a') $data['bheightType'] = '';
        if (empty($data['minwidth'])) {$data['minwidthType'] = '';}
        if (empty($data['minheight'])) {$data['minheightType'] = '';}
        if (empty($data['maxwidth'])) {$data['maxwidthType'] = '';}
        if (empty($data['maxheight'])) {$data['maxheightType'] = '';}

        if ($data['fs1'] === '') $data['fsType'] = '';
        elseif ($data['fsType'] === '') $data['fsType'] = 'px';
        if ($data['lh1'] === '') $data['lhType'] = '';
        if ($data['ls1'] === '') $data['lsType'] = '';
        elseif ($data['lsType'] === '') $data['lsType'] = 'em';

      $set = array();
      if (isset($data['check']['inlineb'])) {
        $cpoint['inlineb'] = (int)$data['inlineb'];
      }
      $inlineb = false;
      if (isset($data['check']['bleft'])) {
        $cpoint['bleft'] = (float)$data['bleft'];
        $cpoint['bleftType'] = $data['bleftType'];
        $cpoint['bleftPos'] = $data['bleftPos'];
		$set[] = 'bleft = "'.$cpoint['bleft'].'",
				  bleftType = "'.$this->con->real_escape_string($cpoint['bleftType']).'",
				  bleftPos = "'.$this->con->real_escape_string($cpoint['bleftPos']).'"';
		$inlineb = true;
      }

      if (isset($data['check']['btop'])) {
      	$cpoint['btop'] = (float)$data['btop'];
      	$cpoint['btopType'] = $data['btopType'];
      	$cpoint['btopPos'] = $data['btopPos'];
		$set[] = 'btop = "'.$cpoint['btop'].'",
				  btopType = "'.$this->con->real_escape_string($cpoint['btopType']).'",
				  btopPos = "'.$this->con->real_escape_string($cpoint['btopPos']).'"';
		$inlineb = true;
      }

	  if ($inlineb) {
	  	$cpoint['inlineb'] = 0;
		$set[] = 'inlineb = "'.$cpoint['inlineb'].'"';
	  }

	  if (isset($data['check']['textAlign'])) {
	  	$cpoint['textAlign'] = $data['textAlign'];
		$set[] = 'textAlign = "'.$this->con->real_escape_string($cpoint['textAlign']).'"';
	  }
	  if (isset($data['check']['bhide'])) {
	  	$cpoint['bhide'] = (int)$data['bhide'];
		$set[] = 'bhide = "'.$cpoint['bhide'].'"';
	  }
	  if (isset($data['check']['bwidth'])) {
	  	$cpoint['bwidth'] = (float)$data['bwidth'];
	  	$cpoint['bwidthType'] = $data['bwidthType'];
		$set[] = 'bwidth = "'.$cpoint['bwidth'].'",
		          bwidthType = "'.$this->con->real_escape_string($cpoint['bwidthType']).'"';
	  }
	  if (isset($data['check']['bheight'])) {
        $cpoint['bheight'] = (float)$data['bheight'];
        $cpoint['bheightType'] = $data['bheightType'];
		$set[] = 'bheight = "'.$cpoint['bheight'].'",
			      bheightType = "'.$this->con->real_escape_string($cpoint['bheightType']).'"';
	  }
	  if (isset($data['check']['fs1'])) {
        $cpoint['fs1'] = $data['fs1'];
        $cpoint['fsType'] = $data['fsType'];
        $set[] = 'fs1 = "'.$this->con->real_escape_string($cpoint['fs1']).'",
			      fsType = "'.$this->con->real_escape_string($cpoint['fsType']).'"';
	  }
	  if (isset($data['check']['fw'])) {
        $cpoint['fw'] = $data['fw'];
	  	$set[] = 'fw = "'.$this->con->real_escape_string($cpoint['fw']).'"';
	  }
	  if (isset($data['check']['lh1'])) {
        $cpoint['lh1'] = $data['lh1'];
        $cpoint['lhType'] = $data['lhType'];
	  	$set[] = 'lh1 = "'.$this->con->real_escape_string($cpoint['lh1']).'",
			      lhType = "'.$this->con->real_escape_string($cpoint['lhType']).'"';
	  }
	  if (isset($data['check']['ls1'])) {
        $cpoint['ls1'] = $data['ls1'];
        $cpoint['lsType'] = $data['lsType'];
	  	$set[] = 'ls1 = "'.$this->con->real_escape_string($cpoint['ls1']).'",
			      lsType = "'.$this->con->real_escape_string($cpoint['lsType']).'"';
	  }
	  if (isset($data['check']['minwidth'])) {
        $cpoint['minwidth'] = (float)$data['minwidth'];
        $cpoint['minwidthType'] = $data['minwidthType'];
	  	$set[] = 'minwidth = "'.$cpoint['minwidth'].'",
			      minwidthType = "'.$this->con->real_escape_string($cpoint['minwidthType']).'"';
	  }
	  if (isset($data['check']['maxwidth'])) {
        $cpoint['maxwidth'] = (float)$data['maxwidth'];
        $cpoint['maxwidthType'] = $data['maxwidthType'];
	  	$set[] = 'maxwidth = "'.$cpoint['maxwidth'].'",
			      maxwidthType = "'.$this->con->real_escape_string($cpoint['maxwidthType']).'"';
	  }
	  if (isset($data['check']['minheight'])) {
        $cpoint['minheight'] = (float)$data['minheight'];
        $cpoint['minheightType'] = $data['minheightType'];
	  	$set[] = 'minheight = "'.$cpoint['minheight'].'",
			      minheightType = "'.$this->con->real_escape_string($cpoint['minheightType']).'"';
	  }
	  if (isset($data['check']['maxheight'])) {
        $cpoint['maxheight'] = (float)$data['maxheight'];
        $cpoint['maxheightType'] = $data['maxheightType'];
	  	$set[] = 'maxheight = "'.$cpoint['maxheight'].'",
			      maxheightType = "'.$this->con->real_escape_string($cpoint['maxheightType']).'"';
	  }
      if (empty($cpoint)) return $data['blockId'];

      $firstSwidth = $endsiwidth = 0;
      if (!empty($swidths)) {
        $firstSwidth = current($swidths);
        foreach($swidths as $key => $value) {
            $lastSiwidth = $swidths[$key] = (float) $value;
            if (isset($swins[$lastSiwidth])) unset($swins[$lastSiwidth]);
        }
        $endsiwidth = end($swidths);
      }

      $r = $this->con->query('SELECT id,parentId,pageId,service,bwidth,bheight,bwidthType,bheightType,inlineb,bhide,btop,btopPos,btopType,bleft,bleftPos,bleftType,fs1,fsType,fw,lh1,lhType,ls1,lsType,minwidth,maxwidth,minheight,maxheight,minwidthType,maxwidthType,minheightType,maxheightType FROM '.DB_PREFIX.'block WHERE id in ('.implode(',', $ids).')');
      while ($b = $r->fetch_assoc()) {
        $adaptiveIns = 0;
        $firstSwidth2 = $firstSwidth;
        $swins2 = $swins;
        $b['bwidth'] = (float)$b['bwidth'];
        $b['bheight'] = (float)$b['bheight'];
        $b['btop'] = (float)$b['btop'];
        $b['bleft'] = (float)$b['bleft'];
        $b['maxwidth'] = (float)$b['maxwidth'];
        $b['minwidth'] = (float)$b['minwidth'];
        $b['maxheight'] = (float)$b['maxheight'];
        $b['minheight'] = (float)$b['minheight'];
        $service = $b['service'];
        if (!$pageId) $pageId = $b['pageId'];
        elseif ($pageId != $b['pageId']) $pageId2 = $b['pageId'];
	    if ($b['inlineb'] == '2') $cpoint['inlineb'] = '2';
        $return2 = $return = array();
        $def = 1;
        $r2 = $this->con->query('SELECT * FROM '.DB_PREFIX.'block_adaptive WHERE id = '.$b['id'].' ORDER BY swidth DESC');
        while ($result = $r2->fetch_assoc()) {
          $result['swidth'] = (float)$result['swidth'];
          $return[$result['swidth']] = $result;
          if ($firstSwidth2 > $result['swidth']) $firstSwidth2 = $result['swidth'];
          if (isset($swins2[$result['swidth']])) unset($swins2[$result['swidth']]);
          if ($endsiwidth && $result['swidth'] > $endsiwidth) $def = 0;
        }
        if (!empty($swins2)) {
          foreach($swins2 as $kb=>$vb) {
            if ($firstSwidth2 > $kb || $lastSiwidth < $kb) unset($swins2[$kb]);
          }
          if (!empty($swins2) && !empty($return)) {
            krsort($swins2);
            foreach($swins2 as $kb=>$vb) {
              foreach($return as $key => $value) {
                if ($key > $kb) $return2[$kb] = $value;
                else {
                    if (!isset($return2[$kb])) $return2[$kb] = $value;
                    break;
                }
              }
            }
          }
        }
        if (!empty($return2)) {
            foreach($return2 as $key => $value) {
                $return2[$key]['swidth'] = $key;
                $this->insertAdaptive($return2[$key]);
            }
        }
        $return2 = array();
        foreach($swidths as $v2) {
          if (!isset($return[$v2])) {
             foreach($return as $key => $value) {
               if ($key > $v2) {
                 $adaptiveIns = $key;
               } elseif (!$adaptiveIns) {
                 $adaptiveIns = $key;
               }
             }
             if ($adaptiveIns) $return2[$v2] = $return[$adaptiveIns];
             else $return2[$v2] = $b;
             $return2[$v2] = array_merge($return2[$v2], $cpoint);
             $return2[$v2]['swidth'] = $v2;
             $this->insertAdaptive($return2[$v2]);
          }
        }

      }

      if (!empty($cpoint) && !empty($swidths) && !empty($ids)) {
	     if (isset($data['check']['inlineb'])) {
	        $set[] = 'inlineb = "'.$cpoint['inlineb'].'"';
	     }
		 $this->con->query('UPDATE '.DB_PREFIX.'block_adaptive SET '.(implode(',', $set)).' WHERE id IN ('.implode(',', $ids).') AND swidth IN ('.implode(',', $swidths).')');
        if ($def) {
            $this->con->query('UPDATE '.DB_PREFIX.'block SET '.(implode(',', $set)).' WHERE id IN ('.implode(',', $ids).')');
         }
         if ($pageId) $this->con->query('UPDATE '.DB_PREFIX.'page SET createCss = 1 WHERE id = '.(int)$pageId);
         if ($pageId2) $this->con->query('UPDATE '.DB_PREFIX.'page SET createCss = 1 WHERE id = '.(int)$pageId2);
         if ($service == 'content_core') {
            if ($pageId) main::mapper('block_core')->correctViewport($pageId);
            if ($pageId2) main::mapper('block_core')->correctViewport($pageId2);
         }
      }
      return $data['blockId'];
    }

	public function insertAdaptive($b) {
		$this->con->query('INSERT INTO '.DB_PREFIX.'block_adaptive
		(id,pageId,service,bwidth,bwidthType,bheight,bheightType,inlineb,bhide,btop,btopPos,btopType,bleft,bleftPos,bleftType,fs1,fsType,fw,lh1,lhType,ls1,lsType,swidth,minwidth,minwidthType,maxwidth,maxwidthType,minheight,minheightType,maxheight,maxheightType,textAlign) VALUES
		('.$b['id'].',
		 '.$b['pageId'].',
		 "'.$this->con->real_escape_string($b['service']).'",
		 "'.round((float)$b['bwidth'], 2).'",
		 "'.$this->con->real_escape_string($b['bwidthType']).'",
		 "'.round((float)$b['bheight'], 2).'",
		 "'.$this->con->real_escape_string($b['bheightType']).'",
		 "'.(int)$b['inlineb'].'",
		 "'.(int)$b['bhide'].'",
		 "'.round((float)$b['btop'], 2).'",
		 "'.$this->con->real_escape_string($b['btopPos']).'",
		 "'.$this->con->real_escape_string($b['btopType']).'",
		 "'.round((float)$b['bleft'], 2).'",
		 "'.$this->con->real_escape_string($b['bleftPos']).'",
		 "'.$this->con->real_escape_string($b['bleftType']).'",
		 "'.$this->con->real_escape_string($b['fs1']).'",
		 "'.$this->con->real_escape_string($b['fsType']).'",
		 "'.$this->con->real_escape_string($b['fw']).'",
		 "'.$this->con->real_escape_string($b['lh1']).'",
		 "'.$this->con->real_escape_string($b['lhType']).'",
		 "'.$this->con->real_escape_string($b['ls1']).'",
		 "'.$this->con->real_escape_string($b['lsType']).'",
		 '.(float)$b['swidth'].',
		 "'.round((float)$b['minwidth'], 2).'",
		 "'.$this->con->real_escape_string($b['minwidthType']).'",
		 "'.round((float)$b['maxwidth'], 2).'",
		 "'.$this->con->real_escape_string($b['maxwidthType']).'",
		 "'.round((float)$b['minheight'], 2).'",
		 "'.$this->con->real_escape_string($b['minheightType']).'",
		 "'.round((float)$b['maxheight'], 2).'",
		 "'.$this->con->real_escape_string($b['maxheightType']).'",
		 "'.(isset($b['textAlign']) ? $this->con->real_escape_string($b['textAlign']) : '').'")');
	}
}