<?php
use Common\Lib\DB;

class page_core_mapper
{
    private $con;
	private $read = '';
	public $p = [];
    public $s = [];
    private $vars = [];

    public function __construct()
    {
        $this->con = DB::connection();

        if (!main::$user['isAdmin'])
        {
            $this->read .= ' AND perm IN (1'.(!empty(main::$user['groups']) ? ','.implode(',', main::$user['groups']) : '').(!main::$user['isGuest'] ? ',2' : '').')';
        }
    }

    public function findByParentIdAnddomainId($id, $domainId, $isTemplate) {
        $return = [];

        $where = '';
        if (!$isTemplate)
        {
            $where = ' AND domainId = '. (int) $domainId;
        }
        $r = $this->con->query('SELECT id, parentId, path, dateCustom, baseName FROM '.DB_PREFIX.'page
                                  WHERE parentId = '. (int) $id .' AND
                                        isTemplate = '. $isTemplate. '
                                       '. $where .'
                               ORDER BY sequence DESC');

        while ($result = $r->fetch_assoc())
        {
            $return[$result['id']] = $result;
        }

        return $return;

    }

    public function findAll($id, $domainId = 1) {
        $return = [];
        if (!$domainId) return [];
        $r = $this->con->query('SELECT id FROM '.DB_PREFIX.'page WHERE parentId = '.(int)$id.' AND domainId = '.(int)$domainId);
        while ($result = $r->fetch_assoc()) $return[] = $result;
        return $return;
    }

    public function getUrls($ids, $domainId)
    {
        if (empty($ids))
        {
            return [];
        }

        $return = [];
        $r = $this->con->query('SELECT p.id, p.path, p.domainId, d.domain FROM '.DB_PREFIX.'page p LEFT JOIN '.DB_PREFIX.'domain d ON (p.domainId = d.domainId) WHERE p.id IN ('.implode(',', array_keys($ids)).') LIMIT '.count($ids));
    	while ($result = $r->fetch_assoc())
        {
            $domain = '';
            if ($result['domainId'] != $domainId)
            {
                $domain = siteProtocol.'://'.$result['domain'];
            }
            $return[$result['id']]['path'] = $domain.BASE_DIR.'/'.str_replace('%2F', '/', rawurlencode($result['path']));
        }

        return $return;
    }

    public function getUrl($id, $domainId)
    {
    	$r = $this->con->query('SELECT path, domainId FROM '.DB_PREFIX.'page WHERE id = '.$id.' LIMIT 1');
    	if ($data = $r->fetch_assoc())
        {
            $domain = '';
            if ($data['domainId'] != $domainId)
            {
                $r2 = $this->con->query('SELECT domain FROM '.DB_PREFIX.'domain WHERE domainId = '.$data['domainId'].' LIMIT 1');
                if ($data2 = $r2->fetch_assoc())
                {
                    $domain = siteProtocol.'://'.$data2['domain'];
                }
            }

            return $domain.BASE_DIR.'/'.str_replace('%2F', '/', rawurlencode($data['path']));
    	}

    	return '';
    }

    public function countItems($id, $domainId = null) {
    	$where = ' AND isTemplate = 0';
    	if ($domainId !== null) $where = ' AND domainId = '.$domainId;
        $r = $this->con->query('SELECT count(*) as count FROM '.DB_PREFIX.'page WHERE parentId = '.(int)$id.$where.$this->read);
        $result = $r->fetch_assoc();
        return (int)$result['count'];
    }

    public function findById($id, $check = false) {
    	if (!$id) return false;
        if (isset($this->p[$id])) return $this->p[$id];
        $r = $this->con->query('SELECT *, UNIX_TIMESTAMP(dateCustom) as dateCustom FROM '.DB_PREFIX.'page
                                  WHERE id = '.(int)$id.($check ? $this->read : ''));
        if ($this->p[$id] = $r->fetch_assoc()) {
            $this->p[$id]['datas'] = $this->p[$id]['datas'] ? unserialize($this->p[$id]['datas']) : [];
        	if (!$this->p[$id]['templateId']) return $this->p[$id];
            $r = $this->con->query('SELECT viewport,datas,createCss FROM '.DB_PREFIX.'page WHERE id = '.$this->p[$id]['templateId']);
            if ($f = $r->fetch_assoc()) {
            	$this->p[$id]['createCss2'] = $f['createCss'];
            	if ($f['viewport'] && ($f['viewport'] > $this->p[$id]['viewport'] || !$this->p[$id]['viewport'])) $this->p[$id]['viewport'] = $f['viewport'];
            	$datas = $f['datas'] ? unserialize($f['datas']) : [];
                if (!isset($this->p[$id]['datas']['videoCheck']) && isset($datas['videoCheck'])) $this->p[$id]['datas']['videoCheck'] = $datas['videoCheck'];
                if (!isset($this->p[$id]['datas']['vbCheck']) && isset($datas['vbCheck'])) $this->p[$id]['datas']['vbCheck'] = $datas['vbCheck'];
            	if (!isset($this->p[$id]['datas']['fileType']) && isset($datas['fileType'])) $this->p[$id]['datas']['fileType'] = $datas['fileType'];
                if (!isset($this->p[$id]['datas']['volume']) && isset($datas['volume'])) $this->p[$id]['datas']['volume'] = $datas['volume'];
                if (!isset($this->p[$id]['datas']['soundwave']) && isset($datas['soundwave'])) $this->p[$id]['datas']['soundwave'] = $datas['soundwave'];
            	if (!isset($this->p[$id]['datas']['bgPosition']) && isset($datas['bgPosition'])) $this->p[$id]['datas']['bgPosition'] = $datas['bgPosition'];
            	if (!isset($this->p[$id]['datas']['bgPosition2']) && isset($datas['bgPosition2'])) $this->p[$id]['datas']['bgPosition2'] = $datas['bgPosition2'];
                if (isset($this->p[$id]['datas']['fileType']) && $this->p[$id]['datas']['fileType'] !== 'file') {
                    if (!isset($this->p[$id]['datas']['url']) && isset($datas['url'])) $this->p[$id]['datas']['url'] = $datas['url'];
                    if (!isset($this->p[$id]['datas']['url2']) && isset($datas['url2'])) $this->p[$id]['datas']['url2'] = $datas['url2'];
                    if (!isset($this->p[$id]['datas']['yId']) && isset($datas['yId']))
                    {
                    	$this->p[$id]['datas']['yId'] = $datas['yId'];
                    	if (isset($datas['start'])) $this->p[$id]['datas']['start'] = $datas['start'];
                    	if (isset($datas['end'])) $this->p[$id]['datas']['end'] = $datas['end'];
                    }
                }
                $this->p[$id]['datas']['tplpbcolor'] = $datas['pbcolor'];
                $this->p[$id]['pdatas'] = $datas;
            }
        }

        return $this->p[$id];

    }

    public function findNodeById($id) {
        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'page WHERE id = '.(int)$id.$this->read);
        return $r->fetch_assoc();
    }

    public function findMultiById($id)
    {
        if (isSubmit()) return $_REQUEST;

        if (isset($_REQUEST['create']))
        {
            $data = $this->findById($_REQUEST['parentId']);

        	$path = '';
            if (!empty($_REQUEST['isTemplate']) || $this->countItems(0, $_REQUEST['domainId']))
            {
                $path = 'page'.$this->nextSeq();
            }

            return [
                'path' => $path,
                'perm' => 1,
                'robots' => 1,
                'templateId' => 0,
                'datas' => [],
                'mobileId' => 0,
                'tabletId' => 0,
                'domainId' => $_REQUEST['domainId'],
                'isTemplate' => !empty($_REQUEST['isTemplate']) ? $_REQUEST['isTemplate'] : 0,
                'langId' => !empty($data['langId']) ? $data['langId'] : DEFAULT_LANG_ID,
                'parentId' => !empty($data['id']) ? $data['id'] : 0
            ];
        }

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'page WHERE id = '.(int)$id);
        $p = $r->fetch_assoc();
        $p['datas'] = $p['datas'] ? unserialize($p['datas']) : [];
        if (!empty($p['pheader'])) $p['ch_pheader'] = 1;
        if (!empty($p['phtm1'])) $p['ch_phtm1'] = 1;
        if (!empty($p['phtm2'])) $p['ch_phtm2'] = 1;
        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'page_file WHERE id = '.(int)$id.' ORDER BY seq');
        while ($t = $r->fetch_assoc()) {
            if ($t['type'] == 'bg') {
               $p['files'][$t['type']][] = $t;
            } else {
        	   $p['files'][$t['type']] = $t;
            }
        }
        $p['vars'] = main::mapper('main_settings')->getVars($id);
        return $p;
    }

    public function getVars($id, $templateId = 0, $domainId = 1) {
    	if (isset($this->vars[$id])) return $this->vars[$id];
        $return = [];
        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'vars WHERE pageId IN ('.(int)$id.($templateId ? ','.(int)$templateId : '').($domainId ? ',-'.$domainId : '').') ORDER BY id');
        while ($result = $r->fetch_assoc()) {
            $return[0][] = $result['name'];
            $return[1][] = $result['value'];
        }
        if (defined('module') && !empty(module::$vars)) {
        	foreach(module::$vars as $key => $val) {
	          $return[0][] = $key;
	          $return[1][] = $val;
        	}
        }
        return $this->vars[$id] = $return;
    }

    public function templatesList()
    {
		$return = [];
    	$r = $this->con->query('SELECT id,datas,baseName FROM '.DB_PREFIX.'page WHERE isTemplate = 1 ORDER BY sequence DESC');
        while ($result = $r->fetch_assoc())
        {
        	$result['datas'] = $result['datas'] ? unserialize($result['datas']) : [];
        	$return[$result['id']] = $result;
        }

        return $return;
    }

    public function siteSystemMap($isTemplate = 0)
    {
        $return = [
            'domains' => [],
            'templates' => [],
            'mobile' => [],
            'tablet' => []
        ];

        $IDN = new \idna_convert(['idn_version' => 2008]);

        $r = $this->con->query('SELECT d.domainId, d.domain, d.siteName, df.fileName FROM '.DB_PREFIX.'domain d LEFT JOIN '.DB_PREFIX.'domain_file df ON (d.domainId = df.domainId AND df.type = "icon") ORDER BY sequence DESC');
        while ($result = $r->fetch_assoc())
        {
            if (!empty($result['domain']))
            {
                $result['domain'] = $IDN->decode($result['domain']);
            }

            if (!$result['domain'])
            {
                $result['domain'] = $result['siteName'] ? $result['siteName'] : 'Site '.$result['domainId'];
            }

            $return['domains'][$result['domainId']] = ['name' => $result['domain'], 'fileName' => $result['fileName'], 'pages' => []];
        }

        $where = '';
        if (!$isTemplate)
        {
            $where = 'WHERE isTemplate = 0';
        }
        $r = $this->con->query('SELECT id, domainId, parentId, path, baseName, mobileId , tabletId, isTemplate FROM '.DB_PREFIX.'page '.$where.' ORDER BY sequence DESC');
        while ($result = $r->fetch_assoc())
        {
            if ($result['isTemplate'])
            {
                $return['templates'][] = $result;
                continue;
            }

            if ($result['mobileId']) $return['mobile'][$result['mobileId']] = 1;
            if ($result['tabletId']) $return['tablet'][$result['tabletId']] = 1;

            $return['domains'][$result['domainId']]['pages'][$result['parentId']][] = $result;
        }

        return $return;

    }

    public function findBySimple($path, $id = 0, $domainId = null)
    {
    	if ($id == 0)
        {
    		if (isset($this->s[$path.' '.$domainId]))
            {
                return $this->s[$path.' '.$domainId];
            }

            $where = 'path = "'.$this->con->real_escape_string(trim($path, ' /\\')).'"';

            if ($domainId !== NULL)
            {
                $where .= ' AND domainId = '.(int)$domainId;
            }

            if (!main::$user['isAdmin'])
            {
                $where .= ' AND isTemplate = 0';
            }

        }
        else
        {
    		if (isset($this->s[$id]))
            {
                return $this->s[$id];
            }

            $where = 'id ='. (int) $id;
    	}

        $r = $this->con->query('SELECT id, parentId, mobileId, tabletId, perm, UNIX_TIMESTAMP(dateCustom) as dateCustom, path, robots, domainId FROM '.DB_PREFIX.'page WHERE '.$where);
        $return = $r->fetch_assoc();
        if ($id == 0)
        {
            $this->s[$path.' '.$domainId] = $return;
        	if ($return) $this->s[$return['id']] = $return;
        } else $this->s[$id] = $return;
        return $return;
    }

    public function updateItem($data) {
    	$set = '';
        $data['parentId'] = isset($data['parentId']) ? (int)$data['parentId'] : 0;
        if ($data['parentId'] && !$this->findNodeById($data['parentId'])) $data['parentId'] = 0;

        if (isset($data['create'])) {
        	$data['id'] = $this->insert($data['parentId'], $data['perm']);
        }

		if (isset($data['colors'])) main::mapper('color_core')->update($data['id'], $data['colors'], $data['datas'], 0);
        if ($data['mobileId'] == $data['id']) $data['mobileId'] = 0;
        if ($data['tabletId'] == $data['id']) $data['tabletId'] = 0;
        if (isset($data['domainId'])) $set = 'domainId = '.(int)$data['domainId'].',';

        $this->con->query('UPDATE '.DB_PREFIX.'page
        					 SET perm = '.(int)$data['perm'].',
        					     createCss = 1,
	        					 langId = '.(int)$data['langId'].',
                                 isTemplate = '.(!empty($data['isTemplate']) ? 1 : 0).',
			                     baseName = "'.$this->con->real_escape_string(mb_strlen($data['baseName'], 'UTF-8') <= 191 ? $data['baseName'] : mb_substr($data['baseName'], 0 , 191, 'UTF-8')).'",
			                     title = "'.$this->con->real_escape_string(mb_strlen($data['title'], 'UTF-8') <= 191 ? $data['title'] : mb_substr($data['title'], 0 , 191, 'UTF-8')).'",
			                     metaDescription = "'.$this->con->real_escape_string(mb_strlen($data['metaDescription'], 'UTF-8') <= 300 ? $data['metaDescription'] : mb_substr($data['metaDescription'], 0 , 300, 'UTF-8')).'",
                                 metaKeywords = "'.$this->con->real_escape_string(mb_strlen($data['metaKeywords'], 'UTF-8') <= 191 ? $data['metaKeywords'] : mb_substr($data['metaKeywords'], 0 , 191, 'UTF-8')).'",
			                     '.(isset($data['viewport']) ? 'viewport = '.(int)$data['viewport'].',' : '').'
                                 robots = '.(isset($data['robots']) ? 1 : 0).',
        					 	 parentId = '.(int)$data['parentId'].',
                                 mobileId = '.(int)$data['mobileId'].',
                                 tabletId = '.(int)$data['tabletId'].',
        					 	 pheader = "'.(!empty($data['ch_pheader']) ? $this->con->real_escape_string(trim($data['pheader'])) : '').'",
                                 phtm1 = "'.(!empty($data['ch_phtm1']) ? $this->con->real_escape_string(trim($data['phtm1'])) : '').'",
                                 phtm2 = "'.(!empty($data['ch_phtm2']) ? $this->con->real_escape_string(trim($data['phtm2'])) : '').'",
                                 datas = "'.(!empty($data['datas']) ? $this->con->real_escape_string(serialize($data['datas'])) : '').'",
        					 	 templateId = '.($data['templateId'] ? (int)$data['templateId'] : 0).',
								 path =  "'.(isset($data['path']) ? $this->con->real_escape_string(trim($data['path'], ' /\\')) : $data['id']).'",
								 '.$set.'
								 dateCustom = now()
        					 WHERE id = '.$data['id']);

    	return $data['id'];

    }

    public function updateTemplate($parent) {
        $parent['datas'] = $parent['datas'] ? unserialize($parent['datas']) : [];

    	$r = $this->con->query('SELECT id, datas FROM '.DB_PREFIX.'page WHERE templateId = '.(int)$parent['id']);
        while ($result = $r->fetch_assoc()) {
            $result['datas'] = $result['datas'] ? unserialize($result['datas']) : [];
            $upp = 0;
            if (isset($parent['datas']['pbcolor']) && !isset($result['datas']['pbcolor'])) {
            	$result['datas']['pbcolor'] = $parent['datas']['pbcolor'];
                $upp = 1;
            }
            if (isset($parent['datas']['vbcolor']) && !isset($result['datas']['vbcolor'])) {
            	$result['datas']['vbcolor'] = $parent['datas']['vbcolor'];
                $upp = 1;
            }
	        if (!isset($result['datas']['url']) && isset($parent['datas']['url'])) {
	            $result['datas']['url'] = $parent['datas']['url'];
                $upp = 1;
	        }
            if (!isset($result['datas']['url2']) && isset($parent['datas']['url2'])) {
	            $result['datas']['url2'] = $parent['datas']['url2'];
                $upp = 1;
	        }
	        if (!isset($result['datas']['fileType']) && isset($parent['datas']['fileType'])) {
	            $result['datas']['fileType'] = $parent['datas']['fileType'];
                $upp = 1;
	        }
	        if (!isset($result['datas']['yId']) && isset($parent['datas']['yId'])) {
	            $result['datas']['yId'] = $parent['datas']['yId'];
	            if (isset($parent['datas']['start'])) $result['datas']['start'] = $parent['datas']['start'];
	            if (isset($parent['datas']['end'])) $result['datas']['end'] = $parent['datas']['end'];
                $upp = 1;
	        }
	        if (!isset($result['datas']['volume']) && isset($parent['datas']['volume'])) {
                $result['datas']['volume'] = $parent['datas']['volume'];
                $upp = 1;
	        }
            if (!isset($result['datas']['videoCheck']) && isset($parent['datas']['videoCheck'])) {
            	$result['datas']['videoCheck'] = $parent['datas']['videoCheck'];
                $upp = 1;
	        }
	        if (!isset($result['datas']['vbCheck']) && isset($parent['datas']['vbCheck'])) {
            	$result['datas']['vbCheck'] = $parent['datas']['vbCheck'];
                $upp = 1;
	        }
            if (!isset($result['datas']['soundwave']) && isset($parent['datas']['soundwave'])) {
            	$result['datas']['soundwave'] = $parent['datas']['soundwave'];
                $upp = 1;
	        }
            if ($upp) {
	            $this->con->query('UPDATE '.DB_PREFIX.'page
	                             SET dateCustom = now(),
	                                 createCss = 1,
	                                 datas = "'.(!empty($result['datas']) ? $this->con->real_escape_string(serialize($result['datas'])) : '').'"
	                             WHERE id = '.$result['id']);
            }
        }

        $this->con->query('UPDATE '.DB_PREFIX.'page
        					 SET templateId = 0
                			 WHERE templateId = '.(int)$parent['id']);

    }

    public function deleteFile($id, $type) {
        $file = $this->findFileById($id, $type);
        if (empty($file)) return;

        foreach($file as $key=>$value) {
            if ($key == 'bg') {
                foreach($value as $value2) {
                    if ($value2['fileName']) unlink(FILES_S.'page/'.$value2['fileName']);
                }
            } else {
                if ($value['fileName']) unlink(FILES_S.'page/'.$value['fileName']);
            }
        }

        $this->con->query('DELETE FROM '.DB_PREFIX.'page_file WHERE id ='.(int)$id.' AND type = "'.$type.'"');

    }

    public function deleteNoExistFileNames($id, $type = false, $fileNames = []) {
        if (empty($fileNames) || $type === false) return;

        foreach($fileNames as $key=>$value) {
            $fileNames[$key] = $this->con->real_escape_string($value);
            $this->con->query('UPDATE '.DB_PREFIX.'page_file SET seq = '.(int)$key.' WHERE `fileName` = "'.$fileNames[$key].'"');
        }

        $files = [];
        $r = $this->con->query('SELECT fileName FROM '.DB_PREFIX.'page_file WHERE id = '.(int)$id.' AND type = "'.$type.'" AND `fileName` NOT IN ("'.implode('","', $fileNames).'")');
        while ($file = $r->fetch_assoc()) $files[] = $file['fileName'];
        if (empty($files)) return;

        foreach($files as $fileName) if ($fileName) unlink(FILES_S.'page/'.$fileName);
        $this->con->query('DELETE FROM '.DB_PREFIX.'page_file WHERE id = '.(int)$id.' AND type = "'.$type.'" AND `fileName` NOT IN ("'.implode('","', $fileNames).'")');

    }

    public function deleteOldTmpFiles() {
        $r = $this->con->query('SELECT `dir` FROM '.DB_PREFIX.'temp_files WHERE crtime <= DATE_SUB(CURRENT_TIME, INTERVAL 3 HOUR)');
        while ($result = $r->fetch_assoc()) {
        	$this->deleteTmpFiles($result['dir']);
        }
    }

    public function deleteTmpFiles($mdir = '') {
    	if (!$mdir) return;
    	if (file_exists(FILES_S.'temp/'.$mdir)) {
	    	$dirs = selectDirFiles(FILES_S.'temp/'.$mdir.'/');
	        foreach($dirs as $dir) {
	            $files = selectDirFiles(FILES_S.'temp/'.$mdir.'/'.$dir.'/');
	            foreach($files as $file) @unlink(FILES_S.'temp/'.$mdir.'/'.$dir.'/'.$file);
	            @rmdir(FILES_S.'temp/'.$mdir.'/'.$dir);
	        }
	        @rmdir(FILES_S.'temp/'.$mdir);
    	}
        $this->con->query('DELETE FROM '.DB_PREFIX.'temp_files WHERE dir = '.$mdir);
        if (isset($_SESSION['temp'.$mdir])) unset($_SESSION['temp'.$mdir]);
    }

    public function updateDate($id = 0) {
    	$where = '';
    	if ($id) $where = ' WHERE id = '.$id.' OR templateId = '.$id;
    	$this->con->query('UPDATE '.DB_PREFIX.'page SET dateCustom = now()'.$where);
    }

    public function updateImage($data, $fileName)
    {
        $ext = substr(strrchr($fileName, '.'), 1);
        $name = uniqid().'.'.$ext;
        if ($this->issetFileName($name))
        {
            $name = $this->uniqFile($ext);
        }

        if (!isset($_REQUEST['create']) && $file = $this->findFileById($data['id'], 'icon')) {
            foreach($file as $key=>$value) unlink(FILES_S.'page/'.$value['fileName']);
        }
		copy(FILES_S.'temp/'.$data['userDir'].'/icon/'.$fileName, FILES_S.'page/'.$name);
        list ($wReal, $hReal, $tReal) = getimagesizenew(FILES_S.'page/'.$name);
        $this->con->query('INSERT INTO '.DB_PREFIX.'page_file (id, width, height, fileName, type)
        				   VALUES ('.(int) $data['id'].', '.(int)$wReal.', '.(int)$hReal.', "'.$this->con->real_escape_string($name).'", "icon")
        				   ON DUPLICATE KEY UPDATE width = VALUES(width), height = VALUES(height), fileName = VALUES(fileName)');

    }

    public function updateFile($data, $fileName, $fileType = 'file')
    {
        $ext = substr(strrchr($fileName, '.'), 1);
        $name = preg_replace('/([^a-z0-9\!\(\)\.\-\_]+)/ui', '', $fileName);
        if ($name[0] == '.') $name = $data['id'].$name;

        $typeId = 0;
        if ($ext)
        {
            $typeId = main::mapper('docType_settings')->findIdByExt($ext);
        }

        if ($this->issetFileName($name))
        {
            $name = $this->uniqFile($ext);
        }

        if ($file = $this->findFileById($data['id'], $fileType))
        {
        	if ($file[$fileType]['fileName'] == $name)
            {
                $name = 'v'.$name;
            }
        	unlink(FILES_S.'page/'.$file[$fileType]['fileName']);
        }

        copy(FILES_S.'temp/'.$data['userDir'].'/'.$fileType.'/'.$fileName, FILES_S.'page/'.$name);

        $this->con->query('INSERT INTO '.DB_PREFIX.'page_file (id, fileName, type, typeId)
                           VALUES ('.(int) $data['id'].', "'.$this->con->real_escape_string($name).'", "'.$fileType.'", '.$typeId.')
                           ON DUPLICATE KEY UPDATE fileName = VALUES(fileName)');
    }

    public function findFileByFileName($fileName) {
        $r = $this->con->query('SELECT id,fileName,width,height,type,typeId,seq FROM '.DB_PREFIX.'page_file WHERE fileName = "'.$this->con->real_escape_string($fileName).'"');
        return $r->fetch_assoc();
    }

    public function uniqFile($ext)
    {
        $uniqid = uniqid();
        if (!$this->issetFileName($uniqid.'.'.$ext))
        {
            return $uniqid.'.'.$ext;
        }
        return $this->uniqFile($ext);
    }

    public function issetFileName($name) {
        $r = $this->con->query('SELECT id from '.DB_PREFIX.'page_file WHERE fileName = "'.$this->con->real_escape_string($name).'"');
        $t = $r->fetch_assoc();
        if ($t) return true;
        return false;
    }

    public function insert($parentId, $perm) {
        $this->con->query('INSERT INTO '.DB_PREFIX.'page (parentId, pheader, phtm1, phtm2, datas, perm, dateCustom, sequence) VALUES ('.(int)$parentId.', "", "", "", "", '.(int)$perm.', now(), '.$this->nextSeq().')');
        return $this->con->insert_id;
    }

    public function nextSeq() {
        $r = $this->con->query('SELECT max(sequence) as max FROM '.DB_PREFIX.'page');
        $data = $r->fetch_assoc();
        return (int)$data['max'] + 1;
    }

    public function findFileById($id, $type = false) {
    	$return = [];
    	$where = '';
    	if ($type) $where .= ' AND `type` = "'.$this->con->real_escape_string($type).'"';
    	if ($type == 'bg') $where .= ' ORDER BY seq DESC';
        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'page_file WHERE id = '.$id.$where);
        while ($result = $r->fetch_assoc()) {
            if ($result['type'] == 'bg') {
               $return[$result['type']][] = $result;
            } else {
        	   $return[$result['type']] = $result;
            }
        }
        return !empty($return) ? $return : false;
    }

    public function findFileByIdAndTplId($id, $templateId, $type = []) {
        $return = [];
        $r = $this->con->query('SELECT width,height,fileName,type,seq,typeId FROM '.DB_PREFIX.'page_file WHERE id = '.(int)$id.' AND type IN ("'.implode('","',$type).'")');
        while ($f = $r->fetch_assoc()) {
            if ($f['type'] == 'bg') {
               $return[$f['type']][] = $f;
            } else {
               $return[$f['type']] = $f;
            }
        }
        if (!$templateId) return $return;
        $next = 0;
        foreach($type as $key=>$val) {
        	if (empty($return[$val])) $next = 1;
        	else unset($type[$key]);
        }
        if (!$next) return $return;
        $r = $this->con->query('SELECT width,height,fileName,type,seq,typeId FROM '.DB_PREFIX.'page_file WHERE id = '.(int)$templateId.' AND type IN ("'.implode('","',$type).'")');
        while ($f = $r->fetch_assoc()) {
            if ($f['type'] == 'bg') {
               $return[$f['type']][] = $f;
            } else {
               $return[$f['type']] = $f;
            }
        }
        return $return;
    }

    public function delete($id) {
    	$old = $this->findNodeById($id);
        $this->deleteFromPage($id);
        $this->con->query('DELETE FROM '.DB_PREFIX.'page WHERE id = '.(int)$id);
        $this->con->query('UPDATE '.DB_PREFIX.'page SET parentId = '.(int)$old['parentId'].' WHERE parentId = '.(int)$id);
        $this->con->query('DELETE FROM '.DB_PREFIX.'temp_blocks WHERE pageId = '.(int)$id);
        $this->con->query('DELETE FROM '.DB_PREFIX.'vars WHERE pageId = '.(int)$id);
        $this->con->query('DELETE FROM '.DB_PREFIX.'block_adaptive WHERE pageId = '.(int)$id);
        $this->con->query('UPDATE '.DB_PREFIX.'handler SET pageId = 0 WHERE pageId = '.(int)$id);
        $this->con->query('UPDATE '.DB_PREFIX.'block SET otherId = 0 WHERE otherId = '.(int)$id);
        main::mapper('color_core')->delete($id, 0);
        if ($file = $this->findFileById($id)) {
	        foreach($file as $key=>$value) {
	            if ($key == 'bg') {
	                foreach($value as $value2) {
	                    if ($value2['fileName']) unlink(FILES_S.'page/'.$value2['fileName']);
	                }
	            } else {
	                if ($value['fileName']) unlink(FILES_S.'page/'.$value['fileName']);
	            }
	        }
        }
        $this->con->query('DELETE FROM '.DB_PREFIX.'page_file WHERE id ='.$id);
        if(file_exists(FILES_S.'styles/'.$id.'.css')) unlink(FILES_S.'styles/'.$id.'.css');
    	if ($old['isTemplate']) $this->updateTemplate($old);
    	if (orderPage == $id) {
    		main::service('main_settings')->setSettingsPage(0, 'orderPage');
    	}
        if (Page404Id == $id) {
            main::service('main_settings')->setSettingsPage(0, 'Page404Id');
        }
    }

    private function deleteFromPage($pageId)
    {
        $forms = [];
        $list = main::mapper('block_core')->findAll(null, $pageId);
        foreach($list as $item)
        {
            main::mapper('block_core')->delete($item);
            if (!empty($item['formId']))
            {
                $forms[$item['formId']] = 1;
            }
        }

        $formRepo = new Admin\Repository\SqlFormRepository();
        $formIds = $formRepo->getEmptyForms($forms);
        $formRepo->deleteForms($formIds);

        $usecase = new Admin\Usecase\DeleteFormHandlersUsecase();
        $usecase->run($formIds);
    }

    public function update($data) {

        $data['id'] = $this->updateItem($data);

        if (!empty($data['deleteIcon'])) {
            $this->deleteFile($data['id'], 'icon');
        } else {
        	$images = selectDirFiles(FILES_S.'temp/'.$data['userDir'].'/icon/');
            if (!empty($images)) {
                $this->updateImage($data, $images[0]);
                unlink(FILES_S.'temp/'.$data['userDir'].'/icon/'.$images[0]);
            }
        }

        if (empty($data['bgExistFileName'])) {
            $this->deleteFile($data['id'], 'bg');
        } else {
            $this->deleteNoExistFileNames($data['id'], 'bg', $data['bgExistFileName']);
        }
        if (!empty($data['bgNew'])) {
           foreach($data['bgNew'] as $key=>$value) {
             $this->insertBg($data, $data['bgFileName'][$key], 'bg', $key);
           }
        }

        if (!empty($data['datas']['fileType']) && $data['datas']['fileType'] === 'file')
        {
            $file = selectDirFiles(FILES_S.'temp/'.$data['userDir'].'/file/');
            if (!empty($file))
            {
                $this->updateFile($data, $file[0], 'file');
            }

            $file1 = selectDirFiles(FILES_S.'temp/'.$data['userDir'].'/file1/');
            if (!empty($file1))
            {
                $this->updateFile($data, $file1[0], 'file1');
            }
        }

        $this->deleteTmpFiles($data['userDir']);
        return $data['id'];
    }

    public function createCss($pageId) {
        $adap = $adap2 = $animb = $prs = [];
        $css = '';
        $data = $this->findById($pageId);
        if ($data['viewport'] === '1') main::mapper('block_core')->correctViewport($pageId);
        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'block_adaptive WHERE pageId = '.(int)$pageId.' ORDER BY swidth DESC');
        while ($res = $r->fetch_assoc()) {
            $res['swidth'] = (float)$res['swidth'];
            $adap[$res['swidth']][] = $res;
            if (!isset($adap2[$res['id']])) $adap2[$res['id']] = $res;
        }
        $style = '';
	    $d = $data['datas'];
	    $d['id'] = $data['id'];
	    $d['templateId'] = $data['templateId'];
	    $style = include(ROOT_PATH.'skinss/template/core/css/page.php');
        $bs = main::mapper('block_core')->findNodesByPageId($pageId);
        if ($data['templateId']) $prs = main::mapper('block_core')->findParentsByPageId($data['templateId']);
        foreach($bs as $bId => $b) {
        	if (isset($b['settings']['screenreader'])) continue;
        	if (!empty($b['settings']['effs'])) $animb[$b['settings']['effs']] = 1;
        	if (isset($adap2[$b['id']])) $b = array_merge($b, $adap2[$b['id']]);
            $m = explode('_', $b['service']);
            $d = $b['datas'];
            $nz = '#';
            if ($b['service'] != 'content_core') {
                $parent = false;
                if (isset($bs[$b['parentId']])) $parent = $bs[$b['parentId']];
                else if(isset($prs[$b['parentId']])) $parent = $prs[$b['parentId']];
                if ($parent && ($parent['service'] == 'scrollH_gallery' || $parent['service'] == 'slideshow_gallery')) $nz = '.';
	            $style .= $nz.'i'.$bId.'{';
	            if (empty($b['bwidthType'])) $style .= 'width:'.$b['bwidth'].'px;';
	            elseif ($b['bwidthType'] == 'a') $style .= 'width:auto;';
	            else  $style .= 'width:'.$b['bwidth'].$b['bwidthType'].';';
	            if (empty($b['bheightType'])) $style .= 'height:'.$b['bheight'].'px;';
	            elseif ($b['bheightType'] == 'a') $style .= 'height:auto;';
	            else  $style .= 'height:'.$b['bheight'].$b['bheightType'].';';
				if ($b['minwidth']) {
				    if (empty($b['minwidthType'])) $style .= 'min-width:'.$b['minwidth'].'px;';
				    elseif ($b['minwidthType'] == '%') $style .= 'min-width:'.$b['minwidth'].'%;';
				}
				if ($b['maxwidth']) {
					if (empty($b['maxwidthType'])) {
						if ($parent && $parent['service'] == 'scrollH_gallery' && !empty($parent['settings']['countItem'])) {
						} else $style .= 'max-width:'.$b['maxwidth'].'px;';
					} elseif ($b['maxwidthType'] == '%') $style .= 'max-width:'.$b['maxwidth'].'%;';
				}
				if ($b['minheight']) {
				    if (empty($b['minheightType'])) $style .= 'min-height:'.$b['minheight'].'px;';
				    elseif ($b['minheightType'] == '%') $style .= 'min-height:'.$b['minheight'].'%;';
				}
				if ($b['maxheight']) {
				    if (empty($b['maxheightType'])) $style .= 'max-height:'.$b['maxheight'].'px;';
				    elseif ($b['maxheightType'] == '%') $style .= 'max-height:'.$b['maxheight'].'%;';
				}
				if (empty($b['inlineb'])) {
	            	$style .= 'position:absolute;z-index:'.($b['zindex']+2).';';
	                if ($b['btopPos'] != 'center') $style .= $b['btopPos'].':'.$b['btop'].($b['btopType'] == '%' ? '%' : 'px').';';
	                if ($b['bleftPos'] != 'center') $style .= $b['bleftPos'].':'.$b['bleft'].($b['bleftType'] == '%' ? '%' : 'px').';';
	                if ($b['btopPos'] == 'center' && $b['bleftPos'] == 'center' && $b['bheightType'] == 'a' && $b['bwidthType'] == 'a') {
	                    $style .= 'left:50%;top:50%;transform:translate(-50%,-50%);';
	                } elseif ($b['btopPos'] == 'center' && $b['bleftPos'] == 'center' && $b['bheightType'] != 'a' && $b['bwidthType'] != 'a') {
	                    $style .= 'top:0;bottom:0;left:0;right:0;margin:auto;';
	                } else {
	                    if ($b['btopPos'] == 'center') {
	                        if ($b['bheightType'] == 'a') $style .= 'top:50%;transform:translateY(-50%);';
	                        else $style .= 'top:0;bottom:0;';
	                    }
	                    if ($b['bleftPos'] == 'center') {
	                        if ($b['bwidthType'] == 'a') $style .= 'left:50%;transform:translateX(-50%);';
	                        else $style .= 'left:0;right:0;';
	                    }
	                    $style .= 'margin:'.($b['bheightType'] == 'a' ? '0' : 'auto').' '.($b['bwidthType'] == 'a' ? '0' : 'auto').';';
	                }
				} elseif ($b['inlineb'] == '2') {
					if ($b['bwidthType'] == 'a' || $b['bwidthType'] == '%') $style .= 'white-space:nowrap;';
					if (empty($b['bhide']))  $style .= 'display:block;';
	            } else {
                     $padding = '';
			         if ($parent) {
			            if (!empty($parent['datas']['tpaddT']) || !empty($parent['datas']['tpaddB']) || !empty($parent['datas']['tpaddR']) || !empty($parent['datas']['tpaddL'])) {
	                        if ($b['bwidthType'] == '%') $padding = 'padding';
	                        else {
	                        	$style .= 'padding:0;';
	                        	$padding = 'margin';
	                        }
	                        $style .= $padding.':'.$parent['datas']['tpaddT'].(empty($parent['datas']['tpaddTType']) ? 'px' : '%').' '.$parent['datas']['tpaddR'].(empty($parent['datas']['tpaddRType']) ? 'px' : '%').' '.$parent['datas']['tpaddB'].(empty($parent['datas']['tpaddBType']) ? 'px' : '%').' '.$parent['datas']['tpaddL'].(empty($parent['datas']['tpaddLType']) ? 'px' : '%').';';
			            }
                    }
                    if ($padding != 'margin') $style .= 'margin:0;';
	            	$style .= 'position:relative;z-index:'.($b['service'] == 'menu_core' ? '20' : '2').';vertical-align:top;';
	            	if (empty($b['bhide']))  $style .= 'display:inline-block;';
	            }
	            if (!empty($b['bhide'])) $style .= 'display:none;';
	            $style .= '}';
	            if ($b['service'] == 'image_core' || $b['service'] == 'image_gallery')
                {
		            if (!empty($d['tAlign']) && ($d['tAlign'] == 'right' || $d['tAlign'] == 'left')) {
					    if ($b['bheightType'] == 'a') {
					    	$style .= $nz.'b'.$b['id'].' figcaption{display:table-cell;'.($d['tAlign'] == 'left' ? 'float:right;' : '').'}';
					    }
					    else $style .= $nz.'b'.$b['id'].' figcaption{display:block;}';
					}
	            }
                else if ($b['service'] == 'scrollH_gallery' || $b['service'] == 'slideshow_gallery')
                {
                    if ($b['bheightType'] == 'a') $style .= $nz.'b'.$b['id'].' .slick-list,'.$nz.'b'.$b['id'].' .slick-track{height:auto;}';
                    else $style .= $nz.'b'.$b['id'].' .slick-list,'.$nz.'b'.$b['id'].' .slick-track{height:100%;}';
                    if ($b['service'] == 'slideshow_gallery') {
                        if ($b['bheightType'] == 'a') $style .= $nz.'b'.$b['id'].' .slick-slide{height:auto;}';
                        else $style .= $nz.'b'.$b['id'].' .slick-slide{height:100%;}';
                    }
                }
                else if ($b['service'] == 'youtube_core')
                {
                    $arX = !empty($b['settings']['arX']) ? $b['settings']['arX'] : 16;
                    $arY = !empty($b['settings']['arY']) ? $b['settings']['arY'] : 9;
                    if ($b['bheightType'] == 'a' || isset($b['settings']['zoom2']))
                    {
                        $style .= $nz.'b'.$b['id'].' .bgVY2{padding-bottom:'.(($arY/$arX) * 100).'%;height:0}';
                    }
                    else
                    {
                        $style .= $nz.'b'.$b['id'].' .bgVY2{padding-bottom:0;height:100%}';
                    }
                }
            }

            if ($b['service'] != 'audio_core' && $b['service'] != 'line_core' && $b['service'] != 'lineV_core' && $b['service'] != 'rectangle_core' && $b['service'] != 'video_core' && $b['service'] != 'youtube_core' && $b['service'] != 'content_core') {
	            $fdata = '';
	            if ($b['fs1'] !== '') {
	              if ($b['fsType'] == 'calc') $fdata .= 'font-size:calc('.$b['fs1'].');';
	              else $fdata .= 'font-size:'.$b['fs1'].$b['fsType'].';';
	            }
	            if (!empty($b['fw'])) $fdata .= 'font-weight:'.$b['fw'].';';
	            if ($b['lh1'] !== '') {
	              if ($b['lhType'] == 'calc') $fdata .= 'line-height:calc('.$b['lh1'].');';
	              else $fdata .= 'line-height:'.$b['lh1'].$b['lhType'].';';
	            }
	            if ($b['ls1'] !== '') {
	              if ($b['lsType'] == 'calc') $fdata .= 'letter-spacing:calc('.$b['ls1'].');';
	              else $fdata .= 'letter-spacing:'.$b['ls1'].$b['lsType'].';';
	            }
	            if (!empty($b['textAlign'])) $fdata .= 'text-align:'.$b['textAlign'].';';
	            if ($fdata) {
	                if ($b['service'] == 'image_core' || $b['service'] == 'image_gallery') $style .= $nz.'i';
	                else $style .= $nz.'b';
		            $style .= $bId.'{'.$fdata.'}';
	            }
            }
            $style .= include(ROOT_PATH.'skinss/template/'.$m[1].'/css/'.$m[0].'.php');
        }
        if (!empty($animb)) $style .= include(ROOT_PATH.'skinss/template/core/css/animation.php');
        if (!empty($adap)) {
          $bpsw = main::mapper('config_settings')->getAdaptivePoints();
          $points = [];
          $prevKey = 0;
          foreach($bpsw as $key => $val) {
             if (!$val) $points[$key] = $key;
             if ($prevKey) $points[$prevKey] = $key;
             $prevKey = $key;
          }
          foreach($adap as $key => $val) {
            $cont = '';
            foreach($val as $k2 => $v2) {
            	if (isset($bs[$v2['id']]['settings']['screenreader'])) continue;
            	$nz = '#';
            	if (isset($adap2[$v2['id']]) && $key == $adap2[$v2['id']]['swidth']) continue;
                $parent = false;
                if (isset($bs[$v2['id']]))
                {
                    if (isset($bs[$bs[$v2['id']]['parentId']]))
                    {
                        $parent = $bs[$bs[$v2['id']]['parentId']];
                    }
                    else if(isset($prs[$bs[$v2['id']]['parentId']]))
                    {
                        $parent = $prs[$bs[$v2['id']]['parentId']];
                    }
                }
                if ($v2['service'] == 'content_core') {
                	$cont .= '#pgc_'.$v2['id'].'{'.(empty($v2['bhide']) ? 'display:block;' : 'display:none;').'}';
                     if (isset($bs[$v2['id']]['settings']['zoom3']) && !isset($bs[$v2['id']]['settings']['virtualW'])) {
                        $cont .= '.bgFWidth'.$v2['id'].'{';
                        if ($v2['bheightType'] == 'a') {
                           if (!empty($v2['minheight'])) {
                              if (empty($v2['minheightType'])) $cont .= 'min-height:'.$v2['minheight'].'px;';
                              elseif ($v2['minheightType'] == '%') $cont .= 'min-height:'.$v2['minheight'].'vh;';
                           } else $cont .= 'min-height:0;';
                        }
                        if (empty($v2['bwidthType'])) $cont .= 'width:'.$v2['bwidth'].'px;';
                        elseif ($v2['bwidthType'] == '%') $cont .= 'width:'.$v2['bwidth'].'%;';
                        if (!empty($v2['minwidth'])) {
                           if (empty($v2['minwidthType'])) $cont .= 'min-width:'.$v2['minwidth'].'px;';
                           elseif ($v2['minwidthType'] == '%') $cont .= 'min-width:'.$v2['minwidth'].'%;';
                        } else $cont .= 'min-width:0;';
                           if (!empty($v2['maxwidth'])) {
                              if (empty($v2['maxwidthType'])) $cont .= 'max-width:'.$v2['maxwidth'].'px;';
                              elseif ($v2['maxwidthType'] == '%') $cont .= 'max-width:'.$v2['maxwidth'].'%;';
                           } else $cont .= 'max-width:none;';
                        $cont .= '}';
                    }
                    $cont .= '#c_'.$v2['id'].'{';
					if ($v2['bheightType'] == 'a') {
						if (!empty($v2['minheight'])) {
						    if (empty($v2['minheightType'])) $cont .= 'min-height:'.$v2['minheight'].'px;';
						    elseif ($v2['minheightType'] == '%') $cont .= 'min-height:'.$v2['minheight'].'vh;';
						} else $cont .= 'min-height:0;';
					}
	                if (empty($v2['bwidthType'])) $cont .= 'width:'.$v2['bwidth'].'px;';
	                elseif (isset($bs[$v2['id']]['settings']['virtualW']) && $v2['bwidthType'] == '%') $cont .= 'width:'.$v2['bwidth'].'%;';
	                else $cont .= 'width:100%;';
					if (!empty($v2['minwidth'])) {
					    if (empty($v2['minwidthType'])) $cont .= 'min-width:'.$v2['minwidth'].'px;';
					    elseif (isset($bs[$v2['id']]['settings']['virtualW']) && $v2['minwidthType'] == '%') $cont .= 'min-width:'.$v2['minwidth'].'%;';
					    else $cont .= 'min-width:0;';
					} else $cont .= 'min-width:0;';
					if (!empty($v2['maxwidth'])) {
					    if (empty($v2['maxwidthType'])) $cont .= 'max-width:'.$v2['maxwidth'].'px;';
					    elseif (isset($bs[$v2['id']]['settings']['virtualW']) && $v2['maxwidthType'] == '%') $cont .= 'max-width:'.$v2['maxwidth'].'%;';
					    else $cont .= 'max-width:none;';
					} else $cont .= 'max-width:none;';
                    $cont .= '}#b'.$v2['id'].',.b'.$v2['id'].'{';

                    if (isset($bs[$v2['id']]['settings']['virtualW'])) $cont .= 'width:100%;';
                    elseif ($v2['bwidthType'] == '%') $cont .= 'width:'.$v2['bwidth'].'%;';

                    if (!empty($v2['minheight'])) {
                        if (empty($v2['minheightType'])) $cont .= 'min-height:'.$v2['minheight'].'px;';
                        elseif ($v2['minheightType'] == '%') $cont .= 'min-height:'.$v2['minheight'].'vh;';
                    } else $cont .= 'min-height:0;';
                    if (!empty($v2['maxheight'])) {
                        if (empty($v2['maxheightType'])) $cont .= 'max-height:'.$v2['maxheight'].'px;';
                        elseif ($v2['maxheightType'] == '%') $cont .= 'max-height:'.$v2['maxheight'].'vh;';
                    } else $cont .= 'max-height:none;';
                    if (!empty($v2['minwidth'])) {
                        if (empty($v2['minwidthType'])) $cont .= 'min-width:'.$v2['minwidth'].'px;';
                        elseif ($v2['minwidthType'] == '%') $cont .= 'min-width:'.$v2['minwidth'].'%;';
                    } else $cont .= 'min-width:0;';
                    if (!isset($bs[$v2['id']]['settings']['virtualW']) && !empty($v2['maxwidth']) && $v2['maxwidthType'] == '%') {
                        $cont .= 'max-width:'.$v2['maxwidth'].'%;';
                    } else $cont .= 'max-width:none;';
                } else {
                    if ($parent && ($parent['service'] == 'scrollH_gallery' || $parent['service'] == 'slideshow_gallery')) $nz = '.';
                    if (isset($bs[$v2['id']]) && $bs[$v2['id']]['minheight'])
                    {
                    	$cont .= $nz.'b'.$v2['id'].'{';
	                    if (!empty($v2['minheight'])) {
	                        if (empty($v2['minheightType'])) $cont .= 'min-height:'.$v2['minheight'].'px;';
	                        elseif ($v2['minheightType'] == '%') $cont .= 'min-height:'.$v2['minheight'].'%;';
	                    } else $cont .= 'min-height:0;';
	                    $cont .= '}';
	                }
                    $cont .= $nz.'i'.$v2['id'].'{';
	                if (!empty($v2['minwidth'])) {
	                    if (empty($v2['minwidthType'])) $cont .= 'min-width:'.$v2['minwidth'].'px;';
	                    elseif ($v2['minwidthType'] == '%') $cont .= 'min-width:'.$v2['minwidth'].'%;';
	                } else $cont .= 'min-width:0;';
	                if (!empty($v2['maxwidth'])) {
	                    if (empty($v2['maxwidthType'])) {
	                        if ($parent && $parent['service'] == 'scrollH_gallery' && !empty($parent['settings']['countItem'])) {
	                        } else $cont .= 'max-width:'.$v2['maxwidth'].'px;';
	                    } elseif ($v2['maxwidthType'] == '%') $cont .= 'max-width:'.$v2['maxwidth'].'%;';
	                } else $cont .= 'max-width:none;';
	                if (!empty($v2['minheight'])) {
	                    if (empty($v2['minheightType'])) $cont .= 'min-height:'.$v2['minheight'].'px;';
	                    elseif ($v2['minheightType'] == '%') $cont .= 'min-height:'.$v2['minheight'].'%;';
	                } else $cont .= 'min-height:0;';
	                if (!empty($v2['maxheight'])) {
	                    if (empty($v2['maxheightType'])) $cont .= 'max-height:'.$v2['maxheight'].'px;';
	                    elseif ($v2['maxheightType'] == '%') $cont .= 'max-height:'.$v2['maxheight'].'%;';
	                } else $cont .= 'max-height:none;';
	                if ($v2['bwidthType'] == 'a') $cont .= 'width:auto;';
	                elseif (empty($v2['bwidthType'])) $cont .= 'width:'.$v2['bwidth'].'px;';
	                else $cont .= 'width:'.$v2['bwidth'].$v2['bwidthType'].';';
                }

                if ($v2['bheightType'] == 'a') $cont .= 'height:auto;';
                elseif (empty($v2['bheightType'])) $cont .= 'height:'.$v2['bheight'].'px;';
	            else  $cont .= 'height:'.$v2['bheight'].($v2['service'] == 'content_core' && $v2['bheightType'] == '%' ? 'vh' : $v2['bheightType']).';';

                if ($v2['service'] != 'content_core') {
                    if (empty($v2['inlineb'])) {
                    	if (empty($v2['bhide'])) $cont .= 'display:inline-block;';
                        $cont .= 'position:absolute;padding:0;';
                        if (isset($bs[$v2['id']]['zindex'])) $cont .= 'z-index:'.($bs[$v2['id']]['zindex']+2).';';
                        if ($v2['btopPos'] != 'center') {
                            $cont .= $v2['btopPos'].':'.$v2['btop'].($v2['btopType'] == '%' ? '%' : 'px').';'.($v2['btopPos'] == 'bottom' ? 'top' : 'bottom').':auto;';
                        }
                        if ($v2['bleftPos'] != 'center') {
                            $cont .= $v2['bleftPos'].':'.$v2['bleft'].($v2['bleftType'] == '%' ? '%' : 'px').';'.($v2['bleftPos'] == 'left' ? 'right' : 'left').':auto;';
                        }
                        if ($v2['btopPos'] == 'center' && $v2['bleftPos'] == 'center' && $v2['bheightType'] == 'a' && $v2['bwidthType'] == 'a') {
                            $cont .= 'left:50%;top:50%;bottom:auto;right:auto;transform:translate(-50%,-50%);margin:0;';
                        } elseif ($v2['btopPos'] == 'center' && $v2['bleftPos'] == 'center' && $v2['bheightType'] != 'a' && $v2['bwidthType'] != 'a') {
                            $cont .= 'top:0;bottom:0;left:0;right:0;transform:none;margin:auto;';
                        } elseif ($v2['btopPos'] == 'center' || $v2['bleftPos'] == 'center') {
                        	$transf = 0;
                        	if ($v2['btopPos'] == 'center') {
                                if ($v2['bheightType'] == 'a') {$cont .= 'top:50%;bottom:auto;transform:translateY(-50%);';$transf = 1;}
                                else $cont .= 'top:0;bottom:0;';
                            }
                            if ($v2['bleftPos'] == 'center') {
                                if ($v2['bwidthType'] == 'a') {$cont .= 'left:50%;right:auto;transform:translateX(-50%);';$transf = 1;}
                                else $cont .= 'left:0;right:0;';
                            }
                            if (!$transf) $cont .= 'transform:none;';
                            $cont .= 'margin:'.($v2['bheightType'] == 'a' ? '0' : 'auto').' '.($v2['bwidthType'] == 'a' ? '0' : 'auto').';';
                        } else {
                            $cont .= 'transform:none;margin:0;';
                        }
                    } elseif ($v2['inlineb'] == '2') {
                    	if ($v2['bwidthType'] == 'a' || $v2['bwidthType'] == '%') $cont .= 'white-space:nowrap;';
                    	if (empty($v2['bhide'])) $cont .= 'display:block;';
                    } else {
                        $padding = '';
                        if ($parent) {
                           if (!empty($parent['datas']['tpaddT']) || !empty($parent['datas']['tpaddB']) || !empty($parent['datas']['tpaddR']) || !empty($parent['datas']['tpaddL'])) {
                               if ($v2['bwidthType'] == '%') $padding = 'padding';
                               else {
                                  $cont .= 'padding:0;';
                                  $padding = 'margin';
                               }
                               $cont .= $padding.':'.$parent['datas']['tpaddT'].(empty($parent['datas']['tpaddTType']) ? 'px' : '%').' '.$parent['datas']['tpaddR'].(empty($parent['datas']['tpaddRType']) ? 'px' : '%').' '.$parent['datas']['tpaddB'].(empty($parent['datas']['tpaddBType']) ? 'px' : '%').' '.$parent['datas']['tpaddL'].(empty($parent['datas']['tpaddLType']) ? 'px' : '%').';';
                           }
                        }
                        if ($padding != 'margin') $cont .= 'margin:0;';
                        $cont .= 'top:auto;bottom:auto;left:auto;right:auto;transform:none;position:relative;z-index:'.($v2['service'] == 'menu_core' ? '20' : '2').';vertical-align:top;';
                        if (empty($v2['bhide'])) $cont .= 'display:inline-block;';
                    }
                    if (!empty($v2['bhide'])) $cont .= 'display:none;';
                }
                $cont .= '}';
                if ($v2['service'] == 'image_core' || $v2['service'] == 'image_gallery')
                {
                    if (!empty($bs[$v2['id']]['settings']['tAlign']) && ($bs[$v2['id']]['settings']['tAlign'] == 'right' || $bs[$v2['id']]['settings']['tAlign'] == 'left')) {
                        if ($v2['bheightType'] == 'a') $cont .= $nz.'b'.$v2['id'].' figcaption{display:table-cell;float:'.($bs[$v2['id']]['settings']['tAlign'] == 'left' ? 'right' : 'none').';}';
                        else $cont .= $nz.'b'.$v2['id'].' figcaption{display:block;}';
                    }
                    if (!isset($bs[$v2['id']]['settings']['bhtall']) && (empty($bs[$v2['id']]['settings']['tAlign']) || isset($bs[$v2['id']]['settings']['coverImage']) || $bs[$v2['id']]['settings']['tAlign'] == 'center')) {
	                  if (isset($bs[$v2['id']]['settings']['aload']) || isset($parent['settings']['aload'])) {
					    if (!empty($bs[$v2['id']]['files']['small']['width']) && $v2['bheightType'] == 'a' && $v2['bwidthType'] != 'a') {
					      $cont .= $nz.'b'.$v2['id'].':before{content:"";display:block;height:0;padding-bottom:'.(($bs[$v2['id']]['files']['small']['height']*100)/$bs[$v2['id']]['files']['small']['width']).'%;}';
					      $cont .= $nz.'b'.$v2['id'].' .bl{object-fit:fill;position:absolute;top:0;left:0;box-sizing:border-box;padding:inherit;}';
					    } else if ($v2['bheightType'] != 'a') {
					      $cont .= $nz.'b'.$v2['id'].':before{content:none;}';
					      $cont .= $nz.'b'.$v2['id'].' .bl{height:100%;object-fit:cover;position:static;padding:0;}';
					    }
					  } else {
					    if ($v2['bheightType'] != 'a') $cont .= $nz.'b'.$v2['id'].' .bl{height:100%;object-fit:cover;}';
						else $cont .= $nz.'b'.$v2['id'].' .bl{height:auto;object-fit:fill;}';
					  }
                    }
                }
                else if ($v2['service'] == 'scrollH_gallery' || $v2['service'] == 'slideshow_gallery')
                {
                    if ($v2['bheightType'] == 'a') $cont .= $nz.'b'.$v2['id'].' .slick-list,'.$nz.'b'.$v2['id'].' .slick-track{height:auto;}';
                    else $cont .= $nz.'b'.$v2['id'].' .slick-list,'.$nz.'b'.$v2['id'].' .slick-track{height:100%;}';
                    if ($v2['service'] == 'slideshow_gallery') {
                        if ($v2['bheightType'] == 'a') $cont .= $nz.'b'.$v2['id'].' .slick-slide{height:auto;}';
                        else $cont .= $nz.'b'.$v2['id'].' .slick-slide{height:100%;}';
                    }
                }
                else if ($v2['service'] == 'youtube_core')
                {
                    $arX = !empty($bs[$v2['id']]['settings']['arX']) ? $bs[$v2['id']]['settings']['arX'] : 16;
                    $arY = !empty($bs[$v2['id']]['settings']['arY']) ? $bs[$v2['id']]['settings']['arY'] : 9;
                    if ($v2['bheightType'] == 'a' || isset($bs[$v2['id']]['settings']['zoom2']))
                    {
                        $cont .= $nz.'b'.$v2['id'].' .bgVY2{padding-bottom:'.(($arY/$arX) * 100).'%;height:0}';
                    }
                    else
                    {
                        $cont .= $nz.'b'.$v2['id'].' .bgVY2{padding-bottom:0;height:100%}';
                    }
                }
                if ($v2['service'] != 'audio_core' && $v2['service'] != 'line_core' && $v2['service'] != 'lineV_core' && $v2['service'] != 'rectangle_core' && $v2['service'] != 'video_core' && $v2['service'] != 'youtube_core') {
	                $fdata = '';
	                if ($v2['fs1'] !== '') {
	                  if ($v2['fsType'] == 'calc') $fdata .= 'font-size:calc('.$v2['fs1'].');';
	                  else $fdata .= 'font-size:'.$v2['fs1'].$v2['fsType'].';';
	                } else $fdata .= 'font-size:inherit;';
	                if ($v2['fw'] !== '') $fdata .= 'font-weight:'.$v2['fw'].';';
	                else $fdata .= 'font-weight:inherit;';
	                if ($v2['lh1'] !== '') {
	                  if ($v2['lhType'] == 'calc') $fdata .= 'line-height:calc('.$v2['lh1'].');';
	                  else $fdata .= 'line-height:'.$v2['lh1'].$v2['lhType'].';';
	                } else $fdata .= 'line-height:inherit;';
	                if ($v2['ls1'] !== '') {
	                  if ($v2['lsType'] == 'calc') $fdata .= 'letter-spacing:calc('.$v2['ls1'].');';
	                  else $fdata .= 'letter-spacing:'.$v2['ls1'].$v2['lsType'].';';
	                } else $fdata .= 'letter-spacing:inherit;';
	                if ($v2['service'] == 'image_core' || $v2['service'] == 'image_gallery') $cont .= $nz.'i';
	                else $cont .= $nz.'b';
	                if (!empty($v2['textAlign'])) $fdata .= 'text-align:'.$v2['textAlign'].';';
	                $cont .= $v2['id'].'{'.$fdata.'}';
                }
            }
            if (!empty($cont)) {
               if (isset($points[$key])) $style .= '@media(max-width:'.($points[$key]-1).'px){'.$cont.'}';
            }
          }
          unset($adap, $cont, $bpsw, $points);
        }
        if (!file_exists(FILES_S.'styles')) mkdir(FILES_S.'styles');
        $fp = fopen(FILES_S.'styles/'.$pageId.'.css', 'w');
        fwrite($fp, $style);
        fclose($fp);
        $this->updateDate($pageId);
        $this->con->query('UPDATE '.DB_PREFIX.'page SET createCss = 0 WHERE id = '.$pageId);
        unset($bs, $style, $data);
    }

    public function insertBg($data, $fileName, $type, $seq = 0)
    {
        $ext = substr(strrchr($fileName, '.'), 1);
        $name = uniqid().'.'.$ext;
        if ($this->issetFileName($name))
        {
            $name = $this->uniqFile($ext);
        }

        copy(FILES_S.'temp/'.$data['userDir'].'/img'.$type.'/'.$fileName, FILES_S.'page/'.$name);

        list ($wReal, $hReal, $tReal) = getimagesizenew(FILES_S.'page/'.$name);
        $this->con->query('INSERT INTO '.DB_PREFIX.'page_file (id, fileName, width, height, type, seq) VALUES ('.$data['id'].', "'.$this->con->real_escape_string($name).'", '.(int)$wReal.', '.(int)$hReal.', "'.$type.'", '.(int)$seq.')');

    }

	public function clones($id) {
    	$data = $this->findMultiById($id);

    	$data['create'] = 1;
        $data['action'] = 'edit';
        unset($data['id']);
        $data['path'] = 'page'.$this->nextSeq();
        $data['baseName'] = 'Clone '.$data['baseName'];

		$data['id'] = $this->updateItem($data);

		main::mapper('color_core')->clones($id, $data['id'], 0);
		main::mapper('block_core')->clonesPage($id, $data['id']);
		if (!empty($data['vars'])) {
            $this->con->query('INSERT INTO '.DB_PREFIX.'vars (`pageId`, `name`, `value`) (SELECT '.(int)$data['id'].', `name`, `value` FROM '.DB_PREFIX.'vars WHERE `pageId` = '.(int)$id.')');
		}
        if (!empty($data['files'])) $this->clonesFiles($data);
    }

    public function clonesFiles($data) {
        $values = [];
        foreach($data['files'] as $type=>$file) {
            if ($type == 'icon') $pref = '';
            elseif ($type == 'bg') {
		        foreach($file as $key=>$value2) {
		            $pref = $type.$key;
                    $ext = substr(strrchr($value2['fileName'], '.'), 1);
		            $name = $pref.$data['id'].'.'.$ext;
		            if ($this->issetFileName($name))
                    {
                        $name = $this->uniqFile($ext);
                    }
		            copy(FILES_S.'page/'.$value2['fileName'], FILES_S.'page/'.$name);
		            $values[] = '('.(int)$data['id'].', '.(int)$value2['width'].', '.(int)$value2['height'].', "'.$this->con->real_escape_string($name).'", "'.$this->con->real_escape_string($type).'", '.(int)$value2['typeId'].','.(int)$value2['seq'].')';
		        }
		        continue;
            } else $pref = $type;

            $ext = substr(strrchr($file['fileName'], '.'), 1);
            $name = $pref.$data['id'].'.'.$ext;
            if ($this->issetFileName($name))
            {
                $name = $this->uniqFile($ext);
            }

            copy(FILES_S.'page/'.$file['fileName'], FILES_S.'page/'.$name);
            $values[] = '('.(int)$data['id'].', '.(int)$file['width'].', '.(int)$file['height'].', "'.$this->con->real_escape_string($name).'", "'.$this->con->real_escape_string($type).'", '.(int)$file['typeId'].','.(int)$file['seq'].')';
        }
        if (!empty($values)) {
            $this->con->query('INSERT IGNORE INTO '.DB_PREFIX.'page_file (id, width, height, fileName, type, typeId, seq) VALUES '.implode(',',$values));
        }

    }

    public function getLangs()
    {
        $return = [];

        $r = $this->con->query('SELECT langId FROM '.DB_PREFIX.'page GROUP BY langId');
        while ($result = $r->fetch_assoc())
        {
            $return[] = $result['langId'];
        }

        return $return;
    }
}