<?php
use Common\Lib\DB;

class config_settings_mapper
{
    private $con;
	private $c = array();

    public function __construct()
    {
        $this->con = DB::connection();
    }

    public function getData($clearCash = false) {
        if (!$clearCash && !empty($this->c)) return $this->c;

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'settings_main WHERE id = 1');
        $this->c = $r->fetch_assoc();
        $this->c['bpsw'] = $this->c['bpsw'] ? unserialize($this->c['bpsw']) : array();
        return $this->c;

    }

    public function setVersion($nversion = '', $cversion = '') {
        $where = '';

        if (!empty($cversion)) $where .= ', cversion = "'.$this->con->real_escape_string(trim($cversion)).'"';
        if (!empty($nversion)) $where .= ', nversion = "'.$this->con->real_escape_string(trim($nversion)).'"';

        $this->con->query('UPDATE '.DB_PREFIX.'settings_main
                              SET nversionTime = '.mktime(date("H"), 0, 0, date("m"), date("d"), date("Y")).
                              $where.'
                            WHERE id = 1');

    }

    public function getAdaptivePoints() {
        if (!empty($this->c)) return $this->c['bpsw'];
        $this->getData();
        return $this->c['bpsw'];

    }

    public function setAdaptivePoints($bpsw) {

        $this->con->query('UPDATE '.DB_PREFIX.'settings_main
                              SET bpsw = "'.(!empty($bpsw) ? $this->con->real_escape_string(serialize($bpsw)) : '').'"
                            WHERE id = 1');

        $this->c['bpsw'] = $bpsw;

    }

}