<?php
use Common\Lib\DB;

class coupon_settings_mapper
{
    private $con;

    public function __construct()
    {
        $this->con = DB::connection();
    }

    public function listItems($text = '', $startLimit = 0, $endLimit = NULL) {
        $return = array();
        $where = $limit = '';
        if ($endLimit != NULL) $limit = ' LIMIT '.(int)$startLimit.','.(int)$endLimit;
        if (!empty($text)) {
            $where = ' WHERE code LIKE "%'.trim($this->con->real_escape_string($text)).'"';
        }
        $r = $this->con->query('SELECT *, UNIX_TIMESTAMP(expire) as expire FROM '.DB_PREFIX.'order_coupon'.$where.' ORDER BY id DESC'.$limit);
        while ($result = $r->fetch_assoc()) {
            $return[] = $result;
        }
        return $return;
    }

    public function countItems($text) {
    	$where = '';
        if (!empty($text)) {
            $where = ' WHERE code LIKE "%'.trim($this->con->real_escape_string($text)).'"';
        }
        $r = $this->con->query('SELECT count(*) as count FROM '.DB_PREFIX.'order_coupon'.$where);
        $result = $r->fetch_assoc();
        return (int)$result['count'];
    }

    public function findMultiById($id)
    {
        $return = false;

        if (isset($_REQUEST['create']) && !isSubmit()) {
            return $return;
        }

        if ($id) {
            $r = $this->con->query('SELECT *, UNIX_TIMESTAMP(expire) as expire FROM '.DB_PREFIX.'order_coupon WHERE id = '.(int)$id);
            $return = $r->fetch_assoc();
        }
        if ($return) {
            $return['expire'] = date('d.m.Y', $return['expire']);
        }

        if (isSubmit()) {
            if ($return) {
                $return = array_merge($return, $_REQUEST);
            } else {
                $return = $_REQUEST;
            }
        }

        return $return;

    }

    public function update($data) {
        if (!empty($data['expire'])) {
           $tDate = explode('.', $data['expire']);
           $data['expire'] = $tDate[2].'-'.$tDate[1].'-'.$tDate[0];
        } else {
           $data['expire'] = date("Y").'-'.(date("m")+1).'-'.date("d");
        }

        $this->con->query('UPDATE '.DB_PREFIX.'order_coupon
                             SET code = "'.$this->con->real_escape_string($data['code']).'",
		                         discount = '.$data['discount'].',
		                         discountType = "'.$this->con->real_escape_string($data['discountType']).'",
		                         isMinPrice = '.(isset($data['isMinPrice']) ? 1 : 0).',
		                         minPrice = '.$data['minPrice'].',
		                         isUsedTime = '.(isset($data['isUsedTime']) ? 1 : 0).',
		                         usedTime = '.(int)$data['usedTime'].',
		                         isExpire = '.(isset($data['isExpire']) ? 1 : 0).',
		                         expire = "'.$this->con->real_escape_string($data['expire']).'"
                             WHERE id = '.$data['id']);
    }

    public function insert($data) {
        if (!empty($data['expire'])) {
           $tDate = explode('.', $data['expire']);
           $data['expire'] = $tDate[2].'-'.$tDate[1].'-'.$tDate[0];
        } else {
           $data['expire'] = date("Y").'-'.(date("m")+1).'-'.date("d");
        }
        for($i=0;$i<$data['countCoupons'];$i++) {
        	$insert[] = '("'.$this->con->real_escape_string('cup-'.substr(md5(rand(0, 99999).' '.time()), rand(0, 4), 5)).'-'.substr(md5(rand(0, 99999).' '.time()), rand(0, 4), 5).'",
        	              '.$data['discount'].',
        	              "'.$this->con->real_escape_string($data['discountType']).'",
        	              '.(isset($data['isMinPrice']) ? 1 : 0).',
        	              '.$data['minPrice'].',
        	              '.(isset($data['isUsedTime']) ? 1 : 0).',
        	              '.(int)$data['usedTime'].',
        	              '.(isset($data['isExpire']) ? 1 : 0).',
        	              "'.$this->con->real_escape_string($data['expire']).'")';
        }
        if ($data['countCoupons'] < 30) {
        	$this->con->query('INSERT IGNORE INTO '.DB_PREFIX.'order_coupon (code, discount, discountType, isMinPrice, minPrice, isUsedTime, usedTime, isExpire, expire) VALUES '.implode(',', $insert));
        } else {
        	for($i=0;$i<$data['countCoupons'];$i+=30) {
               $this->con->query('INSERT IGNORE INTO '.DB_PREFIX.'order_coupon (code, discount, discountType, isMinPrice, minPrice, isUsedTime, usedTime, isExpire, expire) VALUES '.implode(',', array_slice($insert, $i, 30)));
        	}
        }
    }

    public function delete($id) {
        $where = $where2 = '';
        if (empty($id)) return;
        if (is_array($id)) {
          foreach($id as $key => $value) $id[$key] = (int)$value;
             $where = 'id IN ('.implode(',',$id).')';
             $where2 = 'couponId IN ('.implode(',',$id).')';
        } else {
          $where = 'id ='.(int)$id;
          $where2 = 'couponId ='.(int)$id;
        }
        if (!$where) return;
        $this->con->query('DELETE FROM '.DB_PREFIX.'order_coupon WHERE '.$where);
        $this->con->query('UPDATE '.DB_PREFIX.'order SET couponId = 0 WHERE '.$where2);
    }

}