<?php
use Common\Lib\DB;

class licence_settings_mapper
{
    private $con;

    public function __construct()
    {
        $this->con = DB::connection();
    }

    public function findMultiById($id) {
    	$IDN = new \idna_convert(array('idn_version'=>2008));
    	$p = array();
    	$r = $this->con->query('SELECT domain FROM '.DB_PREFIX.'temp_domains');
        while($ret = $r->fetch_assoc()) {
        	$dom = $IDN->decode($ret['domain']);
        	$p['list'][] = $dom;
        }
        if (!empty($p['list'])) sort($p['list']);

        $dd = main::mapper('domain_core')->findById(1);
        if ($dd['dateTime'] == 0)
        {
		    $p['tDays'] = 14;
		}
        else
        {
            $p['tDays'] = (int) ($dd['dateTime'] - mktime(0, 0, 0, date("m"),date("d"), date("Y"))) / 60 / 60 / 24;
        }

        return $p;
    }

    public function update($data) {

        $_REQUEST['data'] = trim($_REQUEST['data']);
        $_REQUEST['domain'] = trim($_REQUEST['domain']);
        if (empty($_REQUEST['data']) || empty($_REQUEST['domain']) || strlen($_REQUEST['data']) < 20)
        {
            return false;
        }

        $dom = preg_replace("/^(www\.)/iUu", '', trim(trim(preg_replace("/^(https?\:\/\/)/iUu", '', $_REQUEST['domain']), '/')));
        if (function_exists('mb_strtolower')) {
           $dom = mb_strtolower($dom, 'UTF-8');
        }
        $ex = explode('/', $dom);
        $dom = $ex[0];
        $dom_encoded = '';
        $IDN = new \idna_convert(array('idn_version'=>2008));
        $dom_encoded = $IDN->encode($dom);

        $l = cp_get_contents('http://cportfolio.ru/licence.php?key='.urlencode($_REQUEST['data']).'&DOMAIN='.urlencode($dom_encoded));
        if (!$l || $l[0] !== '|')  {
            main::addError(connectionError);
            return false;
        }

        $l = ltrim($l, '|');
        if ($l == 'ok') $l = '';
        if ($l) {
            $this->con->query('INSERT INTO '.DB_PREFIX.'temp_domains (domain,licence,dateTime) VALUES ("'.$this->con->real_escape_string($dom_encoded).'","'.$this->con->real_escape_string($l).'", 0) ON DUPLICATE KEY UPDATE licence = VALUES(licence), dateTime = VALUES(dateTime)');
        } else {
            $this->con->query('DELETE FROM '.DB_PREFIX.'temp_domains WHERE domain = "'.$this->con->real_escape_string($dom_encoded).'"');
        }
        return true;

    }

    public function delete($domain) {
        $IDN = new \idna_convert(array('idn_version'=>2008));
        $domain = $IDN->encode($domain);

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'temp_domains WHERE domain = "'.$this->con->real_escape_string($domain).'"');
        $res = $r->fetch_assoc();

        if (!$res || empty($domain) || empty($res['licence']) || strlen($res['licence']) < 20) {
            return true;
        }

        $this->con->query('DELETE FROM '.DB_PREFIX.'temp_domains WHERE domain = "'.$this->con->real_escape_string($domain).'"');

        $l = cp_get_contents('http://cportfolio.ru/licence.php?action=transfer&key='.urlencode($res['licence']).'&DOMAIN='.urlencode($domain));
        $l = ltrim($l, '|');
        if ($l !== 'ok') {
            if (!$l) {
                main::addError(connectionError);
            }
            return false;
        }

        return true;

    }
}