<?php
use Shop\Entity\Order;
use Shop\Usecase\GetOrderByIdUsecase;
use Shop\Usecase\RunEventAndSaveOrderUsecase;

class paymentPayeer_settings_mapper
{
    public function success()
    {
        if (!in_array($_SERVER['REMOTE_ADDR'], array('185.71.65.92', '185.71.65.189', '149.202.17.210')))
        {
            //return;
        }

        if (!isset($_REQUEST['m_operation_id']) || !isset($_REQUEST['m_sign']) || !isset($_REQUEST['m_orderid']))
        {
            return;
        }

        $orderId = (int) $_REQUEST['m_orderid'];

        try
        {
            $ordUsecase = new GetOrderByIdUsecase();
            $ord2 = $ordUsecase->run($orderId);

            $arHash = [
                $_REQUEST['m_operation_id'],
                $_REQUEST['m_operation_ps'],
                $_REQUEST['m_operation_date'],
                $_REQUEST['m_operation_pay_date'],
                $_REQUEST['m_shop'],
                $_REQUEST['m_orderid'],
                $_REQUEST['m_amount'],
                $_REQUEST['m_curr'],
                $_REQUEST['m_desc'],
                $_REQUEST['m_status']
            ];

            if (isset($_REQUEST['m_params']))
            {
                $arHash[] = $_REQUEST['m_params'];
            }

            $arHash[] = $ord2->payment()->settings('secretKey');

            $sign_hash = strtoupper(hash('sha256', implode(':', $arHash)));

            if ($_REQUEST['m_sign'] !== $sign_hash || $_REQUEST['m_status'] !== 'success')
            {
                print $orderId.'|error';
                return;
            }

            if ($ord2->event() !== 'submit' && $ord2->event() !== 'work' && $ord2->event() !== 'cancel')
            {
                print $orderId.'|success';
                return;
            }

            if (!$ord2->payment()->id() ||
                $ord2->payment()->status() == 'off' ||
                $ord2->price() <= 0 ||
                $_REQUEST['m_amount'] != $ord2->price())
            {
                print $orderId.'|error';
                return;
            }

            includeLangConst($ord2->langId());

            $orderEvent = new RunEventAndSaveOrderUsecase($ord2);
            $orderEvent->run('paid');

            print $orderId.'|success';
        }
        catch (\Throwable $e)
        {
            print $orderId.'|error';
        }

    }

    public function getPaymentUrl(Order $ord2)
    {
        $price = number_format($ord2->price(), 2, '.', '');
        $desc = base64_encode($ord2->productName());

        $arHash = [
            $ord2->payment()->settings('merchantId'),
            $ord2->id(),
            $price,
            $ord2->payment()->currency(),
            $desc,
            $ord2->payment()->settings('secretKey')
        ];

        $sign = strtoupper(hash('sha256', implode(":", $arHash)));

        return 'https://payeer.com/merchant/'.
        '?m_shop='.$ord2->payment()->settings('merchantId').
        '&m_orderid='.$ord2->id().
        '&m_amount='.urlencode($price).
        '&m_curr='.$ord2->payment()->currency().
        '&m_desc='.urlencode($desc).
        '&m_sign='.urlencode($sign);
    }

    public function settings($p)
    {
        if (!isset($p['settings']['merchantId']))
        {
            $p['settings']['merchantId'] = '';
        }

        if (!isset($p['settings']['secretKey']))
        {
            $p['settings']['secretKey'] = '';
        }

        return $p;
    }

    public function update($data)
    {
        return $data;
    }
}