<?php
use Shop\Entity\Order;
use Shop\Usecase\GetOrderByIdUsecase;
use Shop\Usecase\RunEventAndSaveOrderUsecase;

class paymentVolet_settings_mapper
{
    public function success()
    {
        if (!in_array($_SERVER['REMOTE_ADDR'], array('50.7.115.5', '51.255.40.139')))
        {
            //return;
        }

        if (!isset($_REQUEST['ac_transfer']) || !isset($_REQUEST['ac_hash']) || !isset($_REQUEST['ac_order_id']) || !isset($_REQUEST['ac_transaction_status']))
        {
            return;
        }

        $orderId = (int) $_REQUEST['ac_order_id'];

        $ordUsecase = new GetOrderByIdUsecase();
        $ord2 = $ordUsecase->run($orderId);

        $arHash = [
            $_REQUEST['ac_transfer'],
            $_REQUEST['ac_start_date'],
            $_REQUEST['ac_sci_name'],
            $_REQUEST['ac_src_wallet'],
            $_REQUEST['ac_dest_wallet'],
            $_REQUEST['ac_order_id'],
            $_REQUEST['ac_amount'],
            $_REQUEST['ac_merchant_currency'],
            $ord2->payment()->settings('password')
        ];

        $sign_hash = hash('sha256', implode(':', $arHash));

        if ($_REQUEST['ac_hash'] !== $sign_hash || $_REQUEST['ac_transaction_status'] !== 'COMPLETED')
        {
            print 'error';
            return;
        }

        if ($ord2->event() !== 'submit' && $ord2->event() !== 'work' && $ord2->event() !== 'cancel')
        {
            return;
        }

        if (!$ord2->payment()->id() ||
            $ord2->payment()->status() == 'off' ||
            $ord2->price() <= 0 ||
            $_REQUEST['ac_amount'] != $ord2->price())
        {
            print 'error';
            return;
        }

        includeLangConst($ord2->langId());

        $orderEvent = new RunEventAndSaveOrderUsecase($ord2);
        $orderEvent->run('paid');
    }

    public function getPaymentUrl(Order $ord2)
    {
        $price = number_format($ord2->price(), 2, '.', '');

        $arHash = [
            $ord2->payment()->settings('email'),
            $ord2->payment()->settings('name'),
            $price,
            $ord2->payment()->currency(),
            $ord2->payment()->settings('password'),
            $ord2->id()
        ];

        $sign = hash('sha256', implode(":", $arHash));

        return 'https://account.volet.com/sci/'.
        '?ac_account_email='.$ord2->payment()->settings('email').
        '&ac_sci_name='.$ord2->payment()->settings('name').
        '&ac_order_id='.$ord2->id().
        '&ac_amount='.urlencode($price).
        '&ac_currency='.$ord2->payment()->currency().
        '&ac_comments='.urlencode($ord2->productName()).
        (CUR_LANG == 'ru' || CUR_LANG == 'uk' || CUR_LANG == 'kk' ? '&ac_client_lang=ru' : '').
        '&ac_sign='.urlencode($sign);
    }

    public function settings($p)
    {
        if (!isset($p['settings']['email']))
        {
            $p['settings']['email'] = '';
        }

        if (!isset($p['settings']['name']))
        {
            $p['settings']['name'] = '';
        }

        if (!isset($p['settings']['password']))
        {
            $p['settings']['password'] = '';
        }

        return $p;
    }

    public function update($data)
    {
        return $data;
    }
}