<?php
use Common\Lib\DB;

class payment_settings_mapper
{
    private $con;

    public function __construct()
    {
        $this->con = DB::connection();
    }

	public function findList($text = false) {
        $return = array();
        $r = $this->con->query('SELECT id, status'.($text ? ', text1 as baseName' : ', baseName').' FROM '.DB_PREFIX.'payment ORDER BY sequence DESC');
        while ($result = $r->fetch_assoc()) $return[$result['id']] = $result;
        return $return;
    }

    public function getStatus($id) {
        $r = $this->con->query('SELECT status FROM '.DB_PREFIX.'payment WHERE id = '.(int)$id);
        $return = $r->fetch_assoc();
        if (empty($return)) return 'off';
        return $return;
    }

    public function findMultiById($id) {

    	if (isSubmit() && !empty($_REQUEST['savepayment'])) return $_REQUEST;

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'payment WHERE id = '.(int)$id);
        $p = $r->fetch_assoc();
        if (!$p) {
        	$p['paymentSystem'] = 'Hand';
            $p['status'] = false;
            $p['method'] = false;
            $p['currency'] = false;
        }

        $p['settings'] = !empty($p['settings']) ? unserialize($p['settings']) : [];

        if (isset($_REQUEST['paymentSystem'])) $p['paymentSystem'] = $_REQUEST['paymentSystem'];
        if (isset($_REQUEST['status'])) $p['status'] = $_REQUEST['status'];
        if (isset($_REQUEST['method'])) $p['method'] = $_REQUEST['method'];
        if (isset($_REQUEST['currency'])) $p['currency'] = $_REQUEST['currency'];

        return main::mapper('payment'.$p['paymentSystem'].'_settings')->settings($p);

    }

    public function update($data) {

        $data = main::mapper('payment'.$data['paymentSystem'].'_settings')->update($data);

        if (isset($data['create'])) $data['id'] = $this->insert();

        $this->con->query('UPDATE '.DB_PREFIX.'payment
                             SET status = "'.$this->con->real_escape_string($data['status']).'",
                                 paymentSystem = "'.$this->con->real_escape_string($data['paymentSystem']).'",
                                 method = "'.$this->con->real_escape_string(isset($data['method'])  ? $data['method'] : '').'",
                                 baseName = "'.$this->con->real_escape_string($data['baseName']).'",
                                 text1 = "'.$this->con->real_escape_string($data['text1']).'",
                                 settings =  "'.(!empty($data['settings']) ? $this->con->real_escape_string(serialize($data['settings'])) : '').'",
                                 currency = "'.(isset($data['currency']) ? $this->con->real_escape_string($data['currency']) : '').'"
                             WHERE id = '.(int)$data['id']);

        $r = $this->con->query('SELECT pageId FROM '.DB_PREFIX.'block WHERE service = "submit_forms"');
        while ($pageIds = $r->fetch_assoc()) {
        	main::mapper('page_core')->updateDate($pageIds['pageId']);
        }

        return $data['id'];

    }

    public function insert() {
        $this->con->query('INSERT INTO '.DB_PREFIX.'payment (baseName, text1, settings, sequence) VALUES ("", "", "", '.$this->nextSeq().')');
        return $this->con->insert_id;
    }

    public function nextSeq() {
        $r = $this->con->query('SELECT max(sequence) as max FROM '.DB_PREFIX.'payment');
        $data = $r->fetch_assoc();
        return (int)$data['max'] + 1;
    }

    public function delete($id)
    {
        if (empty($id)) return;

        $this->con->query('DELETE FROM '.DB_PREFIX.'payment WHERE id ='. (int) $id);
        $this->con->query('UPDATE '.DB_PREFIX.'handler SET paymentId = 0 WHERE paymentId = '. (int) $id);
        $this->con->query('UPDATE '.DB_PREFIX.'order SET paymentId = 0 WHERE paymentId = '. (int) $id);
    }

    public function sort($list)
    {
        $items = explode(",", $list);
        $count = count($items)-1;
        $j=0;
        for($i = $count; $i >= 0; $i--)
        {
            $this->con->query('UPDATE '.DB_PREFIX.'payment SET sequence = '.($j++).' WHERE id = '.substr($items[$i], 1));
        }
    }
}