<?php include_once(ROOT_PATH.'config/sms/Mobizonkz.php');

class smsMobizonkz_settings_mapper {
    private $url = 'https://mobizon.kz/service/message/sendSMSMessage?output=json&api=v1';

    public function __construct() {
        $this->url .= '&apiKey='.urlencode(MobizonkzApiKey).(MobizonkzSender != '' ? '&from='.urlencode(MobizonkzSender) : '');
    }

    public function send($phones,  $mes)
    {
        $status = false;
        $okc=0;
        $url = '&text='.urlencode($mes);
        $phones2 = explode(',',$phones);
        foreach($phones2 as $key=>$value) {
            $value = trim(str_replace(array('+',' '), array('',''), $value));
            if (empty($value)) {
                continue;
            }
            $data = $this->_read_url($this->url.$url.'&recipient='.urlencode($value));
            if ($data['status']) {$okc++;$status = true;}
        }
        if (!$status) {
            throw new \Exception($data['text']);
        }
    }

    public function settings($p) {
        $p['MobizonkzApiKey']=MobizonkzApiKey;
        $p['MobizonkzSender']=MobizonkzSender;
        return $p;
    }

    public function update($data) {

        $file = file_get_contents(ROOT_PATH.'config/sms/Mobizonkz.php');
        $search = array(
            "/define\(\'MobizonkzApiKey\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'MobizonkzSender\'\,\ \'.*\'\)\;/iUu"
        );

        $replace = array(
            "define('MobizonkzApiKey', '".preg_escape_back(trim($data['MobizonkzApiKey']), "'", "\\'")."');",
            "define('MobizonkzSender', '".preg_escape_back(trim($data['MobizonkzSender']), "'", "\\'")."');"
        );

        $file = preg_replace($search, $replace, $file);
        $fp = fopen(ROOT_PATH.'config/sms/Mobizonkz.php', 'w');
        fwrite($fp, $file);
        fclose($fp);
    }

    private function _read_url($url, $time = 20) {
        $post = false;
        if (strlen($url) > 2000) $post = true;
        $ret = "";
        if (function_exists("curl_init")) {

        	$c = curl_init();
            curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($c, CURLOPT_TIMEOUT, $time);
            curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($c, CURLOPT_POST, $post);
            if ($post) {
                list($url, $post) = explode("?", $url, 2);
                curl_setopt($c, CURLOPT_POSTFIELDS, $post);
            }
            curl_setopt($c, CURLOPT_URL, $url);
            $ret = curl_exec($c);

        } elseif (function_exists("fsockopen") && strncmp($url, 'http:', 5) == 0) {

            $m = parse_url($url);
            $fp = fsockopen($m["host"], 80, $errno, $errstr, $time);

            if ($fp) {
                if(!isset($m['path'])) $m['path'] = '/';
                fwrite($fp, ($post ? 'POST '.$m['path'] : 'GET '.$m['path'].'?'.$m['query'])." HTTP/1.0\r\nHost: mobizon.kz\r\nUser-Agent: PHP".($post ? "\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: ".strlen($m['query']) : "")."\r\nConnection: Close\r\n\r\n".($post ? $m['query'] : ""));

                while (!feof($fp))
                    $ret .= fgets($fp, 1024);
                list(, $ret) = explode("\r\n\r\n", $ret, 2);
                fclose($fp);
            }

        } else {

            $ret = file_get_contents($url, false, stream_context_create(array('http' => array('timeout' => $time))));

        }
        $ret = json_decode($ret, true);
        if (empty($ret)) $ret = array('text' => 'ERROR = Connection false', 'status' => false);
        elseif ($ret['code'] != 0 && $ret['code'] != 100) $ret = array('text' => $ret['message'], 'status' => false);
        else $ret = array('text' => '', 'status' => true);
        return $ret;

    }

}