<?php include_once(ROOT_PATH.'config/sms/Proovl.php');

class smsProovl_settings_mapper {
    private $url = 'https://www.proovl.com/api/send.php';
    private $status = array('700' => 'API Disabled',
                            '701' => 'Missing "text" parameter',
                            '702' => 'Internal error',
                            '703' => 'Authorization error',
                            '704' => 'Internal error',
                            '705' => 'Incorrect callback destination',
                            '706' => 'Authorization error',
                            '707' => 'Internal error',
                            '708' => 'Incorrect "token"',
                            '709' => 'Incorrect callback destination',
                            '710' => 'Internal error',
                            '711' => 'Missing "to" parameter',
                            '712' => 'Incorrect "token"',
                            '713' => 'Missing "id" parameter',
                            '714' => 'SMS not found');

    public function __construct() {
        $this->url = ProovlApiAddress;
    }

    public function send($phones,  $mes)
    {
        $status = false;
        $okc=0;
        $url = '?token='.urlencode(ProovlToken).'&text='.urlencode($mes);
        $phones2 = explode(',',$phones);
        foreach($phones2 as $key=>$value) {
            $value = trim(str_replace(' ', '', $value));
            if (empty($value)) continue;
            $data = $this->_read_url($this->url.$url.'&to='.urlencode($value));
            if ($data['status']) {$okc++;$status = true;}
        }
        if (!$status) {
            throw new \Exception($data['text']);
        }
    }

    public function settings($p) {
        $p['ProovlApiAddress']=ProovlApiAddress;
        $p['ProovlToken']=ProovlToken;
        return $p;
    }

    public function update($data) {

        $file = file_get_contents(ROOT_PATH.'config/sms/Proovl.php');
        $search = array(
            "/define\(\'ProovlApiAddress\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'ProovlToken\'\,\ \'.*\'\)\;/iUu"
        );

        $replace = array(
            "define('ProovlApiAddress', '".preg_escape_back(trim($data['ProovlApiAddress']), "'", "\\'")."');",
            "define('ProovlToken', '".preg_escape_back(trim($data['ProovlToken']), "'", "\\'")."');"
        );

        $file = preg_replace($search, $replace, $file);
        $fp = fopen(ROOT_PATH.'config/sms/Proovl.php', 'w');
        fwrite($fp, $file);
        fclose($fp);
    }

    private function _read_url($url, $time = 20) {
        $post = true;
        $ret = "";
        if (function_exists("curl_init")) {

            static $c = 0; // keepalive
            if (!$c) {
                $c = curl_init();
                curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($c, CURLOPT_TIMEOUT, $time);
            }
            curl_setopt($c, CURLOPT_POST, $post);
            if ($post) {
                list($url, $post) = explode("?", $url, 2);
                curl_setopt($c, CURLOPT_POSTFIELDS, $post);
            }
            curl_setopt($c, CURLOPT_URL, $url);
            $ret = curl_exec($c);

        } elseif (function_exists("fsockopen") && strncmp($url, 'http:', 5) == 0) {

            $m = parse_url($url);
            $fp = fsockopen($m["host"], 80, $errno, $errstr, $time);

            if ($fp) {
                if(!isset($m['path'])) $m['path'] = '/';
                fwrite($fp, ($post ? 'POST '.$m['path'] : 'GET '.$m['path'].'?'.$m['query'])." HTTP/1.0\r\nHost: www.proovl.com\r\nUser-Agent: PHP".($post ? "\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: ".strlen($m['query']) : "")."\r\nConnection: Close\r\n\r\n".($post ? $m['query'] : ""));

                while (!feof($fp))
                   $ret .= fgets($fp, 1024);
                list(, $ret) = explode("\r\n\r\n", $ret, 2);
                fclose($fp);
            }

        } else {

            $ret = file_get_contents($url, false, stream_context_create(array('http' => array('timeout' => $time))));

        }

        if (empty($ret)) {
            $ret = array('text' => 'ERROR = Connection false', 'status' => false);
        } else {
            $ret = explode(';',$ret);
            if ($ret[0] == "Error") $ret = array('text' => 'Error: '.(isset($this->status[$ret[1]]) ? $this->status[$ret[1]] : $ret[1]), 'status' => false);
            elseif ($ret[0] == "Rejected") $ret = array('text' => 'Error: Rejected', 'status' => false);
            else {
                if ($ret[2] == ProovlToken) {
                    $ret = array('text' => $ret[0], 'status' => true);
                } else {
                     $ret = array('text' => "Incorrect token or API address", 'status' => false);
                }
            }
        }

        return $ret;

    }
}