<?php include_once(ROOT_PATH.'config/sms/Smsckz.php');

class smsSmsckz_settings_mapper {
    private $url = 'http://smsc.kz/sys/send.php?charset=utf-8';

    public function __construct() {
        $this->url .= '&login='.urlencode(SmsckzLogin).'&psw='.urlencode(SmsckzPass).(SmsckzSender != '' ? '&sender='.urlencode(SmsckzSender) : '');
    }

    public function send($phones,  $mes)
    {
        $this->url .= '&phones='.urlencode(trim(str_replace(' ', '', $phones))).'&mes='.urlencode($mes);
        $text = $this->_read_url($this->url);
        if (empty($text)) $text = 'ERROR = Connection false';
        if(strpos($text,'ERROR') === false) {
            return true;
        } else {
            throw new \Exception((strlen($text) < 250 ? $text : substr($text, 0 , 250).'...'));
        }
    }

    public function settings($p) {
        $p['SmsckzLogin']=SmsckzLogin;
        $p['SmsckzPass']=SmsckzPass;
        $p['SmsckzSender']=SmsckzSender;
        return $p;
    }

    public function update($data) {

        $file = file_get_contents(ROOT_PATH.'config/sms/Smsckz.php');
        $search = array(
            "/define\(\'SmsckzLogin\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'SmsckzPass\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'SmsckzSender\'\,\ \'.*\'\)\;/iUu"
        );

        $replace = array(
            "define('SmsckzLogin', '".preg_escape_back(trim($data['SmsckzLogin']), "'", "\\'")."');",
            "define('SmsckzPass', '".preg_escape_back(trim($data['SmsckzPass']), "'", "\\'")."');",
            "define('SmsckzSender', '".preg_escape_back(trim($data['SmsckzSender']), "'", "\\'")."');"
        );

        $file = preg_replace($search, $replace, $file);
        $fp = fopen(ROOT_PATH.'config/sms/Smsckz.php', 'w');
        fwrite($fp, $file);
        fclose($fp);
    }

    private function _read_url($url, $time = 20) {
        $post = false;
        if (strlen($url) > 2000) $post = true;
    	$ret = "";
        if (function_exists("curl_init")) {

        	static $c = 0; // keepalive
            if (!$c) {
                $c = curl_init();
                curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($c, CURLOPT_TIMEOUT, $time);
                curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
            }
            curl_setopt($c, CURLOPT_POST, $post);
            if ($post) {
                list($url, $post) = explode("?", $url, 2);
                curl_setopt($c, CURLOPT_POSTFIELDS, $post);
            }
            curl_setopt($c, CURLOPT_URL, $url);
            $ret = curl_exec($c);

        } elseif (function_exists("fsockopen") && strncmp($url, 'http:', 5) == 0) {

            $m = parse_url($url);
            if (!$fp = fsockopen($m["host"], 80, $errno, $errstr, $time))
                $fp = fsockopen("212.24.33.196", 80, $errno, $errstr, $time);

            if ($fp) {
            	if(!isset($m['path'])) $m['path'] = '/';
                fwrite($fp, ($post ? 'POST '.$m['path'] : 'GET '.$m['path'].'?'.$m['query'])." HTTP/1.0\r\nHost: smsc.kz\r\nUser-Agent: PHP".($post ? "\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: ".strlen($m['query']) : "")."\r\nConnection: Close\r\n\r\n".($post ? $m['query'] : ""));

                while (!feof($fp))
                   $ret .= fgets($fp, 1024);
                list(, $ret) = explode("\r\n\r\n", $ret, 2);
                fclose($fp);
            }

        } else {

            $ret = file_get_contents($url, false, stream_context_create(array('http' => array('timeout' => $time))));

        }

        return $ret;

    }

}