<?php include_once(ROOT_PATH.'config/sms/Smsctj.php');

class smsSmsctj_settings_mapper {
    private $url = 'http://smsc.tj/sys/send.php?charset=utf-8';

    public function __construct() {
        $this->url .= '&login='.urlencode(SmsctjLogin).'&psw='.urlencode(SmsctjPass).(SmsctjSender != '' ? '&sender='.urlencode(SmsctjSender) : '');
    }

    public function send($phones,  $mes)
    {
        $this->url .= '&phones='.urlencode(trim(str_replace(' ', '', $phones))).'&mes='.urlencode($mes);
        $text = $this->_read_url($this->url);
        if (empty($text)) $text = 'ERROR = Connection false';
        if(strpos($text,'ERROR') === false) {
            return true;
        } else {
            throw new \Exception(strlen($text) < 250 ? $text : substr($text, 0 , 250).'...');
        }
    }

    public function settings($p) {
        $p['SmsctjLogin']=SmsctjLogin;
        $p['SmsctjPass']=SmsctjPass;
        $p['SmsctjSender']=SmsctjSender;
        return $p;
    }

    public function update($data) {

        $file = file_get_contents(ROOT_PATH.'config/sms/Smsctj.php');
        $search = array(
            "/define\(\'SmsctjLogin\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'SmsctjPass\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'SmsctjSender\'\,\ \'.*\'\)\;/iUu"
        );

        $replace = array(
            "define('SmsctjLogin', '".preg_escape_back(trim($data['SmsctjLogin']), "'", "\\'")."');",
            "define('SmsctjPass', '".preg_escape_back(trim($data['SmsctjPass']), "'", "\\'")."');",
            "define('SmsctjSender', '".preg_escape_back(trim($data['SmsctjSender']), "'", "\\'")."');"
        );

        $file = preg_replace($search, $replace, $file);
        $fp = fopen(ROOT_PATH.'config/sms/Smsctj.php', 'w');
        fwrite($fp, $file);
        fclose($fp);
    }

    private function _read_url($url) {
        $ret = "";
        static $c = 0; // keepalive
        if (!$c) {
            $c = curl_init();
            curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
        }
        list($url, $post) = explode("?", $url, 2);
        curl_setopt($c, CURLOPT_POSTFIELDS, $post);
        curl_setopt($c, CURLOPT_URL, $url);
        curl_setopt($c, CURLOPT_POST, true);
        $ret = curl_exec($c);

        return $ret;

    }

}