<?php include_once(ROOT_PATH.'config/sms/Smscua.php');

class smsSmscua_settings_mapper {
    private $url = 'http://smsc.ua/sys/send.php?charset=utf-8';

    public function __construct() {
        $this->url .= '&login='.urlencode(SmscuaLogin).'&psw='.urlencode(SmscuaPass).(SmscuaSender != '' ? '&sender='.urlencode(SmscuaSender) : '');
    }

    public function send($phones,  $mes)
    {
        $this->url .= '&phones='.urlencode(trim(str_replace(' ', '', $phones))).'&mes='.urlencode($mes);
        $text = $this->_read_url($this->url);
        if (empty($text)) $text = 'ERROR = Connection false';
        if(strpos($text,'ERROR') === false) {
            return true;
        } else {
            throw new \Exception(strlen($text) < 250 ? $text : substr($text, 0 , 250).'...');
        }


    }

    public function settings($p) {
        $p['SmscuaLogin']=SmscuaLogin;
        $p['SmscuaPass']=SmscuaPass;
        $p['SmscuaSender']=SmscuaSender;
        return $p;
    }

    public function update($data) {

        $file = file_get_contents(ROOT_PATH.'config/sms/Smscua.php');
        $search = array(
            "/define\(\'SmscuaLogin\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'SmscuaPass\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'SmscuaSender\'\,\ \'.*\'\)\;/iUu"
        );

        $replace = array(
            "define('SmscuaLogin', '".preg_escape_back(trim($data['SmscuaLogin']), "'", "\\'")."');",
            "define('SmscuaPass', '".preg_escape_back(trim($data['SmscuaPass']), "'", "\\'")."');",
            "define('SmscuaSender', '".preg_escape_back(trim($data['SmscuaSender']), "'", "\\'")."');"
        );

        $file = preg_replace($search, $replace, $file);
        $fp = fopen(ROOT_PATH.'config/sms/Smscua.php', 'w');
        fwrite($fp, $file);
        fclose($fp);
    }

    private function _read_url($url) {
        $ret = "";
        static $c = 0; // keepalive
        if (!$c) {
            $c = curl_init();
            curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
        }
        list($url, $post) = explode("?", $url, 2);
        curl_setopt($c, CURLOPT_POSTFIELDS, $post);
        curl_setopt($c, CURLOPT_URL, $url);
        curl_setopt($c, CURLOPT_POST, true);
        $ret = curl_exec($c);

        return $ret;

    }

}