<?php include_once(ROOT_PATH.'config/sms/Smspby.php');

class smsSmspby_settings_mapper {
    private $url = 'https://cabinet.smsp.by/api/?urgent=1';

    public function __construct() {
        $this->url .= '&r='.urlencode('api/msg_send').'&user='.urlencode(SmspbyLogin).'&apikey='.urlencode(SmspbyKey).(SmspbySender != '' ? '&sender='.urlencode(SmspbySender) : '');
    }

    public function send($phones,  $mes)
    {
        $url = '&recipients='.urlencode(trim(str_replace(array('+',' '), array('',''), $phones))).'&message='.urlencode($mes);
        $data = $this->_read_url($this->url.$url);
        if ($data['status'] === 'error') {
            throw new \Exception($data['text']);
        }
    }

    public function settings($p) {
        $p['SmspbyKey']=SmspbyKey;
        $p['SmspbyLogin']=SmspbyLogin;
        $p['SmspbySender']=SmspbySender;
        return $p;
    }

    public function update($data) {

        $file = file_get_contents(ROOT_PATH.'config/sms/Smspby.php');
        $search = array(
            "/define\(\'SmspbyKey\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'SmspbyLogin\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'SmspbySender\'\,\ \'.*\'\)\;/iUu"
        );

        $replace = array(
            "define('SmspbyKey', '".preg_escape_back(trim($data['SmspbyKey']), "'", "\\'")."');",
            "define('SmspbyLogin', '".preg_escape_back(trim($data['SmspbyLogin']), "'", "\\'")."');",
            "define('SmspbySender', '".preg_escape_back(trim($data['SmspbySender']), "'", "\\'")."');"
        );

        $file = preg_replace($search, $replace, $file);
        $fp = fopen(ROOT_PATH.'config/sms/Smspby.php', 'w');
        fwrite($fp, $file);
        fclose($fp);
    }

    private function _read_url($url, $time = 20) {
        $post = false;
        if (strlen($url) > 2000) $post = true;
        $ret = "";
        if (function_exists("curl_init")) {

            static $c = 0; // keepalive
            if (!$c) {
                $c = curl_init();
                curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($c, CURLOPT_TIMEOUT, $time);
                curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
            }
            curl_setopt($c, CURLOPT_POST, $post);
            if ($post) {
                list($url, $post) = explode("?", $url, 2);
                curl_setopt($c, CURLOPT_POSTFIELDS, $post);
            }
            curl_setopt($c, CURLOPT_URL, $url);
            $ret = curl_exec($c);

        } elseif (function_exists("fsockopen") && strncmp($url, 'http:', 5) == 0) {

            $m = parse_url($url);
            $fp = fsockopen($m["host"], 80, $errno, $errstr, $time);

            if ($fp) {
            	if(!isset($m['path'])) $m['path'] = '/';
                fwrite($fp, ($post ? 'POST '.$m['path'] : 'GET '.$m['path'].'?'.$m['query'])." HTTP/1.0\r\nHost: cp.smsp.by\r\nUser-Agent: PHP".($post ? "\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: ".strlen($m['query']) : "")."\r\nConnection: Close\r\n\r\n".($post ? $m['query'] : ""));

                while (!feof($fp))
                    $ret .= fgets($fp, 1024);
                list(, $ret) = explode("\r\n\r\n", $ret, 2);
                fclose($fp);
            }

        } else {

            $ret = file_get_contents($url, false, stream_context_create(array('http' => array('timeout' => $time))));

        }
        $ret = json_decode($ret, true);
        if (empty($ret)) $ret = array('text' => 'ERROR = Connection false', 'status' => 'error');
        elseif ($ret['status'] == 'error') $ret = array('text' => $ret['message'], 'status' => 'error');
        else $ret = array('text' => (int)$ret['count'], 'status' => 'ok');
        return $ret;

    }

}