<?php include_once(ROOT_PATH.'config/sms/Turbosmsua.php');

class smsTurbosmsua_settings_mapper {
    private $url = 'http://turbosms.in.ua/api/wsdl.html';

    public function send($phones,  $mes)
    {
    	$status = false;
    	$text = '';

        $client = new SoapClient($this->url);
    	$result = $client->Auth (array ('login' => TurbosmsuaLogin, 'password' => TurbosmsuaPass));
        if ($result->AuthResult.'' != 'Вы успешно авторизировались') {
            $text = $result->AuthResult;
            $connect = false;
        } else {
        	$connect = true;
        }

        $status = false;
        if ($connect) {
            $result = $client->SendSMS(array('sender' => (TurbosmsuaSender != '' ? TurbosmsuaSender : 'your_label'), 'destination' => trim(str_replace(' ', '', $phones)), 'text' => $mes));
            if (is_array($result->SendSMSResult->ResultArray)) {
                $text = $result->SendSMSResult->ResultArray[0];
            } else {
                $text = $result->SendSMSResult->ResultArray;
            }
            if ($text == 'Сообщения успешно отправлены') {
                $status = true;
            }
        }

        if (!$status) {
            throw new \Exception(strlen($text) < 250 ? $text : substr($text, 0 , 250).'...');
        }
    }

    public function settings($p) {
        $p['TurbosmsuaLogin']=TurbosmsuaLogin;
        $p['TurbosmsuaPass']=TurbosmsuaPass;
        $p['TurbosmsuaSender']=TurbosmsuaSender;
        return $p;
    }

    public function update($data) {

        $file = file_get_contents(ROOT_PATH.'config/sms/Turbosmsua.php');
        $search = array(
            "/define\(\'TurbosmsuaLogin\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'TurbosmsuaPass\'\,\ \'.*\'\)\;/iUu",
            "/define\(\'TurbosmsuaSender\'\,\ \'.*\'\)\;/iUu"
        );

        $replace = array(
            "define('TurbosmsuaLogin', '".preg_escape_back(trim($data['TurbosmsuaLogin']), "'", "\\'")."');",
            "define('TurbosmsuaPass', '".preg_escape_back(trim($data['TurbosmsuaPass']), "'", "\\'")."');",
            "define('TurbosmsuaSender', '".preg_escape_back(trim($data['TurbosmsuaSender']), "'", "\\'")."');"
        );

        $file = preg_replace($search, $replace, $file);
        $fp = fopen(ROOT_PATH.'config/sms/Turbosmsua.php', 'w');
        fwrite($fp, $file);
        fclose($fp);
    }

}