<style>
    .handler {
        display: flex;
        flex-direction: column;
        height: 100%;
    }
    .handler__filters {
        display: flex;
        gap: 30px;
        margin-bottom: 40px;
    }
    .handler__filter {
        width: 150px;
    }
</style>
<div class="handler">
    <div class="handler__filters">
        <div>
            <?= handler_core?>:<br>
            <select name="handler" id="handler" class="handler__filter">
                <option value=""></option><?php
                foreach($hTypes as $key=>$value)
                {
                    $selected = $key == $dto->handler ? ' SELECTED' : '';
                    if ($value === '') {
                        print '<option value=""></option>';
                        continue;
                    }
                    ?>
                    <option value="<?= $key?>"<?= $selected?>><?= $value?>&nbsp;</option>
                <?php }?>
            </select>
        </div>
        <?php
        $formRepo = new Admin\Repository\SqlFormRepository();
        $forms = $formRepo->listForms();
        $options = '';
        if (count($forms)) {
            foreach ($forms as $key => $value)
            {
                $options .= '<option value="'.$key.'"'.($dto->formId == $key ? ' SELECTED' : '').'>'.$value['formName'].'</option>';
            }
        }
        if ($options) {
        ?>
            <div>
                <?= form_forms?>:<br>
                <select name="formId" id="formId" class="handler__filter">
                    <option value="0"></option>
                    <?= $options?>
                </select>
            </div>
        <?php } else {?>
            <input name="formId" id="formId" type="hidden" class="handler__filter" value="0">
        <?php }?>
        <div>
            <?= goal?>:<br>
            <select name="goal" id="goal" class="handler__filter">
                <?php foreach ($goals as $key => $value) {
                    if ($key == 'login' || $key == 'requests') {
                        print '<option value="" disabled></option>';
                    }
                    print '<option value="'.$key.'"'.($dto->goal == $key ? ' SELECTED' : '').'>'.$value.'</option>';
                }?>
            </select>
        </div>
        <?php if (count($langIds) > 1) {?>
            <div>
                <?= lang_settings?>:<br>
                <select name="langId" id="langId" class="handler__filter">
                    <option value="0"></option>
                    <?php foreach($langIds AS $langId) {
                        print '<option value="'.$langId.'"'.($dto->langId == $langId ? ' SELECTED' : '').'>'.$dataLang[$langId]['baseName'].'&nbsp;&nbsp;</option>';
                    } ?>
                </select>
            </div>
        <?php } else {?>
            <input name="langId" id="langId" type="hidden" class="handler__filter" value="0">
        <?php }
        if (count($dmList) > 1) {?>
            <div>
                <?= domain_core?>:<br>
                <select name="domainId" id="domainId" class="handler__filter">
                    <option value="0"></option>
                    <?php
                    foreach($dmList AS $item) {
                        print '<option value="'.$item['domainId'].'"'.($dto->domainId == $item['domainId'] ? ' SELECTED' : '').'>'.$item['baseName'].'&nbsp;&nbsp;</option>';
                    } ?>
                </select>
            </div>
        <?php } else {?>
            <input name="domainId" id="domainId" type="hidden" class="handler__filter" value="0">
        <?php }?>
    </div>
    <style>
    .handler__lists {
        display: flex;
        gap: 10px;
        min-height: 350px;
    }
    .handler__listItem {
        box-sizing: border-box;
        display: flex;
        align-items: flex-start;
        gap: 5px;
        padding:8px 8px 10px 8px;
        box-shadow: rgba(9,30,66,.25) 0 1px 2px 0;
    }
    .handler__listStatus {
        flex-shrink: 0;
        width: 192px;
        box-sizing: border-box;
        background-color: #f4f5f7;
        padding: 0 7px 2px 7px;
    }
    .handler__listHeader {
        padding: 10px 10px 5px 10px;
        display: flex;
        justify-content: space-between;
    }
    .handler__item {
        display: block;
        overflow: hidden;
        text-overflow: ellipsis;
        width: 100%;
        white-space: nowrap;
        line-height: 1.5;
    }
    .handler__name {
        font-size: 11px;
        font-weight: bold;
    }
    .handler__listCheckbox {
        margin-top:4px;
    }
    .handler__list {
        height: 100%;
    }
    .delopener {
        visibility: hidden;
        position:absolute;
        z-index: 1;
        top: 10px;
        left: 36px;
        background-color: #fff;
        box-shadow: 0 2px 10px rgb(0 0 0 / 50%);
        padding: 0 10px 0 10px;
        line-height: 18px;
        border: 1px solid #444444;
    }
    .delopener:hover {
        background-color: #fff;
    }
    ul.boxy li {
        border: 0;
        background-color: #fff;
        margin: 5px 0px 7px 0px;
    }
    ul.sortable li:hover {
        background-color: #fff;
    }
    </style>
<?php
    $colors = [
        'submit' => 'border-top:4px solid #FC600A',
        'work' => 'border-top:4px solid #FB9902',
        'paid' => 'border-top:4px solid #007dff',
        'delivery' => 'border-top:4px solid #00bfff',
        'cancel' => 'border-top:4px solid #000',
        'done' => 'border-top:4px solid #459300'
    ];
?>
    <div class="handler__lists">
        <?php foreach($clist as $event => $list) {?>
            <div class="handler__listStatus" style="<?= $colors[$event]?>">
                <div class="handler__listHeader">
                    <?= trans('event.'.$event)?>
                    <a href="./?action=edit&amp;create=1&amp;service=handler_core&amp;event=<?= $event?>&amp;id=0&amp;langId=<?= $dto->langId?>&amp;domainId=<?= $dto->domainId?>&amp;goal=<?= $dto->goal?>&amp;formId=<?= $dto->formId?>" title="<?= addLabel?>">
                        <img src="<?= BASE_DIR?>/skinss/image/addW.png" width="16" height="16" alt="<?= addLabel?>">
                    </a>
                </div>
                <ul class="handler__list sortable boxy" data-event="<?= $event?>">
                <?php foreach($list AS $item) {
                    $statClass = '';
                    if(!$item['status']) $statClass = ' red';
                    ?>
                    <li class="handler__listItem<?= $statClass?>" id="i<?= $item['id']?>">
                        <input type="checkbox" name="ids[]" class="handler__listCheckbox chall" value="<?= $item['id']?>">
                        <div class="handler__item">
                            <a class="nameList" href="./?service=handler_core&amp;action=edit&amp;id=<?= $item['id']?>&amp;handler=<?= $item['handler']?>">
                                <span class="handler__name"><?= $hTypes[$item['handler']]?></span>
                                <?= $item['baseName']?><br>
                                <?= $item['domainName']?>
                                <?= $item['langName']?>
                                <?= $item['goalName']?>
                            </a>
                        </div>
                    </li>
                <?php }?>
                </ul>
            </div>
        <?php }?>
    </div>
</div>
<div class="buttonBlock delopener" id=""><?= bDel?></div>
<script>

    let filters = document.querySelectorAll('.handler__filter');
    for (let i = 0; i < filters.length; i++) {
        filters[i].addEventListener("change", function()
        {
            window.location = '?service=handler_core&' + this.id + '=' + this.value;
        });
    }
    var drop = false;
    $(".handler__list").sortable({
        connectWith: ".handler__list",
        receive: function(event, ui)
        {
            drop = true;
            $.get("./ajax.php?service=handler_core&action=sort&event="+this.dataset.event+"&list="+$(this).sortable('toArray'));
        },
        stop: function(event, ui)
        {
            if (!drop)
            {
                $.get("./ajax.php?service=handler_core&action=sort&list="+$(this).sortable('toArray'));
            }
            drop = false;
        }
    });
    let chall = document.querySelectorAll('.chall');
    for (let i = 0; i < chall.length; i++) {
        chall[i].addEventListener("click", chAll2);
    }

    function chAll2(event) {

        if (this.checked) {
            this.parentNode.append(document.querySelector('.delopener'));
            document.querySelector('.delopener').style.visibility = 'visible';
        } else{
            document.querySelector('.delopener').style.visibility = 'hidden';
        }

    }

</script>
