<style>
    .handler__filters {
        display: flex;
        gap: 25px;
        margin-bottom: 20px;
    }
    .handler__filter {
        width: 130px;
    }

    ul.sortable li
    {
        cursor: auto;
        padding:5px 0 5px 0;
        margin: 15px 0px 0 0px;
        display:flex;
        justify-content:space-between;
        align-items: start;
        border:0
    }

    ul.sortable li:hover {
        background-color: #eeeeee;
    }
    .multyChange {
        position:absolute;
        visibility: hidden;
        z-index: 1;
        top: 16px;
        left: 32px;
        box-shadow: 0 2px 10px rgba(0, 0, 0, 0.5);
    }

    .eventChangerRight
    {
        position:relative;
    }
    input[type='radio'] {
        -webkit-appearance: none;
        -moz-appearance: none;
        appearance: none;
        display: block;
        width:0;
        height:0;
        top:0;
        left:0;
        position: absolute;
        margin: 0;
        padding: 0;
        outline: 0;
    }
    input[type='radio'] + label {
      font-size: 14px;
      display: block;
      margin-bottom:2px;
      padding:3px 20px 3px 20px;
    }

    input[type='radio']:checked + label,
    input[type='radio']:hover + label
    {
        color:white;
    }

    [value=submit]:checked + label,
    [value=submit]:hover + label,
    [value=delete]:checked + label,
    [value=delete]:hover + label
    {
        background: red;
    }
    [value=work]:checked + label,
    [value=work]:hover + label
    {
        background: #FB9902;
    }
    [value=paid]:checked + label,
    [value=paid]:hover + label
    {
        background: #007dff;
    }
    [value=delivery]:checked + label,
    [value=delivery]:hover + label
    {
        background:  #00bfff;
    }
    [value=done]:checked + label,
    [value=done]:hover + label
    {
        background: #459300;
    }
    [value=cancel]:checked + label,
    [value=cancel]:hover + label
    {
        background: #000;
    }
</style>
<select class="multyChange">
    <option value=""></option>
    <?php
    foreach($events as $event => $value) {
        print '<option value="'.$event.'">'.trans('event.'.$event).'</option>';
    }
    ?>
</select>
<div class="handler__filters">
    <?php
    $formRepo = new Admin\Repository\SqlFormRepository();
    $forms = $formRepo->listForms();
    $options = '';
    if (count($forms)) {
        foreach ($forms as $key => $value)
        {
            $options .= '<option value="'.$key.'"'.($dto->formId == $key ? ' SELECTED' : '').'>'.$value['formName'].'</option>';
        }
    }
    if ($options) {
    ?>
        <div>
            <?= form_forms?>:<br>
            <select name="formId" id="formId" class="handler__filter">
                <option value="0"></option>
                <?= $options?>
            </select>
        </div>
    <?php } else {?>
        <input name="formId" id="formId" type="hidden" class="handler__filter" value="0">
    <?php }?>
    <div>
        <?= goal?>:<br>
        <select name="goal" id="goal" class="handler__filter">
            <?php $goals = array('' => '', 'order' => goal_order, 'appointment' => goal_appointment, 'contact' => goal_contact, 'callback' => goal_callback, 'payment' => goal_payment, 'subscription' => goal_subscription, 'requests' => '['.goal_order . '...' . goal_subscription.']', 'login' => goal_login, 'forgot' => goal_forgot);
            foreach ($goals as $key => $value) {
                if ($key == 'login' || $key == 'requests') {
                    print '<option value="" disabled></option>';
                }
                print '<option value="'.$key.'"'.($dto->goal == $key ? ' SELECTED' : '').'>'.$value.'</option>';
            }?>
            </optgroup>
        </select>
    </div>
    <?php if (count($langIds) > 1) {?>
        <div>
            <?= lang_settings?>:<br>
            <select name="langId" id="langId" class="handler__filter">
                <option value="0"></option>
                <?php foreach($langIds AS $langId) {
                    print '<option value="'.$langId.'"'.($dto->langId == $langId ? ' SELECTED' : '').'>'.$dataLang[$langId]['baseName'].'&nbsp;&nbsp;</option>';
                } ?>
            </select>
        </div>
    <?php } else {?>
        <input name="langId" id="langId" type="hidden" class="handler__filter" value="0">
    <?php }
    if (count($dmList) > 1) {?>
        <div>
            <?= domain_core?>:<br>
            <select name="domainId" id="domainId" class="handler__filter">
                <option value="0"></option>
                <?php
                foreach($dmList AS $item) {
                    print '<option value="'.$item['domainId'].'"'.($dto->domainId == $item['domainId'] ? ' SELECTED' : '').'>'.$item['baseName'].'&nbsp;&nbsp;</option>';
                } ?>
            </select>
        </div>
    <?php } else {?>
        <input name="domainId" id="domainId" type="hidden" class="handler__filter" value="0">
    <?php }?>
    <div>
        <?= statusAbout?>:<br>
        <select name="event" id="event" class="handler__filter" data-event="<?= $dto->event?>">
            <option value=""></option>
            <?php
            foreach($events as $event => $value) {
                if ($event === 'delete') continue;
                print '<option value="'.$event.'"'.($event == $dto->event ? ' SELECTED' : '').'>'.trans('event.'.$event).'</option>';
            }
            ?>
        </select>
    </div>
    <input name="userId" id="userId" type="hidden" class="handler__filter" value="<?= $dto->userId?>">
    <input name="couponId" id="couponId" type="hidden" class="handler__filter" value="<?= $dto->couponId?>">
    <input name="partner1Id" id="partner1Id" type="hidden" class="handler__filter" value="<?= $dto->partner1Id?>">
    <input name="page" id="page" type="hidden" class="handler__filter" value="<?= $dto->page?>">
    <a style="margin-left:auto;float:none;" class="buttonBlock cloneIcon" href="<?= ADMIN_DIR?>?service=order_core&amp;action=export_form&amp;<?= http_build_query($dto)?>"><?= Export?></a>
</div>
<?php
$count = count($items);

if ($count > 1 && (isset(main::$user['admins']['ordere']) || isset(main::$user['admins']['orderd']))) {?>
    <div style="position:relative;padding-top:30px;margin-top:-30px;">
        <input type="checkbox" class="chall chall__all" value="1" style="position:absolute;left:9px;top:16px">
    </div>
<?php }?>
<ul id="sortable" class="sortable boxy">
<?php
for($i=0; $i < $count; $i++)
{
    $order = $items[$i];
?>
<li id="li<?= $order['id']?>">
  <input type="checkbox" name="ids[]" class="chall" value="<?= $order['id']?>" style="position:absolute;left:8px;top:16px">
  <table style="width:100%;">
	<tr>
        <td style="padding:10px 0 10px 35px;">
        <?php
        if (isset(main::$user['admins']['orderd'])) {
        ?><img src="<?= BASE_DIR?>/skinss/image/close.png" width="12" height="12" alt="" class="delOrder" onclick="deleteOrder(<?= $order['id']?>, '<?= isDelete?>')"><?php
        }?>
        <div><b>№</b> <?= $order['id']?></div>
        <?php
		print '<b>'.baseName.'</b>: '.$order['orderName'];

        if (!empty($order['price']))
        {?>
            <div style="padding-top:5px"><b><?= price?></b>: <?= $order['price']?></div>
        <?php
        }

        $userPhone = $userEmail = false;

        if ($order['orderInfo'])
        {
	        foreach($order['orderInfo'] as $key => $item)
            {
	        	if (isset($item['userPassword']) ||
                    !empty($item['skips']) ||
                    $item['value'] === '' ||
                    $key === 'orderNumber' ||
                    $key === 'goodName' ||
                    $key === 'price'
                   )
                {
                    continue;
                }
                $class = '';
                if (isset($item['handler'])) {
                    $class = 'class="order_handler_'.$order['id'].'_'.$item['handler'].'"';
                }
                ?><div <?= $class?> style="padding-top:5px;"><?php
                    if (!empty($item['baseName']))
                    {
                        print '<b>'.$item['baseName'].'</b>: ';
                    }

                    if (isset($item['error']))
                    {
                        print '<span style="color:red;">';
                    }

                    if ($key === 'reftail')
                    {
                        $host = parse_url($item['value'], PHP_URL_HOST);
                        if ($host)
                        {
                            $item['value'] = $host;
                        }
                    }

                    if (!empty($item['isFile'])) {
                        $files = [];
                        $item['value'] = explode(',', $item['value']);
                        foreach($item['value'] as $file)
                        {
                            if (file_exists(FILES_S.'orders/'.$order['id'].'/'.$file.'.txt'))
                            {
                                $files[] = '<a href="./?service=order_core&action=file&file='.urlencode($file).'&id='.$order['id'].'" target="_blank">'.
                                                $file.
                                            '</a>';
                            }
                            else
                            {
                                $files[] = $file;
                            }
                        }
                        print implode(', ',  $files);
                    }
                    else if (isset($item['userPhone']) || isset($item['userEmail']))
                    {
                        if (isset($item['userPhone']))
                        {
                            $userPhone = true;
                        }
                        else if (isset($item['userEmail']))
                        {
                            $userEmail = true;
                        }
                        print '<a href="./?service=dirGroup_ACL&action=lists&id=0&search='.urlencode($item['value']).'">'.$item['value'].'</a>';
                    }
                    else
                    {
                        print $item['value'];
                    }

                    if (isset($item['error']))
                    {
                        print '</span>';
                    }

                    if (isset($item['handler']))
                    {
                        print '<span class="cursor" title="'.again.'" style="margin-left:10px;font-size:14px;color:#07367B;" onclick="runHandler('.$order['id'].', '.$item['handler'].')">&#8634;</span>';
                    }
	        	?></div>
	        <?php }
        } else {
            print '<div style="padding-top:5px;color:red;">'.error2.': Fatal error and not save order info.</div>';
        }

        if (!$userEmail && !empty($order['userEmail']))
        {
            print '<div style="padding-top:5px"><b>E-mail</b>: <a href="./?service=dirGroup_ACL&action=lists&id=0&search='.urlencode($order['userEmail']).'">'.$order['userEmail'].'</a></div>';
        }

        if (!$userPhone && !empty($order['userPhone']))
        {
            print '<div style="padding-top:5px"><b>'.Phone.'</b>: <a href="./?service=dirGroup_ACL&action=lists&id=0&search='.urlencode($order['userPhone']).'">'.$order['userPhone'].'</a></div>';
        }

        if ($order['partner1Id'] && $order['partner1Id'] != $order['userId'])
        {
            print '<div style="padding-top:5px;"><b>'. Partner .'</b>: <a href="./?service=user_ACL&action=edit&id='.$order['partner1Id'].'">'.$order['partnerLogin'].'</a></div>';
        }

        ?>
        <div style="padding-top:5px"><?= dateTimeConvert($order['dateCreate'])?></div>
        </td>
	</tr>
  </table>
  <div data-event="<?= $order['event']?>" style="margin:5px 9px;">
    <?php
    foreach($events as $event => $value)
    {
        if ($event === 'delete') continue;
        print '<div class="eventChangerRight">'.
                '<input type="radio" class="eventChanger '.$event.'" name="event['.$order['id'].']" id="'.$event.$order['id'].'"  data-id="'.$order['id'].'" value="'.$event.'"'.($event == $order['event'] ? ' checked' : '').'>'.
                '<label for="'.$event.$order['id'].'"> '.trans('event.'.$event).' </label>'.
               '</div>';
    }
    ?>
  </div>
</li>
<?php }?>
</ul>
<?php if (!$count) {?>
    <h1 style="font-size: 27px;text-align:center;margin-top:100px"><?= NoAvailable?></h1>
<?php }?>
<?php
$urlData = clone $dto;
$pager = new pager($dto->page, $countItems, 80);
$data = $pager->getList();
$count2 = count($data);?>
<div class="pages">
<?php if ($count2>1) {?>
<div class="numbers"><span class="title"><?= pagesLink;?>:</span>
<?php
    $i = ($pager -> getCurrentNumberPage() - 8 > 0 ? $pager -> getCurrentNumberPage() - 8 : 0);
    if ($i != 0) print '<span class="active">...</span>';
    $countViewPage = ($pager -> getCurrentNumberPage() + 9 < $count2 ? $pager -> getCurrentNumberPage() + 9 : $count2);
    for (; $i < $countViewPage; $i++) {
        if ($pager -> getCurrentNumberPage() == $i) {
          print '<span class="active">'.($i + 1).'</span>';
        } else {
          $urlData->page = $data[$i];
          print '<a href="./?service=order_core&action=lists&'.http_build_query($urlData).'">'.($i + 1).'</a>';
        }
     }
     if ($countViewPage < $count2) print '<span class="active">...</span>';
?>
</div>
<?php }?>
</div>
<?php if ($count > 1 && (isset(main::$user['admins']['ordere']) || isset(main::$user['admins']['orderd']))) {?>
    <div style="position:relative;">
        <input type="checkbox" class="chall chall__all" value="1" style="position:absolute;left:9px;top:16px">
    </div>
<?php }?>
<script>

    let filters = document.querySelectorAll('.handler__filter');
    for (let i = 0; i < filters.length; i++) {
        filters[i].addEventListener("change", function()
        {
            window.location = '?service=order_core&' + this.id + '=' + this.value;
        });
    }

    let chall = document.querySelectorAll('.chall');
    for (let i = 0; i < chall.length; i++) {
        chall[i].addEventListener("click", chAll2);
    }

    let multyChangeInput = document.querySelector('.multyChange');
    multyChangeInput.addEventListener("input", multyChange);

    function chAll2(event) {

        if (this.classList.contains('chall__all')) {
            for (let i = 0; i < chall.length; i++) {
                if (this.checked) {
                    chall[i].checked = true;
                } else {
                    chall[i].checked = false;
                }
            }
        }
        let countCh = 0;
        for (let i = 0; i < chall.length; i++) {
            if (chall[i].checked) {
                countCh++;
            }
        }
        if (this.checked) {
            this.parentNode.append(multyChangeInput);
            multyChangeInput.style.visibility = 'visible';
        } else{
            multyChangeInput.style.visibility = 'hidden';
        }

    }

    function multyChange(event) {
        let string = '',
            ids = '',
            isChange = true,
            obj = event.target;

        if (obj.value == 'delete') {
            isChange = confirm('<?= isDelete?>');
        }
        if (!isChange) {
            obj.selectedIndex = 0;
            return false;
        }
        for (let i = 0; i < chall.length; i++) {
            if (chall[i].checked && !chall[i].classList.contains('chall__all')) {
                ids += '&ids[]='+chall[i].value;
            }
        }
        for (let i = 0; i < filters.length; i++) {
            string += '&' + filters[i].id + '=' + filters[i].value;
        }

        if (ids) {
            if (obj.value) {
                window.location = './?service=order_core'+ids+'&action=multyChange'+string+'&multyevent='+obj.value;
            }
            obj.selectedIndex = 0;
        }

    }

    let ec = document.querySelectorAll('.eventChanger');
    for (let i = 0; i < ec.length; i++) {
        ec[i].addEventListener("change", (event) => {
            orderEvent(event, '<?= isDelete?>')
        });
        ec[i].addEventListener("click", function (event) {
            if (event.clientX)
            {
                this.blur();
            }
        });


    }
</script>