<?php
namespace Admin\Controller;

use Admin\Repository\SqlProductRepository;
use main;

class ProductController
{
    private $productRepo;

    public function __construct()
    {
        $this->productRepo = new SqlProductRepository();
    }

    public function lists()
    {

        if (isset(main::$user['admins']['orderv']))
        {

            $list = $this->productRepo->getList();

            return renderTpl('core/admin/listProducts.php',
                compact('list')
            );

        }

    }

    public function update()
    {
        if (!isset(main::$user['admins']['orderv']))
        {
            return;
        }

        if (isSubmit())
        {
            if (isset($_REQUEST['price']))
            {
                $_REQUEST['price'] = floatval(str_replace(',','.', preg_replace('/\s{1,}/u', '', $_REQUEST['price'])));
            }

            $_REQUEST['sku'] = trim($_REQUEST['sku']);
            if (!empty($_REQUEST['sku']))
            {
                if ($this->productRepo->issetSku($_REQUEST['sku'], $_REQUEST['productId']))
                {
                    main::addError(str_replace("%0.var.value%", $_REQUEST['sku'], uniqueLogin_ACL));
                }
            }

            $_REQUEST['codes'] = trim($_REQUEST['codes']);
            if (!empty($_REQUEST['codes']))
            {
                $_REQUEST['codes'] = explode("\n", $_REQUEST['codes']);
                $_REQUEST['codes'] = array_map("trim", $_REQUEST['codes']);
            }
            else
            {
                $_REQUEST['codes'] = [];
            }

            foreach($_REQUEST['codes'] as $key => $value)
            {
                if ($value == '')
                unset($_REQUEST['codes'][$key]);
            }

            if (!empty($_REQUEST['productId']))
            {
                $lock = $this->productRepo->lock($_REQUEST['productId']);
                $product = $this->productRepo->findById($_REQUEST['productId']);

                if (!$lock)
                {
                    main::addError('System error');
                }
                else if ($product && !empty($_REQUEST['codes']))
                {
                    $codesString = $product['codes'];
                    if (!empty($product['codes']))
                    {
                        $product['codes'] = explode("\n", $product['codes']);
                        $product['codes'] = array_map("trim", $product['codes']);
                    }
                    else
                    {
                        $product['codes'] = [];
                    }

                    if (!empty(array_diff($_REQUEST['codes'], $product['codes'])) || !empty(array_diff($product['codes'], $_REQUEST['codes'])))
                    {
                        if (!empty($_REQUEST['old_codes']))
                        {
                            if ($_REQUEST['old_codes'] != $codesString)
                            {
                                $_REQUEST['old_codes'] = explode("\n", $_REQUEST['old_codes']);
                                $_REQUEST['old_codes'] = array_map("trim", $_REQUEST['old_codes']);

                                $deleted = array_diff($_REQUEST['old_codes'], $product['codes']);
                                foreach($deleted as $value)
                                {
                                    $index = array_search($value, $_REQUEST['codes']);
                                    if ($index !== false)
                                    {
                                        unset($_REQUEST['codes'][$index]);
                                    }
                                }
                            }
                        }

                        $deleted = array_diff($product['codes'], $_REQUEST['codes']);
                        foreach($deleted as $value)
                        {
                            $index = array_search($value, $product['codes']);
                            if ($index !== false)
                            {
                                unset($product['codes'][$index]);
                            }
                        }

                        if (!empty(array_diff($_REQUEST['codes'], $product['codes'])) || !empty(array_diff($product['codes'], $_REQUEST['codes'])))
                        {
                            $new = array_diff($_REQUEST['codes'], $product['codes']);
                            $_REQUEST['codes'] = array_merge($product['codes'], $new);
                        }
                    }
                }
            }

            if(!main::getErrors())
            {
                if (isset(main::$user['admins']['ordere']))
                {
                    $productId = $this->productRepo->update($_REQUEST);
                    $this->productRepo->unlock($productId);
                }

                redirect('?service=product_core&action=lists');
			}

            if (!empty($_REQUEST['productId']))
            {
                $this->productRepo->unlock($_REQUEST['productId']);
            }
		}

        $data = $this->productRepo->findMultiById();

        return renderTpl('core/admin/editProduct.php', compact('data'));

    }

	public function delete()
    {
		if ((!isset(main::$user['admins']['orderd'])) || empty($_REQUEST['id']))
        {
            return;
        }

        $ids = $_REQUEST['id'];
        if (is_array($ids))
        {
            foreach($ids as $key => $value)
            {
                $ids[$key] = (int) $value;
            }
        }

        if (!is_array($ids))
        {
            $ids = [(int) $ids];
        }

        $this->productRepo->delete($ids);

        redirect('?service=product_core');
    }
}