<?php
namespace Admin\Repository;

use main;
use Common\Lib\DB;
use Admin\Repository\SqlFormRepository;

class SqlHandlerRepository
{
    private $con;
    public static $allRequests = ['order', 'payment', 'appointment', 'contact', 'callback', 'subscription'];

    private $events = [
        'submit' => [],
        'work' => [],
        'paid' => [],
        'delivery' => [],
        'cancel' => [],
        'done' => []
    ];

    public function __construct()
    {
        $this->con = DB::connection();
    }

    public function events()
    {
        return $this->events;
    }

    public function getHendlersTypes()
    {
        return [
            'Reload' => reload_page,
            'Redirect' => Redirect,
            'Alert' => youMessage,
            'Script' => 'JavaScript',
            'Empty1' => '',
            'Email'=>'Email',
            'Telegram' => 'Telegram',
            'Sms' => 'Sms',
            'Crm' => 'Crm',
            'AmoCrm' => 'Amocrm',
            'Empty2' => '',
            'Discount' => discount_settings,
            'Timer' => timer_discount,
            'Coupon' => coupon_settings,
            'Partner' => partner_settings,
            'empty3' => '',
            'Payment' => goal_payment,
            'NewEvent' => moveOrder,
            'Imgresize' => imgresize,
            'Deletefile' => deletefile,
            'DontSave' => DontSave,
            'empty4' => '',
            'Adduser' => registrationUser,
            '' => '',
            'Recaptcha' => 'Recaptcha',
            'BanIP' => BanIP,
            'AllowIP' => AllowIP,
            'Php' => 'Php',
        ];
    }

    public function getItemsByIds($ids)
    {
        if (empty($ids))
        {
            return [];
        }

        $r = $this->con->query('SELECT id, handler, domainId FROM '.DB_PREFIX.'handler WHERE id IN ('.implode(',', $ids).')');

        $return = [];
        while ($result = $r->fetch_assoc())
        {
            $return[] = $result;
        }

        return $return;
    }

    public function getItemsByFormId($id)
    {
        if (!$id)
        {
            return [];
        }

        $r = $this->con->query('SELECT id, handler, domainId FROM '.DB_PREFIX.'handler WHERE formId = '.(int) $id);

        $return = [];
        while ($result = $r->fetch_assoc())
        {
            $return[] = $result;
        }

        return $return;
    }

    public function findMultiById($id)
    {
        if (isSubmit() || isset($_REQUEST['create'])) {
            return $_REQUEST;
        }

        return $this->findById($id);
    }

    public function findById($id)
    {
        if (empty($id)) return;

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'handler WHERE `id` = '.(int)$id);
        $return = $r->fetch_assoc();
        $return['settings'] = $return['settings'] ? unserialize($return['settings']) : [];

        return $return;
    }

    public function getList($dto, $dataLang, $dmList, $goals, $countLangs)
    {
        $formRepo = new SqlFormRepository();
        $forms = $formRepo->listForms();

        $return = $this->events;
        $goalList = [];
        $where = '';
        $countDomains = count($dmList);
        $goal = $dto->goal;
        $domainId = $dto->domainId;
        $langId = $dto->langId;

        if ($dto->handler)
        {
            $where .= ' AND handler = "'.$this->con->real_escape_string($dto->handler).'"';
        }

        if ($dto->formId && isset($forms[$dto->formId]))
        {
            $where .= ' AND formId in (0, '. (int) $dto->formId. ')';
            $goal = $forms[$dto->formId]['goal'];

            $ld = $formRepo->getLangAndDomain($dto->formId);
            if ($ld)
            {
                $domainId = $ld['domainId'];
                $langId = $ld['langId'];
            }
        }
        else if (!$dto->handler)
        {
            $where .= ' AND formId = 0';
        }

        if ($goal)
        {
            if ($goal == 'requests') {
                $goalList = self::$allRequests;
            } else if (in_array($goal, self::$allRequests)) {
                $goalList[] = 'requests';
            }
            $goalList[] = $goal;
            $where .= ' AND goal IN ("'.implode('","', $goalList).'", "")';
        }
        else if (!$dto->handler)
        {
            $where .= ' AND goal = ""';
        }

        if ($langId)
        {
            $where .= ' AND langId in (0, '. (int) $langId .')';
        }
        else if (!$dto->handler)
        {
            $where .= ' AND langId = 0';
        }

        if ($domainId)
        {
            $where .= ' AND domainId in (0, '. (int) $domainId .')';
        }
        else if (!$dto->handler)
        {
            $where .= ' AND domainId = 0';
        }

        $r = $this->con->query('SELECT id,langId,baseName,formId,`event`,`status`,domainId,goal,handler
                                  FROM '.DB_PREFIX.'handler
                                 WHERE 1 '. $where .'
                                 ORDER BY sequence DESC');

        while ($result = $r->fetch_assoc())
        {
            if ($result['formId'])
            {
                if ($goal &&
                    !$dto->formId &&
                    isset($forms[$result['formId']]) &&
                    !in_array($forms[$result['formId']]['goal'], $goalList))
                {
                    continue;
                }

                if (isset($forms[$result['formId']]))
                {
                    $result['formName'] = form_forms.': '.$forms[$result['formId']]['formName'];
                }
                else
                {
                    $result['formName'] = form_forms.': №'.$result['formId'];
                }
            }

            $result['langName'] = '';
            if (!$result['langId']) {
                $lang = all;
            } else if (isset($dataLang[$result['langId']])) {
                $lang = $dataLang[$result['langId']]['baseName'];
            } else {
                $lang = $result['langId'];
            }

            if ($result['langId'] || (!$result['langId'] && $countLangs > 1))
            {
                $result['langName'] = lang_settings.': '. $lang .'<br>';
            }

            $result['domainName'] = '';
            if (!$result['domainId']) {
                $domain = all;
            } else if (isset($dmList[$result['domainId']])) {
                $domain = $dmList[$result['domainId']]['baseName'];
            } else {
                $domain = $result['domainId'];
            }

            if ($result['domainId'] || (!$result['domainId'] && $countDomains > 1))
            {
                $result['domainName'] = domain_core.': '. $domain .'<br>';
            }

            if (isset($result['formName'])) {
                $result['goalName'] = $result['formName'];
            } else if (!empty($result['goal'])) {
                $result['goalName'] = goal.': '.$goals[$result['goal']];
            } else {
                $result['goalName'] = goal.': '.all;
            }
            if (!empty($result['baseName'])) {
                $result['baseName'] = '<br>'.$result['baseName'];
            }
            $return[$result['event']][$result['id']] = $result;

        }

        return $return;
    }

    public function update($data)
    {
        if (!isset($this->events[$data['event']])) {
            return;
        }

        $langId = isset($data['langId']) ? $data['langId'] : 0;
        $domainId = isset($data['domainId']) ? $data['domainId'] : 0;
        $formId = isset($data['formId']) ? $data['formId'] : 0;
        $goal = isset($data['goal']) ? $data['goal'] : '';
        $baseName = isset($data['baseName']) ? $data['baseName'] : '';

        if (isset($data['create'])) {
            $data['id'] = $this->insert($langId, $domainId, $goal, $formId);
        }

        $this->con->query('UPDATE '.DB_PREFIX.'handler
                             SET
                                event = "'.$this->con->real_escape_string($data['event']).'",
                                handler = "'.$this->con->real_escape_string($data['handler']).'",
                                baseName = "'.$this->con->real_escape_string($baseName).'",
                                pageId = '.(isset($data['pageId']) ? (int) $data['pageId'] : 0).',
                                userGroupId = '.(isset($data['userGroupId']) ? (int) $data['userGroupId'] : 0).',
                                paymentId = '.(isset($data['paymentId']) ? (int) $data['paymentId'] : 0).',
                                timerId = '.(isset($data['timerId']) ? (int) $data['timerId'] : 0).',
                                langId = '.(int) $langId.',
                                domainId = '.(int) $domainId.',
                                formId = '.(int) $formId.',
                                settings =  "'.(!empty($data['settings']) ? $this->con->real_escape_string(serialize($data['settings'])) : '').'",
                                goal = "'.$this->con->real_escape_string($goal).'",
                                text1 = "'.(isset($data['text1']) ? $this->con->real_escape_string($data['text1']) : '').'",
                                status = '.(isset($data['status']) ? (int) $data['status'] : 0).'
                             WHERE id = '.$data['id']);

        return $data['id'];
    }

    public function insert($langId, $domainId, $goal, $formId)
    {
        $this->con->query('INSERT INTO '.DB_PREFIX.'handler
                                       (langId, domainId, formId, goal, baseName, settings, text1, sequence)
                                VALUES ('.(int) $langId.',
                                        '.(int) $domainId.',
                                        '.(int) $formId.',
                                        "'.$this->con->real_escape_string($goal).'",
                                        "",
                                        "",
                                        "",
                                        '.$this->nextSeq().'
                                       )');

        return $this->con->insert_id;
    }

    public function nextSeq()
    {
        $r = $this->con->query('SELECT max(sequence) as max FROM '.DB_PREFIX.'handler');
        $data = $r->fetch_assoc();
        return (int)$data['max'] + 1;
    }

    public function delete($ids)
    {
        $this->con->query('DELETE FROM '.DB_PREFIX.'handler WHERE id IN ('. implode(',', $ids) .')');
    }

    public function deleteByFormIds($ids)
    {
        if (empty($ids))
        {
            return;
        }

        $this->con->query('DELETE FROM '.DB_PREFIX.'handler WHERE formId IN ('. implode(',', $ids) .')');
    }

    public function sort($list, $event)
    {
        $set = '';
        if ($event)
        {
            $set = ', event = "'.$this->con->real_escape_string($event).'"';
        }
        $items = explode(",", $list);
        $count = count($items)-1;$j=0;
        for($i=$count;$i>=0;$i--)
        {
            $this->con->query('UPDATE '.DB_PREFIX.'handler SET sequence = '.($j++).$set.' WHERE id = '.substr($items[$i], 1));
        }
    }

    public function clones($oldFormId, $newFormId)
    {
        if (!$oldFormId || !$newFormId)
        {
            return;
        }

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'handler WHERE formId = '. (int) $oldFormId .' ORDER BY sequence');
        while ($data = $r->fetch_assoc())
        {
            $id = $data['id'];
            $data['create'] = 1;
            $data['formId'] = (int) $newFormId;
            $data['settings'] = $data['settings'] ? unserialize($data['settings']) : [];

            $data['id'] = $this->update($data);

            if (file_exists(FILES_S.'handler/'.$id.'.php'))
            {
                copy(FILES_S.'handler/'.$id.'.php', FILES_S.'handler/'.$data['id'].'.php');
            }
        }
    }
}