<?php
namespace Admin\Repository;

use Common\Lib\DB;

class SqlProductRepository
{
    private $con;

    public function __construct()
    {
        $this->con = DB::connection();
    }

    public function findMultiById()
    {
        if (isSubmit())
        {
            if (isset($_REQUEST['codes']))
            {
                $_REQUEST['codes'] = implode("\n", $_REQUEST['codes']);
            }
            return $_REQUEST;
        }

        $data = [
            'productId' => 0,
            'productName' => '',
            'price' => '',
            'sku' => '',
            'is_need_codes' => 0,
            'codes' => ''
        ];

        if (isset($_REQUEST['create']) || empty($_REQUEST['productId']))
        {
            if (isset($_REQUEST['productName']))
            {
                $data['productName'] = $_REQUEST['productName'];
            }

            if (isset($_REQUEST['price']))
            {
                $data['price'] = $_REQUEST['price'];
            }

            if (isset($_REQUEST['sku']))
            {
                $data['sku'] = $_REQUEST['sku'];
            }

            if (isset($_REQUEST['is_need_codes']))
            {
                $data['is_need_codes'] = 1;
            }

            if (isset($_REQUEST['codes']))
            {
                $data['codes'] = implode("\n", $_REQUEST['codes']);
            }

            return $data;
        }

        return $this->findById($_REQUEST['productId']);
    }

    public function findById($id)
    {
        if (empty($id)) return false;

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'product WHERE `productId` = '. (int) $id);
        $return = $r->fetch_assoc();
        if (isset($return['codes']))
        {
            $return['old_codes'] = $return['codes'];
        }
        return $return;
    }

    public function issetSku($sku, $productId)
    {
        if (empty($sku)) return false;

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'product WHERE `sku` = "'.$this->con->real_escape_string($sku).'" AND productId != '. (int) $productId);
        return $r->fetch_assoc();
    }

    public function getList()
    {
        $return = [];

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'product ORDER BY productName DESC');

        while ($result = $r->fetch_assoc())
        {
            $return[$result['productId']] = $result;
        }

        return $return;
    }

    public function update($data)
    {
        $this->con->query('INSERT INTO '.DB_PREFIX.'product
        (productId, price, productName, sku, is_need_codes, codes)
        VALUES (
            '.(!empty($data['productId']) ? (int) $data['productId'] : 'NULL').',
            "'.$this->con->real_escape_string($data['price']).'",
            "'.$this->con->real_escape_string(trim($data['productName'])).'",
            '.(!empty($data['sku']) ? '"'.$this->con->real_escape_string(trim($data['sku'])).'"' : 'NULL').',
            '.(isset($data['is_need_codes']) ? (int) $data['is_need_codes'] : 0).',
            "'.($data['codes'] ? $this->con->real_escape_string(implode("\n", $data['codes'])) : '').'"
        )
        ON DUPLICATE KEY UPDATE
            price = VALUES(price),
            productName = VALUES(productName),
            sku = VALUES(sku),
            is_need_codes = VALUES(is_need_codes),
            codes = VALUES(codes)');

        if (!$data['productId'])
        {
            $data['productId'] = $this->con->insert_id;
        }

        return $data['productId'];
    }

    public function lock($productId)
    {
        $r = $this->con->query('SELECT GET_LOCK("codes_'.$productId.'", 1) as locked');
        $item = $r->fetch_assoc();
        if ($item && $item['locked'])
        {
            return true;
        }
        return false;
    }

    public function unlock($productId)
    {
        $this->con->query('SELECT RELEASE_LOCK("codes_'.$productId.'")');
	}

    public function delete($ids)
    {
        if (empty($ids))
        {
            return false;
        }

        $this->con->query('DELETE FROM '.DB_PREFIX.'product WHERE productId IN ('. implode(',', $ids) .')');
        $this->con->query('UPDATE '.DB_PREFIX.'order SET productId = 0 WHERE productId IN ('. implode(',', $ids) .')');
        $this->con->query('UPDATE '.DB_PREFIX.'block SET productId = 0 WHERE productId IN ('. implode(',', $ids) .')');
    }
}