<?php
namespace Admin\Usecase;

use Admin\Repository\SqlHandlerRepository;
use main;

class DeleteFormHandlersUsecase
{
    private $handlerRepo;

    public function __construct()
    {
        $this->handlerRepo = new SqlHandlerRepository();
    }

    public function run($ids)
    {
        if (empty($ids))
        {
            return false;
        }

        foreach($ids as $id)
        {
            $list = $this->handlerRepo->getItemsByFormId($id);
            foreach($list as $item)
            {
                if ($item['handler'] == 'Recaptcha')
                {
                    $this->Recaptcha($item['domainId']);
                }
                else if ($item['handler'] == 'Php')
                {
                    $this->Php($item['id']);
                }
            }
        }

        $this->handlerRepo->deleteByFormIds($ids);
    }

    private function Recaptcha($domainId)
    {
        $domain = main::mapper('domain_core');
        if (empty($domainId))
        {
            $list = $domain->findList();
            foreach($list as $item)
            {
                $domain->updateRecaptcha($item['domainId']);
            }
        }
        else
        {
            $domain->updateRecaptcha($domainId);
        }
    }

    private function Php($id)
    {
        if (file_exists(FILES_S.'handler/'.$id.'.php'))
        {
            unlink(FILES_S.'handler/'.$id.'.php');
        }
    }

}
