<?php
namespace Shop\Repository;

use Shop\Exception\NotFoundException;
use Common\Lib\DB;

class SqlHandlerRepository
{
    private $con;
    public static $allRequests = ['order', 'payment', 'appointment', 'contact', 'callback', 'subscription'];
    private $where = "";

    public function __construct()
    {
        $this->con = DB::connection();
    }

    public function getById($id)
    {
        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'handler
                                 WHERE status = 1 AND
                                       id = '. (int) $id.
                                       $this->where);

        $result = $r->fetch_assoc();

        if (!$result)
        {
            throw new NotFoundException('Not found');
        }

        $result['settings'] = $result['settings'] ? unserialize($result['settings']) : [];
        return $result;
    }

    public function getItems($event, $formId, $goal, $domainId, $langId)
    {
        $dontSaveHandler = $recaptchaHandler = $banIPHandler = $allowIPHandler = $deletefileHandler = $phpHandler = $imgresizeHandler = false;

        $hendlers = $goalList = [];

        if ($goal == 'requests')
        {
            $goalList = self::$allRequests;
        }
        else if (in_array($goal, self::$allRequests))
        {
            $goalList[] = 'requests';
        }

        $goalList[] = $goal;

        $r = $this->con->query('SELECT * FROM '.DB_PREFIX.'handler
                                        WHERE status = 1 AND
                                              event = "'. $this->con->real_escape_string($event) .'" AND
                                              formId in (0, '. (int) $formId .') AND
                                              goal IN ("", "'.implode('","', $goalList).'") AND
                                              langId in (0, '. (int) $langId .')  AND
                                              domainId in (0, '. (int) $domainId .')
                                              '.$this->where.'
                                        ORDER BY sequence DESC');

        while ($item = $r->fetch_assoc())
        {
            $item['settings'] = $item['settings'] ? unserialize($item['settings']) : [];

            if ($item['handler'] === 'DontSave')
            {
                $dontSaveHandler = true;
                continue;
            }
            else if ($item['handler'] === 'Recaptcha')
            {
                $recaptchaHandler = $item;
                continue;
            }
            else if ($item['handler'] === 'BanIP')
            {
                $banIPHandler = $item;
                continue;
            }
            else if ($item['handler'] === 'AllowIP')
            {
                $allowIPHandler = $item;
                continue;
            }
            else if ($item['handler'] === 'Deletefile')
            {
                $deletefileHandler = $item;
                continue;
            }
            else if ($item['handler'] === 'Php')
            {
                $phpHandler = $item;
                continue;
            }
            else if ($item['handler'] === 'Imgresize')
            {
                $imgresizeHandler = $item;
                continue;
            }

            $hendlers[] = $item;
        }

        if ($deletefileHandler) // последний
        {
            $hendlers[] = $deletefileHandler;
        }

        if ($phpHandler) // 9
        {
            array_unshift($hendlers, $phpHandler);
        }

        if ($imgresizeHandler) // 8
        {
            array_unshift($hendlers, $imgresizeHandler);
        }

        if ($event === 'paid') // 7
        {
            array_unshift($hendlers, ['handler' => 'Paid']);
        }

        if ($dontSaveHandler === false) // 6
        {
            array_unshift($hendlers, ['handler' => 'Save']);
        }

        if ($goal === 'login') // 5
        {
            array_unshift($hendlers, ['handler' => 'Login']);
        }
        else if ($goal === 'forgot') // 4
        {
            array_unshift($hendlers, ['handler' => 'Forgot']);
        }

        if ($recaptchaHandler) // 3
        {
            array_unshift($hendlers, $recaptchaHandler);
        }

        if ($banIPHandler) // 2
        {
            array_unshift($hendlers, $banIPHandler);
        }

        if ($allowIPHandler) // 1
        {
            array_unshift($hendlers, $allowIPHandler);
        }

        return $hendlers;
    }

}