<?php
namespace Shop\Usecase;

use Shop\Repository\SqlOrderRepository;
use Shop\Usecase\RunCustomEventUsecase;
use Shop\Usecase\GetOrderByIdUsecase;

class ChangeOrderEventUsecase
{
    private $orderRepo;

    public function __construct()
    {
        $this->orderRepo = new SqlOrderRepository();
    }

    public function run($orderId, $event)
    {
        $ordUsecase = new GetOrderByIdUsecase();
        $ord2 = $ordUsecase->run($orderId);

        if ($ord2->event() === $event)
        {
            throw new \Exception('Duplicate event');
        }

        $orderEvent = new RunCustomEventUsecase($ord2);
        $orderEvent->run($event);

        $this->orderRepo->save($ord2);
    }
}