<?php
namespace Shop\Usecase\Handler;

use Shop\Entity\Order;
use Shop\Exception\NotFoundException;
use main;

class AmoCrmUsecase
{
    private $ord2;
    private $handler;

    public function __construct(Order $ord2, $handler = [])
    {
        $this->ord2 = $ord2;
        $this->handler = $handler;
    }

    public function run()
    {
        try
        {
            $lead_id = $this->ord2->orderInfo('lead_id');
            if ($lead_id)
            {
                $lead_id = $lead_id['value'];
            }

            $lead_id = main::mapper('crm_settings')->AMOsend($this->ord2, $lead_id);

            $this->ord2->updateOrderInfo('ha'.$this->handler['id'], [
                'baseName' => 'Amo ('.trans('event.'.$this->ord2->event()).')',
                'value' => 'Ok',
                'handler' => $this->handler['id']
            ]);

            if ($lead_id)
            {
                $this->ord2->updateOrderInfo('lead_id', [
                    'skips' => 1,
                    'value' => $lead_id
                ]);
            }
        }
        catch (\Throwable $e)
        {
            $this->ord2->updateOrderInfo('ha'.$this->handler['id'], [
                'baseName' => 'Amo ('.trans('event.'.$this->ord2->event()).')',
                'value' => escape($e->getMessage()),
                'handler' => $this->handler['id'],
                'error' => 1
            ]);
        }

    }

}