<?php
namespace Shop\Usecase\Handler;

use Shop\Entity\Order;
use Shop\Exception\NotFoundException;

class DeletefileUsecase
{
    private $ord2;
    private $handler;

    public function __construct(Order $ord2, $handler = [])
    {
        $this->ord2 = $ord2;
        $this->handler = $handler;
    }

    public function run()
    {
        $files = $this->ord2->files();
        if (empty($files))
        {
            throw new NotFoundException('Not found');
        }

        if ($this->ord2->isErrorSendFiles())
        {
            $this->ord2->updateOrderInfo('ha'.$this->handler['id'], [
                'baseName' => deletefile,
                'value' => error2,
                'handler' => $this->handler['id'],
                'error' => 1
            ]);

            throw new NotFoundException('Not found');
        }

        foreach($files as $file)
        {
            unlink(FILES_S.'orders/'.$this->ord2->id().'/'.$file);
        }

        if (file_exists(FILES_S.'orders/'.$this->ord2->id()))
        {
            rmdir(FILES_S.'orders/'.$this->ord2->id());
        }

        $this->ord2->setFiles([]);
        $this->ord2->removeOrderInfo('ha'.$this->handler['id']);
    }

}