<?php

namespace Shop\Usecase\Handler;

use Shop\Entity\Order;
use Shop\Usecase\ProductCodesUsecase;

class PaidUsecase
{
    private $ord2;

    public function __construct(Order $ord2, $handler = [])
    {
        $this->ord2 = $ord2;
    }

    public function run()
    {
        $this->ord2->updateOrderInfo('payStatus', [
            'baseName' => $this->ord2->payment()->name(),
            'value' => orderPayd
        ]);

        if ($this->ord2->payment()->event() !== 'Success')
        {
            $this->ord2->customer()->partner()->saveCommission();
            $this->ord2->customer()->addSaleCount(1);

            if ($this->ord2->couponId())
            {
                $this->ord2->customer()->setCouponCounterIncrease('Paid');
            }

            $productCodes = new ProductCodesUsecase($this->ord2);
            $productCodes->run();
        }

        $this->ord2->payment()->setEvent('Success');

    }

}