<?php
namespace Shop\Usecase\Handler;

use Shop\Entity\Order;
use Shop\Exception\NotFoundException;

class PartnerUsecase
{
    private $ord2;
    private $handler;

    public function __construct(Order $ord2, $handler = [])
    {
        $this->ord2 = $ord2;
        $this->handler = $handler;
    }

    public function run()
    {
        if ($this->ord2->orderInfo('partnerCommissions1') ||
            $this->ord2->orderInfo('dis'.$this->handler['id']))
        {
            return;
        }

    	$partner = $this->ord2->customer()->partner();

        if (!$partner->id())
        {
            throw new NotFoundException('Not found');
        }

        $commission = 0;
        $commissionType = '';
        foreach($this->handler['settings']['sale'] as $key => $sales)
        {
            if ($sales <= $partner->saleCount())
            {
                $commission = $this->handler['settings']['number'][$key];
                $commissionType = $this->handler['settings']['type'][$key];
            }
            else break;
        }

        if (!empty($this->handler['settings']['discount']))
        {
            $this->ord2->addDiscount($this->handler['settings']['discount'], $this->handler['settings']['discountType']);

            $name = $this->handler['baseName'];
            if (empty($name))
            {
                $name = partner_settings;
            }
            $this->ord2->updateOrderInfo('dis'.$this->handler['id'], [
                'baseName' => discount.' ('.$name.')',
                'value' => floatval($this->handler['settings']['discount']).$this->handler['settings']['discountType']
            ]);
        }

        if (!$this->ord2->customer()->isPartner() && $commission)
        {
            $this->ord2->setCommission($commission, $commissionType);
        }
    }


}