<?php
namespace Shop\Usecase\Handler;

use Shop\Entity\Order;
use Shop\Repository\SqlOrderRepository;

class SaveUsecase
{
    private $ord2;

    public function __construct(Order $ord2, $handler = [])
    {
        $this->ord2 = $ord2;
    }

    public function run()
    {
        if ($this->ord2->operation())
        {
            return;
        }

        $oldId = $this->ord2->id();

        $repo = new SqlOrderRepository();
        $repo->insert($this->ord2);
        $this->ord2->setOperation('update');

        if (file_exists(FILES_S.'orders/'.$oldId) && $oldId != $this->ord2->id())
        {
            rename(FILES_S.'orders/'.$oldId, FILES_S.'orders/'.$this->ord2->id());
        }


    }


}