<?php
namespace Shop\Usecase\Handler;

use Shop\Entity\Order;
use Shop\Exception\NotFoundException;
use main;

class TimerUsecase
{
    private $ord2;
    private $handler;

    public function __construct(Order $ord2, $handler = [])
    {
        $this->ord2 = $ord2;
        $this->handler = $handler;
    }

    public function run()
    {
        if ($this->ord2->orderInfo('dis'.$this->handler['id']))
        {
            return;
        }

		if (empty($this->handler['timerId'])) {
            throw new NotFoundException('Not found');
        }

        $timer = main::mapper('block_core')->findById($this->handler['timerId']);

        if (empty($timer)) {
            throw new NotFoundException('Not found');
        }

        if($timer['settings']['ttype'] == 'timer')
        {
            $timerStart = $this->ord2->customer()->timer($timer['id']);
            if (!$timerStart || $timer['settings']['seconds'] <= time() - $timerStart)
            {
                throw new NotFoundException('Not found');
            }
        }
        elseif($timer['settings']['ttype'] == 'timerDate')
        {
            if ($timer['settings']['seconds'] - time() <= 0)
            {
                throw new NotFoundException('Not found');
            }
        }
        else
        {
            throw new NotFoundException('Not found');
        }

        if (empty($this->handler['settings']['commissions']))
        {
            throw new NotFoundException('Not found');
        }

        $this->ord2->addDiscount($this->handler['settings']['commissions'], $this->handler['settings']['commissionsType']);
        $this->ord2->updateOrderInfo('dis'.$this->handler['id'], [
            'baseName' => discount.' ('.timer_core.')',
            'value' => floatval($this->handler['settings']['commissions']).$this->handler['settings']['commissionsType']
        ]);

    }


}