<?php
namespace Shop\Usecase;

use Shop\Entity\Order;
use Shop\Usecase\RunEventUsecase;

class RunCustomEventUsecase
{
    private $ord2;
    private $orderEvent;

    public function __construct(Order $ord2)
    {
        $this->ord2 = $ord2;
        $this->orderEvent = new RunEventUsecase($ord2);
    }

    public function run($event)
    {
        if ($event == 'paid')
        {
            $this->ord2->payment()->setId(0);
            $this->ord2->payment()->setName(handToHand);
            $this->ord2->payment()->setSystem('');
            $this->ord2->payment()->setMethod('');
            $this->ord2->payment()->setCurrency('');
            $this->ord2->payment()->setStatus('on');
        }

        $this->orderEvent->run($event);
    }
}