<?php
namespace Shop\Usecase;

use Shop\Entity\Order;
use Shop\Usecase\RunEventUsecase;
use Shop\Repository\SqlOrderRepository;

class RunEventAndSaveOrderUsecase
{
    private $ord2;
    private $orderRepo;
    private $orderEvent;

    public function __construct(Order $ord2)
    {
        $this->ord2 = $ord2;
        $this->orderEvent = new RunEventUsecase($ord2);
        $this->orderRepo = new SqlOrderRepository();
    }

    public function run($event)
    {
        $this->orderEvent->run($event);
        $this->orderRepo->save($this->ord2);
    }

}