
class cpMobileMenu extends cpMenu {

    lastObj = null;
    isSetHide = 1;
    isShow;

    show(event) {

        if (event) {
            this.lastObj = event.currentTarget;
        }

        if (!this.menu) {
            this.render();
            this.menu = top.document.getElementById('cpMobileMenu');
            this.addListeners();
        }

        this.isShow = this.lastObj.id;

        removeClass(this.menu, "hide2");

        if (this.editor.nodes.length > 1) {
            this.settingsMultyElements();
        } else {
            this.settingsOneElements();
        }

        this.editor.contextMenu.hide();

        this.menu.style.left = 'calc(50% - ' + parseInt(this.menu.offsetWidth / 2) + 'px)';

    }

    deleteMenu = (event) => {

        this.editor.changeState(cpDeleteState).init(event);

    }

    uppCanvas = (event) => {
        this.editor.move.top(event);
    }

    downCanvas = (event) => {
        this.editor.move.bottom(event);
    }

    hideCommand = () => {

        this.editor.executeCommand(
            new cpHideCommand(this.editor, this.editor.nodes[0], this.isSetHide)
        );

    }

    copy = (event) => {

        this.editor.executeCommand(
            new cpCopyCommand(this.editor, event.pageY, event.pageX)
        );

    }

    render() {

        top.document.body.insertAdjacentHTML("beforeend", `

            <div id="cpMobileMenu" class="hide2">
                <a href="#" class="acmItem aedit" onclick="top.location=this.getAttribute('href');return false;">
                    <div id="settingCont" class="cmItem"></div>
                </a>
                <a href="#" class="acmItem alist" onclick="top.location=this.getAttribute('href');return false;">
                    <div id="menuListCont" class="cmItem"></div>
                </a>
                <a href="#" class="acmItem alist" onclick="top.location=this.getAttribute('href');return false;">
                    <div id="listCont" class="cmItem"></div>
                </a>
                <a href="#" class="acmItem afields" onclick="top.location=this.getAttribute('href');return false;">
                    <div id="listFields" class="cmItem"></div>
                </a>
                <a href="./?service=handler_core" class="acmItem ahandlers" onclick="top.location=this.getAttribute('href');return false;">
                    <div class="cmItem handlersCont"></div>
                </a>
                <a href="#" class="acmItem alink" onclick="top.location=this.getAttribute('href');return false;">
                    <div id="linkCont" class="cmItem"></div>
                </a>
                <a href="#" class="acmItem amenu" onclick="top.location=this.getAttribute('href');return false;">
                    <div id="menuCont" class="cmItem"></div>
                </a>
                <a href="#" class="acmItem aimage" onclick="top.location=this.getAttribute('href');return false;">
                    <div id="imageCont" class="cmItem"></div>
                </a>
                <a href="#" class="acmItem atext" onclick="top.location=this.getAttribute('href');return false;">
                    <div id="textCont" class="cmItem"></div>
                </a>
                <div class="cmItem hideCont">
                    <span class="cmsp"></span>
                </div>
                <div class="uppTool cmItem"></div>
                <div class="downTool cmItem"></div>
                <div id="copyCont" class="cmItem multyContext">
                    <span class="cmsp"></span>
                </div>
                <div class="cmItem multyContext delMobileCont">
                    <span class="cmsp"></span>
                </div>
            </div>
            <style>
              #cpMobileMenu {
                background-color:#0c1719;
                position:absolute;
                left:calc(50% - 125px);
                bottom:0;
              }
              #cpMobileMenu{z-index:6599;}
              #cpMobileMenu i{font-style: normal;}
              #cpMobileMenu b{font-weight: normal;}
              #cpMobileMenu .cmsp{margin: 0;}
              #cpMobileMenu .cmItem {
                height: 32px;
                min-width:34px;
                display:inline-block;
                border-left:0 !important;
              }
              .delMobileCont{background-position: 0 -1194px;}
            </style>
        `);

    }

    addListeners() {

        this.menu.querySelector("#copyCont").addEventListener("click", this.copy);
        this.menu.querySelector(".delMobileCont").addEventListener("click", this.deleteMenu);
        this.menu.querySelector(".uppTool").addEventListener("click", this.uppCanvas);
        this.menu.querySelector(".downTool").addEventListener("click", this.downCanvas);
        this.menu.querySelector(".hideCont").addEventListener("click", this.hideCommand);

    }

    settingsMultyElements() {

        let $mainMenu = $(this.menu);

        $mainMenu.find('.cmItem:not(.delMobileCont):not(#settingCont)').addClass('hide2');

        if (hasClass(this.lastObj, "cblockM")) $mainMenu.find('#copyCont').addClass('hide2');
        else $mainMenu.find('#copyCont').removeClass('hide2');

        let ids1 = [];
        for(let i = 0, length = this.editor.nodes.length; i < length; i++) {
            ids1.push(this.editor.nodes[i].id.substr(1));
        }

        $mainMenu.find('.aedit').attr("href", "./edit.php?id="+ this.editor.pageId +"&service=adaptive_core&action=edit&blockId=0&swidth="+top.cPointWidth+top.allPointWidth+"&ids="+ids1.join(',')+"&startStr="+(hasClass(this.lastObj, "virtuals") ? '9' : '1'));

    }

    settingsOneElements() {
        let $mainMenu = $(this.menu);

        this.isSetHide = 1;
        $mainMenu.find('.cmItem').removeClass("hide2");
        this.selId = this.lastObj.id.substr(1);

        $mainMenu.find('.aimage').attr("href", this.setHref('edit', 'image_gallery', true));
        $mainMenu.find('.atext').attr("href", this.setHref('edit', 'textC_core', true));
        $mainMenu.find('.alink').attr("href", this.setHref('edit', 'link_core', true));
        $mainMenu.find('.amenu').attr("href", this.setHref('edit', 'menu_core', true));
        $mainMenu.find('.aedit').attr("href", this.setHref('edit'));
        $mainMenu.find('.alist').attr("href", this.setHref('lists'));

        if (hasClass(this.lastObj, "gallContext"))
        {
            $mainMenu.find('.uppTool,.downTool,#linkCont,#menuCont,#menuListCont,#listFields,.handlersCont').addClass('hide2');
        }
        else if (hasClass(this.lastObj, "gallContext0"))
        {
            $mainMenu.find('.uppTool,.downTool,#linkCont,#menuCont,#menuListCont,#listFields,.handlersCont').addClass('hide2');
        }
        else if (hasClass(this.lastObj, "menuListContext"))
        {
            $mainMenu.find('.uppTool,.downTool,#textCont,#imageCont,#listCont,#listFields,.handlersCont').addClass('hide2');
        }
        else if (hasClass(this.lastObj, "menuContext"))
        {
            $mainMenu.find('.uppTool,.downTool,#textCont,#imageCont,#menuCont,#listCont,#listFields,.handlersCont').addClass('hide2');
        }
        else if (hasClass(this.lastObj, "virtuals"))
        {
            $mainMenu.find('#imageCont,#textCont,#linkCont,#menuCont,#menuListCont,#listFields,.handlersCont').addClass('hide2');

            let pgselectedDr = document.getElementById('pgc_'+this.selId), pgdisplay = pgselectedDr.style.display;
            if (pgdisplay) pgselectedDr.style.display = "";
            if (getComputedStyle(pgselectedDr).display === "none") this.isSetHide = 0;
            if (pgdisplay) pgselectedDr.style.display = pgdisplay;

        }
        else if (hasClass(this.lastObj, "drrr0"))
        {
            $mainMenu.find('.uppTool,.downTool,#imageCont,#textCont,#linkCont,#menuCont,#menuListCont,#listFields,.handlersCont').addClass('hide2');
        }
        else if (hasClass(this.lastObj, "formContext"))
        {
            let form = this.lastObj.querySelector('[form]'),
                formId = 0;

            if (form)
            {
                formId = form.getAttribute("form").substr(4);
            }

            $mainMenu.find('.ahandlers').attr("href", './?service=handler_core&formId=' + formId);
            $mainMenu.find('.afields').attr("href", "./edit.php?id="+ this.editor.pageId +"&service=form_forms&action=listsFields&formId="+formId+"&swidth="+top.cPointWidth+top.allPointWidth);

            $mainMenu.find('#uppdown,#imageCont,#textCont,#linkCont,#menuCont,#menuListCont,#listCont,#pasteCont').addClass('hide2');
        }
        else
        {
            $mainMenu.find('.uppTool,.downTool,#imageCont,#textCont,#linkCont,#menuCont,#menuListCont,#listCont,#listFields,.handlersCont').addClass('hide2');
        }

        if (!hasClass(this.lastObj, "virtuals")) {
            let pgdisplay = this.lastObj.style.display;
            if (pgdisplay) this.lastObj.style.display = "";
            if (getComputedStyle(this.lastObj).display === "none") this.isSetHide = 0;
            if (pgdisplay) this.lastObj.style.display = pgdisplay;
        }

        if (this.isSetHide === 0) {$mainMenu.find('.hideCont').addClass('shohide');}
        else {$mainMenu.find('.hideCont').removeClass('shohide');}

        if (hasClass(this.lastObj, "cblockM")) $mainMenu.find('#copyCont').addClass('hide2');

    }

}