
class cpCopyCommand {

    editor = {};
    topcop = 0;
    leftcop = 0;

    constructor(editor, topcop = 0, leftcop = 0) {

        this.editor = editor;

        if (!topcop && !leftcop) {

            this.topcop = window.innerHeight/2;
            this.leftcop = window.innerWidth/2;

        } else {

            let bounding = document.body.getBoundingClientRect(),
                           framerBounding = top.cpEditorFramer.getBoundingClientRect();

            this.topcop = topcop + framerBounding.top + bounding.top;
            this.leftcop = leftcop + framerBounding.left + bounding.left;

        }

    }

    execute() {

        if (!this.editor.nodes.length) {
            return;
        }

        let startStr = 1,
            copyListItem = top.document.querySelector(".cpToolbar__listItemCopy");

        if (hasClass(this.editor.nodes[0], "virtuals")) startStr = 9;
        else if (hasClass(this.editor.nodes[0], "cblockM")) return;

        this.render();

        copyListItem.hidden = false;
        if (!top.cpToolbar.classList.contains("cpToolbar--copy"))
        {
          top.cpToolbar.classList.add('cpToolbar--copy');
        }
        let copyAnDiv = top.document.querySelector(".copyAnDiv"),
            box = copyListItem.getBoundingClientRect(),
            time = 500;

        if (box.top - this.topcop > 500 || box.left - this.leftcop > 500) {
            time = 1000;
        }
        $(copyAnDiv).animate({
            top: (box.top + 8) + 'px',
            left: (box.left + 8) + 'px'
        },
        time,
        function() {
          copyAnDiv.parentNode.removeChild(copyAnDiv);
        });

        this.editor.contextMenu.hide();
        this.editor.mobileMenu.hide();

        let saveIndex = "&startStr="+startStr+"&clonePage=" + this.editor.pageId;

        for(let i=0, length = this.editor.nodes.length; i < length; i++) {

            let id = this.editor.nodes[i].id.substr(1);

            saveIndex += "&ids["+id+"]="+id;

            if (startStr != 1) continue;

            saveIndex += "&tops["+id+"]=" + this.editor.nodes[i].offsetTop;
            saveIndex += "&lefts["+id+"]=" + this.editor.nodes[i].offsetLeft;

        }

        copyIndexes=saveIndex;
        this.editor.changeState(cpCreateState).setDraggedBlock('cloneBlock_core');

        $.ajax({
                type: "POST",
                url: "./ajax.php?service=cloneBlock_core&action=saveIndex",
                data: copyIndexes
               });

    }

    render() {

        top.document.body.insertAdjacentHTML("beforeend", `
            <div class="copyAnDiv ui-state-focus2"
                 style="width:16px;
                        height:16px;
                        position:absolute;
                        z-index:7000;
                        top:${this.topcop}px;
                        left:${this.leftcop}px">
            </div>
        `);
    }

}