class cpRelativeMoveCommand
{
    editor;
    position;
    nodes = [];
    parentId;

    constructor(editor, position, nodes, parentId)
    {
        this.editor = editor;
        this.parentId = parentId;
        this.position = position;


        let list = document.querySelectorAll(".ui-selected");
        for(let i=0, length = list.length; i < length; i++)
        {
            if (nodes.includes(list[i]))
            {
                this.nodes.push(list[i]);
            }
        }
    }

    execute()
    {
        let length = this.nodes.length;
        if (!length) return;

        let parentNode = this.nodes[0].parentNode,
            div = document.createElement("div"),
            positionNode;

        div.style.display = 'none';

        if (this.position.insert === "last" || this.position.insert === "first")
        {
            if (this.position.insert === "last" && this.position.node.nextElementSibling)
            {
                this.position.node.parentNode.insertBefore(div, this.position.node.nextElementSibling);
            }
            else if (this.position.insert === "first")
            {
                this.position.node.parentNode.insertBefore(div, this.position.node);
            }
            else
            {
                this.position.node.parentNode.appendChild(div);
            }
            positionNode = div;
        }
        else if (this.parentId)
        {
            let parentDrop = document.getElementById('c_'+this.parentId);
            if (!parentDrop)
            {
                parentDrop = document.getElementById('b'+this.parentId);
            }
            if (parentDrop)
            {
                parentDrop.appendChild(div);
                positionNode = div;
            }
        }

        let saveIndex = "",
            parentSize = getSizes(getParentNode(this.nodes[0]));

        for(let i=0; i < length; i++)
        {
            if (positionNode)
            {
                positionNode.parentNode.insertBefore(this.nodes[i], positionNode);
            }

            let id = this.nodes[i].id.substr(1),
                cssChild = getComputedStyle(this.nodes[i]);

            saveIndex += "&ids["+id+"]=" + id;
            saveIndex += "&lefts["+id+"]=" + parseFloat(cssChild.left);
            saveIndex += "&tops["+id+"]=" + parseFloat(cssChild.top);
            saveIndex += "&rights["+id+"]=" + (parentSize.width - (parseFloat(cssChild.left) + parseFloat(cssChild.width)));
            saveIndex += "&bottoms["+id+"]=" + (parentSize.height - (parseFloat(cssChild.top) + parseFloat(cssChild.height)));
        }

        if (div && positionNode)
        {
            positionNode.parentNode.removeChild(div);
        }

        if (this.position.insert === "first")
        {
            saveIndex += "&sort="+this.position.node.id.substr(1);
        }
        else if (this.position.insert === "last")
        {
            let nextNode = this.position.findNextPosition();
            if (nextNode)
            {
                saveIndex += "&sort="+nextNode.id.substr(1);
            }
            else
            {
                saveIndex += "&sort=";
            }
        }
        else
        {
            saveIndex += "&sort=";
        }

        let that = this,
            selectedDr2 = this.nodes;

        this.position.line.hide();

        this.editor.layers.expandMap(parentNode.closest(".blockM,.dCnt2"));
        this.editor.layers.expandMap(this.nodes[0].parentNode.closest(".blockM,.dCnt2"));
        this.editor.layers.scroll(this.nodes[0]);

        $.ajax({
            type: "POST",
            url:"./actions.php?bmove=1&parentId="+that.parentId,
            data: saveIndex+"&swidth="+top.cPointWidth+top.allPointWidth,
            success: function (data)
            {
              if (data)
              {
                for(let i=0, length = selectedDr2.length; i < length; i++)
                {
                    let node = document.getElementById("media"+selectedDr2[i].id);
                    if (node) node.remove();
                }

                document.head.insertAdjacentHTML("beforeend", data);
                that.editor.xyPan.refresh();
              }
            }
        });
    }
}