
class cpCanvasMove extends cpElementsMove {

    top(event) {

      let el = this.editor.nodes[0].closest(".pgdiv"),
          allCanvas = $(el).prevAll(".pgdiv"),
          prevCanvas = null;
      allCanvas.each((i, value) => {
          if (getComputedStyle(value).display === 'none') return;
          prevCanvas = value.id.substr(4);
          this.animatedMove(el, value, 2);
          cpListener();
          this.editor.layers.cplayers__list.insertBefore(this.editor.layers.cplayers__list.querySelector(".v"+el.id.substr(4)), this.editor.layers.cplayers__list.querySelector(".v"+prevCanvas));
          return false;
      });

      $.ajax({url:"./ajax.php?id="+ this.editor.pageId +"&service=content_core&action=move&blockId="+el.id.substr(4)+"&prevCanvas="+prevCanvas});

      this.refresh(event);

    }

    left(event) {
        this.top(event);
    }

    right(event) {
        this.bottom(event);
    }

    bottom(event) {

      let el = this.editor.nodes[0].closest(".pgdiv");
      let allCanvas = $(el).nextAll(".pgdiv"), nextCanvas = null;
      allCanvas.each((i, value) => {
          if (getComputedStyle(value).display === 'none') return;
          nextCanvas = value.id.substr(4);
          this.animatedMove(el, value, 1);
          cpListener();
          this.editor.layers.cplayers__list.insertBefore(this.editor.layers.cplayers__list.querySelector(".v"+el.id.substr(4)), this.editor.layers.cplayers__list.querySelector(".v"+nextCanvas).nextElementSibling);
          return false;
      });

      $.ajax({url:"./ajax.php?id="+ this.editor.pageId +"&service=content_core&action=move&blockId="+el.id.substr(4)+"&nextCanvas="+nextCanvas});

      this.refresh(event);

    }

    dragEnd = () => {
      this.save();
    }

    animatedMove(fstElem, scdElem, dirflag) {
      let fstdir, scddir;
      if (dirflag === 2) {
        fstdir = '-';
        scddir = '';
      } else if (dirflag === 1) {
        fstdir = '';
        scddir = '-';
      }
      setCss(fstElem, {
        transform: 'translateY(' + fstdir + scdElem.offsetHeight + 'px)',
        transition: 'transform 0.4s'
      })
      setCss(scdElem, {
        transform: 'translateY(' + scddir + fstElem.offsetHeight + 'px)',
        transition: 'transform 0.4s'
      })
      setTimeout(function() {
        setCss(fstElem, {transform: 'none', transition: 'unset'});
        setCss(scdElem, {transform: 'none', transition: 'unset'});
        if (dirflag === 2) {
          $(fstElem).after($(scdElem));
        } else if (dirflag === 1) {
          $(fstElem).before($(scdElem));
        }
      }, 500);
    }

}
