class cpElementsMove extends cpMove {

    nodes = [];
    length = 0;
    initObj;

    static snapDrag = '';

    constructor(editor, initObj, nodes) {

        super(editor);

        this.nodes = nodes;
        this.length = nodes.length;
        this.initObj = initObj;

    }

    saveIfTime() {

        if (this.autoSaveTime && Date.now() - this.autoSaveTime > 800) {
            return this.save();
        }

        if (this.autoSaveTime) return false;
        return true;

    }

    finish() {

        if (this.autoSaveTime) this.save();
        else super.save();

    }

    static dragInit(editor, obj) {

        if (!obj) return;

        editor.executeCommand(
            new cpSelectOneCommand(editor, obj)
        );

        cpElementsMove.strategy(editor, obj);

        $(".ui-draggable").draggable("destroy");

        $(obj).draggable({
          snap: cpElementsMove.snapDrag,
          snapTolerance: 10,
          scroll: true,
          helper: function(){
            return $("<div></div>");
          },
          start: editor.move.dragStart,
          drag: editor.move.drag,
          stop: editor.move.dragEnd
        });

        top.cpEditorIframe.focus();

    }

    static strategy(editor, initObj = null) {

        if (!initObj) {
            if (editor.nodes[0]) initObj = editor.nodes[0];
            else return;
        }

        let type = 'relative',
            relNodes = [],
            absNodes = [],
            conNodes = [];

        cpElementsMove.snapDrag = "";
        if (hasClass(initObj, 'virtuals')) {
            type = 'canvas';
        } else if (getComputedStyle(initObj).position === 'absolute') {
            type = 'absolute';
            cpElementsMove.snapDragStart(editor, initObj);
        }

        for(let i=0, length = editor.nodes.length; i < length; i++) {
            let obj = editor.nodes[i];

            if (hasClass(obj, 'virtuals')) {
                conNodes.push(obj);
            } else if (getComputedStyle(obj).position === 'absolute') {
                absNodes.push(obj);
            } else {
                relNodes.push(obj);
            }

        }

        if (type === 'absolute') {
            return editor.move = new cpAbsoluteMove(editor, initObj, absNodes);
        } else if (type === 'relative') {
            return editor.move = new cpRelativeMove(editor, initObj, relNodes);
        } else if (type === 'canvas') {
            return editor.move = new cpCanvasMove(editor, initObj, conNodes);
        }

        return;

    }

    static snapDragStart(editor, obj) {
        obj = obj.parentNode;
        if (obj)
        {
            cpElementsMove.snapDrag = "#"+obj.id+", #"+obj.id+" > .blockM:not(.ui-selected), #"+obj.id+" > .cblockM:not(.ui-selected)";
            if (editor.rulers.isShow) {
                cpElementsMove.snapDrag += ",.cpRulersLine";
            }
            if (editor.grid.isShow) {
                cpElementsMove.snapDrag += ",.cpGrid__line";
            }
        }
    }

}
