<style>
.cpPages
{
  z-index:10;
  position: absolute;
  min-width: 250px;
  max-width: 300px;
  max-height: 400px;
  box-sizing: border-box;
  top: 50px;
  left: 75px;
  background-color: #1e1e1e;
  border: 1px solid #323233;
  border-top: 0;
  box-shadow: 0 0 10px 0 rgba(0,0,0,0.3);
  padding: 7px 0 8px 0;
  overflow-y:auto;
  overflow-x:hidden;
  scrollbar-color: #505050 transparent;
  scrollbar-width:thin;
}
.cpPages::-webkit-scrollbar
{
  width:6px;
  background: transparent;
}
.cpPages::-webkit-scrollbar-corner
{
  background: transparent;
}
.cpPages::-webkit-scrollbar-thumb
{
  background: #505050;
}
.cpPages [hidden]
{
  display: none;
}
.pages__domain, .pages__item
{
  position: relative;
}
.pages__domain
{
    display: flex;
    align-items: center;
}
.pages__domain, .pages__link, .pages__template
{
    padding: 0 10px 0 15px;
}
.pages__link, .pages__domainLink, .pages__template
{
    overflow: hidden;
    text-overflow: ellipsis;
    min-width:100%;
    box-sizing: border-box;
    height: 30px;
    fill:#ccc;
    letter-spacing: normal;
    white-space: nowrap;
    font: 14px/30px Arial, "Helvetica CY", "Nimbus Sans L", sans-serif;
    box-sizing: border-box;
    display:block;
    width:100%;
    color: #ccc;
}
.pages__link, .pages__link:link, .pages__link:visited,
.pages__domainLink, .pages__domainLink:link, .pages__domainLink:visited
{
  text-decoration: none;
  color: #ccc;
}
.pages__domain:hover, .pages__domain:focus,
.pages__item:hover, .pages__item:focus,
.pages__template:hover, .pages__template:focus
{
    background-color: #2a2d2e;
}
.pages__settings
{
    opacity: 0;
    display: block;
    width: 24px;
    height: 22px;
    user-select: none;
    position: absolute;
    right: 2px;
    top: 5px;
    background: url("<?= BASE_DIR?>/skinss/image/icons.png");
    background-size: auto;
    background-repeat: no-repeat;
    background-position: -4px -1029px;
}
.pages__domainIcon
{
    width:12px;
    height:12px;
    background-color:#424242;
    margin-right:8px;
    display: inline-block;
}
.pages__settings:focus,
.pages__domain:hover .pages__settings,
.pages__item:hover .pages__settings
{
    opacity:1;
}
</style>
<div class="cpPages" hidden><?php
    $map = main::mapper('page_core')->siteSystemMap(1);
    foreach($map['domains'] as $domainId => $val)
    {
        print '<div class="pages__domain">';
        if ($val['fileName']) {?>
            <img src="<?= FILES_W?>page/<?= $val['fileName']?>" height="12" alt="" style="vertical-align:baseline;margin-right:8px;">
        <?php } else {
            print '<div class="pages__domainIcon"></div>';
        }
        print '<a class="pages__domainLink saveAll2" href="'.ADMIN_DIR.'?service=domain_core&amp;action=edit&amp;domainId='.$domainId.'">'.$val['name'].'</a>'.
              '<a class="pages__settings saveAll2" href="'.ADMIN_DIR.'?service=domain_core&amp;action=edit&amp;domainId='.$domainId.'" title="'.escapeMeta(main_settings).'" aria-label="'.escapeMeta(main_settings.' '.$val['name']).'"></a>';
        print '</div>';
        print implode('', createLeftMap($val, 0, 35));
    }
    if (!empty($map['templates']))
    {
        print '<div class="pages__template"><div class="pages__domainIcon"></div>'.
                templatess.
              '</div>';
        foreach($map['templates'] AS $item)
        {
            print '<div class="pages__item" title="'.escapeMeta($item['baseName']).'">'.
                '<a class="pages__link saveAll2" href="'.ADMIN_DIR.'editor.php?id='.$item['id'].'" style="padding-left:35px">'. $item['baseName'].'</a>'.
                '<a class="pages__settings saveAll2" href="'.ADMIN_DIR.'?service=page_core&amp;action=edit&amp;isTemplate=1&amp;domainId='.$item['domainId'].'&amp;id='.$item['id'].'" title="'.escapeMeta(main_settings).'" aria-label="'.escapeMeta(main_settings).'"></a>'.
            '</div>';
        }
        print implode('', createLeftMap($map['templates'], 0, 35));
    }
    ?>
</div>
<script>
    var cpPages = document.querySelector(".cpPages");
</script>
<?php
function createLeftMap($list, $curent, $padd = 0)
{
    $return = array();
    if (empty($list['pages'][$curent])) return array();
    foreach($list['pages'][$curent] AS $item)
    {
        $return[] = '<div class="pages__item" title="'.escapeMeta($item['baseName']).'">'.
            '<a class="pages__link" href="'.ADMIN_DIR.'editor.php?id='.$item['id'].'"'.($padd ? ' style="padding-left:'.$padd.'px"' : '').'>'. $item['baseName'] .'</a>'.
            '<a class="pages__settings saveAll2" href="'.ADMIN_DIR.'?service=page_core&amp;action=edit&amp;domainId='.$item['domainId'].'&amp;id='.$item['id'].'" title="'.escapeMeta(main_settings).'" aria-label="'.escapeMeta(main_settings.' '.$item['baseName']).'"></a>'.
        '</div>';
        if (isset($list['pages'][$item['id']]))
        {
            $return = array_merge($return, createLeftMap($list, $item['id'], $padd + 20));
        }
    }
    return $return;
}
?>
