
class cpSelectState extends cpState {

    constructor(editor) {

        super(editor);

        editor.toolbar.setState('cpSelectState');

        $(".ui-resizable").resizable("destroy");

        editor.contextMenu.hide();
        editor.mobileMenu.hide();
        canvasSelectable();
        selectable2();

        top.selectState = 1;

        document.addEventListener('visibilitychange', this.visibilitychange, false);

    }

    click(event) {

        event.preventDefault();
        event.stopPropagation();

        let selectType = event.ctrlKey || event.metaKey ? 'selectUp' : '';

        this.editor.executeCommand(
            new cpSelectPlusMinusCommand(this.editor, event.currentTarget, 'scroll', selectType)
        );

    }

    keydown(event) {

        //shift || ctrl || metaKey
        if (event.which == 16 || event.which == 17 || event.which == 91) {
            return;
        }

        super.keydown(event);

    }

    keyup(event) {

        //shift || ctrl || metaKey
        if (event.which == 16 || event.which == 17 || event.which == 91) {
            this.editor.changeState(cpEditState);
            return;
        }

        super.keyup(event);

    }

    finish() {

        document.removeEventListener('visibilitychange', this.visibilitychange, false);
        selectableDestroy(this.editor);
        top.selectState = 0;

    }

    visibilitychange = () => {
        this.editor.changeState(cpEditState);
    }

    selectLayers = (event) =>
    {
        this.editor.layers.multySelect(event);
    }
}