<?php
session_start();
define('ROOT_PATH', dirname(__DIR__) . DIRECTORY_SEPARATOR);
require ROOT_PATH.'vendor/autoload.php';

if (substr($_SERVER['HTTP_HOST'], 0, 4) === 'www.')
{
    $_SERVER['HTTP_HOST'] = substr($_SERVER['HTTP_HOST'], 4);
}
$host = explode(':',$_SERVER['HTTP_HOST']);
$_SERVER['HTTP_HOST'] = $host[0];
define('DOMAIN', $host[0]);

$connection = Common\Lib\DB::connection();

$data = main::mapper('page_core')->findById($_REQUEST['id']);
if (empty($data))
{
    $connection->close();
    exit;
}
$_REQUEST['path'] = $data['path'];
$domain = main::mapper('domain_core')->findById($data['domainId']);
if (!empty($domain['datas']['fontFams'])) $GLOBALS['fontFamily'] = array_merge($domain['datas']['fontFams'],$GLOBALS['fontFamily']);
login();

$detect = new MobileDetect;
define('isMobile', $detect->isMobile());
define('isTablet', $detect->isTablet());
define('isSkipVideoBG', (isMobile && ($detect->isOpera() || strpos($detect->getUserAgent(), 'MiuiBrowser'))));
define('isSafari', $detect->isSafari());

if ($data['langId'] == DEFAULT_LANG_ID) {
    define('CUR_LANG_ID', DEFAULT_LANG_ID);
    define('CUR_LANG', DEFAULT_LANG);
} elseif ($lang = getLangById($data['langId'])) {
    define('CUR_LANG_ID', $data['langId']);
    define('CUR_LANG', $lang);
} else {
    define('CUR_LANG_ID', DEFAULT_LANG_ID);
    define('CUR_LANG', DEFAULT_LANG);
}
if (!main::$user['id']) main::$user['langId'] = CUR_LANG_ID;
if (file_exists(ROOT_PATH.'constants/'.CUR_LANG.'.php')) include(ROOT_PATH.'constants/'.CUR_LANG.'.php');
else include(ROOT_PATH.'constants/en.php');

$controller = new Shop\Controller\FormController();
$controller->submit();
$connection->close();